/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern0 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != UNSPEC_VOLATILE
      || XVECLEN (x4, 0) != 2
      || XINT (x4, 1) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  return 0;
}

int
pattern11 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern10 (x1, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern10 (x1, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V8HFmode:
      if (pattern10 (x1, 
E_V4HFmode, 
E_V8HFmode) != 0)
        return -1;
      return 2;

    case E_V8BFmode:
      if (pattern10 (x1, 
E_V4BFmode, 
E_V8BFmode) != 0)
        return -1;
      return 3;

    case E_V4SImode:
      if (pattern10 (x1, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern10 (x1, 
E_V2SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern10 (x1, 
E_DImode, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 100
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x2, 0);
  operands[0] = x8;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x9 = XEXP (x3, 0);
  operands[1] = x9;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x10 = XEXP (x3, 1);
  operands[2] = x10;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x11 = XEXP (x4, 0);
  operands[3] = x11;
  if (!scratch_operand (operands[3], E_DImode))
    return -1;
  x12 = XEXP (x5, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return 0;
}

int
pattern40 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern44 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i2))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[2]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[2], E_V16QImode)
          || !s_register_operand (operands[3], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !s_register_operand (operands[3], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !s_register_operand (operands[3], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern74 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !s_register_operand (operands[2], E_V16QImode)
          || !mve_imm_7 (operands[3], E_SImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_15 (operands[3], E_SImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !s_register_operand (operands[2], E_V4SImode)
          || !mve_imm_31 (operands[3], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern92 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  return 0;
}

int
pattern103 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      if (!s_register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 1;

    case E_V2SImode:
      if (!s_register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V4HImode))
        return -1;
      return 2;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 3;

    case E_DImode:
      if (!s_register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_V2SImode))
        return -1;
      return 4;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[1]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern131 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern146 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern41 (x3, 
E_V4HFmode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 3;

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0)
        return -1;
      return 4;

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern156 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V16QImode:
      return 0;

    case E_V8HImode:
      return 1;

    case E_V8HFmode:
      return 2;

    case E_V8BFmode:
      return 3;

    case E_V4SImode:
      return 4;

    case E_V4SFmode:
      return 5;

    case E_V2DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern165 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4x16QImode:
      return 0;

    case E_V4x8HImode:
      return 1;

    case E_V4x4SImode:
      return 2;

    case E_V4x8HFmode:
      return 3;

    case E_V4x4SFmode:
      return 4;

    default:
      return -1;
    }
}

int
pattern177 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return pattern115 (x3); /* [-1, 2] */
}

int
pattern182 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      return pattern40 (x3, 
E_HFmode, 
E_V8HFmode); /* [-1, 0] */

    case E_V4SFmode:
      if (pattern40 (x3, 
E_SFmode, 
E_V4SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      return pattern38 (x3, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern38 (x3, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern200 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern207 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !s_register_operand (operands[2], E_V8HImode)
          || !mve_imm_16 (operands[3], E_SImode)
          || !vpr_register_operand (operands[4], E_V8BImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern206 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern223 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i3)
      || GET_MODE (x1) != i3
      || !s_register_operand (operands[1], i3)
      || !s_register_operand (operands[2], i2)
      || !vpr_register_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern228 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern216 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern216 (x3, 
E_V4BImode, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
    return -1;
  x8 = XVECEXP (x3, 0, 4);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  x9 = XVECEXP (x3, 0, 5);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
    return -1;
  x10 = XVECEXP (x3, 0, 6);
  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
    return -1;
  x11 = XVECEXP (x3, 0, 7);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x12 = XEXP (x1, 1);
  x13 = XEXP (x12, 1);
  if (XVECLEN (x13, 0) != 8)
    return -1;
  x14 = XVECEXP (x13, 0, 0);
  if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
    return -1;
  x15 = XVECEXP (x13, 0, 1);
  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 9])
    return -1;
  x16 = XVECEXP (x13, 0, 2);
  if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 10])
    return -1;
  x17 = XVECEXP (x13, 0, 3);
  if (x17 != const_int_rtx[MAX_SAVED_CONST_INT + 11])
    return -1;
  x18 = XVECEXP (x13, 0, 4);
  if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
    return -1;
  x19 = XVECEXP (x13, 0, 5);
  if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 13])
    return -1;
  x20 = XVECEXP (x13, 0, 6);
  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 14])
    return -1;
  x21 = XVECEXP (x13, 0, 7);
  if (x21 != const_int_rtx[MAX_SAVED_CONST_INT + 15]
      || pattern237 (x1, 
E_V8QImode, 
E_V16QImode) != 0)
    return -1;
  return 0;
}

int
pattern259 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!cc_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!mem_noofs_operand (operands[2], E_QImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_QImode
          || !s_register_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!mem_noofs_operand (operands[2], E_HImode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_HImode
          || !s_register_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern266 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MULT
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
    return -1;
  return 0;
}

int
pattern272 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern277 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !reg_or_zero_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern281 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern286 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC_VOLATILE
      || XVECLEN (x3, 0) != 3
      || XINT (x3, 1) != 19)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 100
      || GET_MODE (x5) != E_CCmode)
    return -1;
  return pattern21 (x1); /* [-1, 3] */
}

int
pattern293 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  return pattern292 (x1); /* [-1, 3] */
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != 100
      || GET_MODE (x2) != E_CCmode)
    return -1;
  return 0;
}

int
pattern302 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V2SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_V4HImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x4 = XEXP (x2, 2);
  if (GET_CODE (x4) != CONST_INT)
    return -1;
  x5 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x5) != ZERO_EXTRACT
      || GET_MODE (x5) != E_V4HImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x7 = XEXP (x5, 2);
  if (GET_CODE (x7) != CONST_INT)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x8) != ZERO_EXTRACT
      || GET_MODE (x8) != E_V4HImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x10 = XEXP (x8, 2);
  if (GET_CODE (x10) != CONST_INT)
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x11) != ZERO_EXTRACT
      || GET_MODE (x11) != E_V4HImode)
    return -1;
  x12 = XEXP (x11, 1);
  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
    return -1;
  x13 = XEXP (x11, 2);
  if (GET_CODE (x13) != CONST_INT
      || !register_operand (operands[0], E_V2SImode)
      || !register_operand (operands[1], E_V2SImode))
    return -1;
  x14 = XEXP (x2, 0);
  operands[2] = x14;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x15 = XEXP (x8, 0);
  operands[3] = x15;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x16 = XEXP (x5, 0);
  if (!rtx_equal_p (x16, operands[2]))
    return -1;
  x17 = XEXP (x11, 0);
  if (!rtx_equal_p (x17, operands[3]))
    return -1;
  switch (XWINT (x4, 0))
    {
    case 0LL:
      if (XWINT (x7, 0) != 32LL)
        return -1;
      switch (XWINT (x10, 0))
        {
        case 0LL:
          if (XWINT (x13, 0) != 32LL)
            return -1;
          return 0;

        case 16LL:
          if (XWINT (x13, 0) != 48LL)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 16LL:
      if (XWINT (x7, 0) != 48LL)
        return -1;
      switch (XWINT (x10, 0))
        {
        case 0LL:
          if (XWINT (x13, 0) != 32LL)
            return -1;
          return 2;

        case 16LL:
          if (XWINT (x13, 0) != 48LL)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern334 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  return 0;
}

int
pattern339 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 4
      || XINT (x3, 1) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[2] = x7;
  x8 = XVECEXP (x6, 0, 1);
  operands[3] = x8;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[4] = x9;
  if (!mve_imm_32 (operands[4], E_SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[5] = x10;
  x11 = XEXP (x2, 0);
  operands[1] = x11;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x12 = XVECEXP (x3, 0, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XVECEXP (x3, 0, 1);
  if (!rtx_equal_p (x13, operands[3]))
    return -1;
  x14 = XVECEXP (x3, 0, 2);
  if (!rtx_equal_p (x14, operands[4]))
    return -1;
  x15 = XVECEXP (x3, 0, 3);
  if (!rtx_equal_p (x15, operands[5]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern338 (x6, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern338 (x6, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern338 (x6, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern360 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!nonimmediate_operand (operands[1], i2))
    return -1;
  x4 = XEXP (x1, 1);
  operands[3] = x4;
  if (!s_register_operand (operands[3], i1))
    return -1;
  x5 = XEXP (x1, 2);
  operands[2] = x5;
  return 0;
}

int
pattern370 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !mve_memory_operand (operands[1], i2)
      || !vpr_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern376 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode
      || !s_register_operand (operands[1], E_SImode)
      || !reg_or_int_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern381 (rtx x1, machine_mode i1, rtx_code i2, rtx_code i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i4)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i2
      || GET_MODE (x3) != i1)
    return -1;
  return 0;
}

int
pattern386 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern400 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i1)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern407 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (!shift_nomul_operator (operands[2], E_SImode))
    return -1;
  x2 = XEXP (x1, 0);
  operands[5] = x2;
  x3 = XEXP (x2, 0);
  operands[6] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[4] = x8;
  if (!shift_amount_operand (operands[4], E_SImode))
    return -1;
  x9 = XEXP (x5, 1);
  operands[1] = x9;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern416 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern425 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || pattern307 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern430 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!mve_memory_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[1], i3)
      || !vpr_register_operand (operands[2], i2))
    return -1;
  return 0;
}

int
pattern438 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != MULT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern446 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[2] = x6;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern454 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != SIGN_EXTEND
      || GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_MODE (x5) != E_CC_Vmode
      || GET_MODE (x2) != E_CC_Vmode)
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  return 0;
}

int
pattern463 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HFmode:
      return pattern462 (x1, 
E_V4HFmode); /* [-1, 0] */

    case E_V8HFmode:
      if (GET_MODE (x1) != E_V8HFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V8HFmode)
        return -1;
      return 1;

    case E_V2SFmode:
      if (pattern462 (x1, 
E_V2SFmode) != 0)
        return -1;
      return 2;

    case E_V4SFmode:
      if (GET_MODE (x1) != E_V4SFmode)
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_V4SFmode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern478 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  return pattern318 (x4, 
i1, 
i2); /* [-1, 0] */
}

int
pattern484 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2))
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern493 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != COND_EXEC)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != NE)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 100
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != COND_EXEC)
    return -1;
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != EQ)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != E_CCmode)
    return -1;
  x11 = XEXP (x9, 1);
  if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x12 = XEXP (x8, 1);
  if (GET_CODE (x12) != SET)
    return -1;
  x13 = XEXP (x12, 1);
  if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x14 = XEXP (x12, 0);
  if (!rtx_equal_p (x14, operands[0]))
    return -1;
  return 0;
}

int
pattern515 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !s_register_operand (operands[3], i2)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern522 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_DImode
      || !arm_low_register_operand (operands[0], E_DImode)
      || !arm_low_register_operand (operands[1], E_DImode)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern531 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XVECEXP (x9, 0, 2);
  operands[3] = x10;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x11 = XVECEXP (x1, 0, 3);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  if (!scratch_operand (operands[4], E_SImode))
    return -1;
  return pattern530 (x1); /* [-1, 3] */
}

int
pattern542 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern548 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case SET:
      x2 = XEXP (x1, 1);
      if (GET_CODE (x2) != i1
          || GET_MODE (x2) != E_SImode)
        return -1;
      return 0;

    case CLOBBER:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!scratch_operand (operands[0], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern557 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern563 (rtx x1, rtx_code i1, machine_mode i2, rtx_code i3, rtx_code i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i4
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i3
      || GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_DImode)
    return -1;
  return 0;
}

int
pattern573 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != MEM
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != PLUS
      || GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  return 0;
}

int
pattern579 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case PLUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 0;

    case MINUS:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 1;

    case IOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 2;

    case XOR:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 3;

    case AND:
      x2 = XEXP (x1, 1);
      operands[2] = x2;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x3 = XEXP (x1, 0);
      if (!rtx_equal_p (x3, operands[1]))
        return -1;
      return 4;

    case NOT:
      x3 = XEXP (x1, 0);
      if (GET_CODE (x3) != AND
          || GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XEXP (x3, 1);
      operands[2] = x4;
      if (!reg_or_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 0);
      if (!rtx_equal_p (x5, operands[1]))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern608 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[2], i1)
      || !vpr_register_operand (operands[4], i2)
      || !s_register_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern614 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x5, 1);
  if (!rtx_equal_p (x7, operands[2]))
    return -1;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 1);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x9, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  return 0;
}

int
pattern624 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[2] = x4;
  if (!register_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x2, 1);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!register_operand (operands[3], E_SImode))
    return -1;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern635 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case PLUS:
      if (GET_MODE (x4) != E_SImode)
        return -1;
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x6 = XVECEXP (x1, 0, 2);
      x7 = XEXP (x6, 0);
      x8 = XEXP (x7, 0);
      x9 = XEXP (x8, 1);
      if (XWINT (x9, 0) != 8LL)
        return -1;
      x10 = XVECEXP (x1, 0, 3);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      x13 = XEXP (x12, 1);
      if (XWINT (x13, 0) != 12LL)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern646 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

int
pattern650 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  if (!register_operand (operands[3], E_V4HImode))
    return -1;
  x9 = XEXP (x1, 1);
  x10 = XEXP (x9, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[2]))
    return -1;
  x13 = XEXP (x9, 1);
  x14 = XEXP (x13, 0);
  x15 = XEXP (x14, 0);
  if (!rtx_equal_p (x15, operands[3]))
    return -1;
  x16 = XEXP (x4, 1);
  x17 = XVECEXP (x16, 0, 0);
  switch (XWINT (x17, 0))
    {
    case 0LL:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 2LL)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2LL)
            return -1;
          return 0;

        case 1LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3LL)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 1LL:
      x18 = XEXP (x11, 1);
      x19 = XVECEXP (x18, 0, 0);
      if (XWINT (x19, 0) != 3LL)
        return -1;
      x20 = XEXP (x7, 1);
      x21 = XVECEXP (x20, 0, 0);
      switch (XWINT (x21, 0))
        {
        case 0LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 2LL)
            return -1;
          return 2;

        case 1LL:
          x22 = XEXP (x14, 1);
          x23 = XVECEXP (x22, 0, 0);
          if (XWINT (x23, 0) != 3LL)
            return -1;
          return 3;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (pattern289 (x2, 
E_CC_NZmode) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != XOR
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != E_CC_NZmode)
    return -1;
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!arm_rhs_operand (operands[2], E_SImode))
    return -1;
  x9 = XEXP (x3, 0);
  operands[0] = x9;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x10 = XEXP (x4, 0);
  if (!rtx_equal_p (x10, operands[1]))
    return -1;
  x11 = XEXP (x4, 1);
  if (!rtx_equal_p (x11, operands[2])
      || !
#line 3871 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
    return -1;
  return 114; /* *xorsi3_compare0 */
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_SImode)
    return -1;
  switch (GET_CODE (x5))
    {
    case NE:
      x6 = XEXP (x5, 0);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x6) != E_SImode)
            return -1;
          x7 = XEXP (x6, 2);
          if (GET_CODE (x7) != CONST_INT)
            return -1;
          operands[3] = x7;
          if (const_int_operand (operands[3], E_SImode)
              && pattern527 (x1) == 0
              && 
#line 3116 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
            return 94; /* *ne_zeroextractsi */
          if (XWINT (x7, 0) != 0LL
              || pattern527 (x1) != 0
              || !
#line 3154 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 95; /* *ne_zeroextractsi_shifted */

        case REG:
        case SUBREG:
          operands[1] = x6;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x8 = XEXP (x2, 0);
          operands[2] = x8;
          if (!s_register_operand (operands[2], E_SImode)
              || !
#line 1769 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 986; /* *cstoresi_ne0_thumb1_insn */

        default:
          return -1;
        }

    case EQ:
      x6 = XEXP (x5, 0);
      operands[1] = x6;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x8 = XEXP (x2, 0);
      operands[2] = x8;
      if (!s_register_operand (operands[2], E_SImode)
          || !
#line 1756 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
        return -1;
      return 985; /* *cstoresi_eq0_thumb1_insn */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[6] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  x7 = XEXP (x4, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x8 = XEXP (x4, 1);
  operands[3] = x8;
  if (!arm_add_operand (operands[3], E_SImode))
    return -1;
  x9 = XEXP (x3, 2);
  operands[1] = x9;
  if (!arm_rhs_operand (operands[1], E_SImode)
      || !
#line 10874 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
    return -1;
  return 352; /* *ifcompare_plus_move */
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[2] = x6;
      if (ldrd_strd_offset_operand (operands[2], E_SImode))
        {
          res = recog_21 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (XWINT (x6, 0) != -4LL)
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode
          || !s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x11 = XEXP (x8, 0);
      if (!rtx_equal_p (x11, operands[1])
          || !
#line 12751 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], -4, false, true))))
        return -1;
      return 425; /* *thumb2_ldrd_base_neg */

    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!s_register_operand (operands[1], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != SET)
        return -1;
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return -1;
      x11 = XEXP (x8, 0);
      if (GET_CODE (x11) != PLUS
          || GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 1);
      if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
          || !s_register_operand (operands[0], E_SImode))
        return -1;
      x10 = XEXP (x7, 0);
      operands[2] = x10;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x11, 0);
      if (!rtx_equal_p (x13, operands[1])
          || !
#line 12738 "../../gcc/config/arm/arm.md"
(TARGET_LDRD && TARGET_THUMB2 && reload_completed
     && (operands_ok_ldrd_strd (operands[0], operands[2],
                                  operands[1], 0, false, true))))
        return -1;
      return 424; /* *thumb2_ldrd_base */

    case UNSPEC:
      if (XVECLEN (x5, 0) != 3
          || XINT (x5, 1) != 2
          || GET_MODE (x5) != E_SImode)
        return -1;
      x14 = XVECEXP (x5, 0, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
        return -1;
      x7 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x7) != CLOBBER
          || !register_operand (operands[0], E_SImode))
        return -1;
      x15 = XVECEXP (x5, 0, 0);
      operands[2] = x15;
      if (!register_operand (operands[2], E_SImode))
        return -1;
      x16 = XVECEXP (x5, 0, 2);
      operands[3] = x16;
      x10 = XEXP (x7, 0);
      operands[1] = x10;
      if (!scratch_operand (operands[1], E_SImode)
          || !
#line 274 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
        return -1;
      return 1015; /* tls_load_dot_plus_four */

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC_VOLATILE
      || XVECLEN (x6, 0) != 1)
    return -1;
  x7 = XEXP (x2, 0);
  operands[0] = x7;
  if (!s_register_operand (operands[0], E_SImode)
      || GET_MODE (x3) != E_SImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  x9 = XVECEXP (x6, 0, 0);
  operands[2] = x9;
  switch (XINT (x3, 1))
    {
    case 22:
      if (XINT (x6, 1) != 22)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!mem_noofs_operand (operands[1], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !s_register_operand (operands[2], E_QImode)
              || !
#line 557 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3173; /* arm_store_exclusiveqi */

        case E_HImode:
          if (!mem_noofs_operand (operands[1], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !s_register_operand (operands[2], E_HImode)
              || !
#line 557 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3174; /* arm_store_exclusivehi */

        case E_SImode:
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[2], E_SImode)
              || !
#line 557 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3175; /* arm_store_exclusivesi */

        case E_DImode:
          if (!mem_noofs_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[2], E_DImode)
              || !
#line 557 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          return 3176; /* arm_store_exclusivedi */

        default:
          return -1;
        }

    case 24:
      if (XINT (x6, 1) != 24)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_DImode:
          if (!mem_noofs_operand (operands[1], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !s_register_operand (operands[2], E_DImode)
              || !
#line 580 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQEXD && ARM_DOUBLEWORD_ALIGN))
            return -1;
          return 3177; /* arm_store_release_exclusivedi */

        case E_QImode:
          if (!mem_noofs_operand (operands[1], E_QImode)
              || GET_MODE (x6) != E_QImode
              || !s_register_operand (operands[2], E_QImode)
              || !
#line 595 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3178; /* arm_store_release_exclusiveqi */

        case E_HImode:
          if (!mem_noofs_operand (operands[1], E_HImode)
              || GET_MODE (x6) != E_HImode
              || !s_register_operand (operands[2], E_HImode)
              || !
#line 595 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3179; /* arm_store_release_exclusivehi */

        case E_SImode:
          if (!mem_noofs_operand (operands[1], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !s_register_operand (operands[2], E_SImode)
              || !
#line 595 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDACQ))
            return -1;
          return 3180; /* arm_store_release_exclusivesi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_34 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_33 (x1, insn, pnum_clobbers);

    case CALL:
      if (pnum_clobbers == NULL)
        return -1;
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != USE)
        return -1;
      x4 = XEXP (x2, 0);
      switch (pattern6 (x4))
        {
        case 0:
          x5 = XEXP (x2, 1);
          operands[1] = x5;
          x6 = XEXP (x3, 0);
          operands[2] = x6;
          if (s_register_operand (operands[0], E_SImode))
            {
              if (
#line 8714 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 290; /* *call_reg_armv5 */
                }
              if (
#line 8724 "../../gcc/config/arm/arm.md"
(TARGET_ARM && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 291; /* *call_reg_arm */
                }
            }
          if (
#line 8853 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !SIBLING_CALL_P (insn)
   && (GET_CODE (operands[0]) == SYMBOL_REF)
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
            {
              *pnum_clobbers = 1;
              return 294; /* *call_symbol */
            }
          if (register_operand (operands[0], E_SImode))
            {
              if (
#line 1870 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 991; /* *call_reg_thumb1_v5 */
                }
              if (
#line 1893 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && !arm_arch5t && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 993; /* *call_reg_thumb1 */
                }
            }
          if (
#line 1960 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && GET_CODE (operands[0]) == SYMBOL_REF
   && !arm_is_long_call_p (SYMBOL_REF_DECL (operands[0]))))
            {
              *pnum_clobbers = 1;
              return 997; /* *call_insn */
            }
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 534 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1025; /* *call_reg_thumb2 */

        case 1:
          x7 = XVECEXP (x4, 0, 0);
          x8 = XEXP (x7, 0);
          if (GET_CODE (x8) == REG
              && REGNO (x8) == 4
              && GET_MODE (x8) == E_SImode)
            {
              x5 = XEXP (x2, 1);
              operands[0] = x5;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (
#line 1882 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && use_cmse && !SIBLING_CALL_P (insn)))
                {
                  *pnum_clobbers = 1;
                  return 992; /* *nonsecure_call_reg_thumb1_v5 */
                }
            }
          operands[0] = x8;
          if (s_register_operand (operands[0], E_SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              x6 = XEXP (x3, 0);
              operands[2] = x6;
              if (
#line 545 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && TARGET_HAVE_FPCXT_CMSE))
                {
                  *pnum_clobbers = 1;
                  return 1026; /* *nonsecure_call_reg_thumb2_fpcxt */
                }
            }
          if (GET_CODE (x8) != REG
              || REGNO (x8) != 4
              || GET_MODE (x8) != E_SImode)
            return -1;
          x5 = XEXP (x2, 1);
          operands[0] = x5;
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (!
#line 557 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && use_cmse && !TARGET_HAVE_FPCXT_CMSE))
            return -1;
          *pnum_clobbers = 1;
          return 1027; /* *nonsecure_call_reg_thumb2 */

        default:
          return -1;
        }

    case RETURN:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      x9 = XEXP (x3, 1);
      if (pattern16 (x9, 
POST_INC, 
MEM, 
E_SImode) != 0)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 15
          || GET_MODE (x6) != E_SImode)
        return -1;
      x10 = XEXP (x9, 0);
      x11 = XEXP (x10, 0);
      operands[0] = x11;
      if (!s_register_operand (operands[0], E_SImode)
          || !
#line 12016 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && (reload_in_progress || reload_completed)))
        return -1;
      return 389; /* *ldr_with_return */

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x2, 0))
        {
        case 1:
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != CLOBBER)
            return -1;
          switch (XINT (x2, 1))
            {
            case 16:
              x12 = XVECEXP (x2, 0, 0);
              operands[0] = x12;
              if (!s_register_operand (operands[0], E_SImode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (!scratch_operand (operands[1], E_SImode))
                return -1;
              if (
#line 12275 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return 404; /* arm_eh_return */
              if (
#line 2096 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
                return 1005; /* thumb_eh_return */
              if (!
#line 1239 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
                return -1;
              return 1051; /* thumb2_eh_return */

            case 54:
              if (GET_MODE (x2) != E_SImode)
                return -1;
              x12 = XVECEXP (x2, 0, 0);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 100
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 1699 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse))
                return -1;
              return 1070; /* *clear_apsr */

            default:
              return -1;
            }

        case 6:
          if (pattern17 (x1, 
E_SImode) != 0)
            return -1;
          x13 = XVECEXP (x2, 0, 4);
          operands[4] = x13;
          if (!immediate_operand (operands[4], E_SImode))
            return -1;
          x14 = XVECEXP (x2, 0, 5);
          operands[5] = x14;
          if (!immediate_operand (operands[5], E_SImode))
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x3, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          switch (XINT (x2, 1))
            {
            case 43:
              if (!
#line 13007 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCR)))
                return -1;
              return 505; /* arm_mcr */

            case 44:
              if (!
#line 13007 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCR2)))
                return -1;
              return 506; /* arm_mcr2 */

            default:
              return -1;
            }

        case 4:
          if (pattern17 (x1, 
E_DImode) != 0)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x3, 0);
          if (!rtx_equal_p (x6, operands[2]))
            return -1;
          switch (XINT (x2, 1))
            {
            case 47:
              if (!
#line 13044 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCRR)))
                return -1;
              return 509; /* arm_mcrr */

            case 48:
              if (!
#line 13044 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_MCRR2)))
                return -1;
              return 510; /* arm_mcrr2 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  switch (pattern299 (x1))
    {
    case 0:
      if (pattern389 (x1) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      x6 = XEXP (x3, 0);
      operands[2] = x6;
      x7 = XEXP (x4, 0);
      operands[3] = x7;
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[4] = x9;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          x11 = XEXP (x10, 0);
          x12 = XEXP (x11, 1);
          if (XWINT (x12, 0) != 4LL)
            return -1;
          x13 = XEXP (x4, 1);
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != PLUS
              || GET_MODE (x14) != E_SImode)
            return -1;
          x15 = XEXP (x14, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          x17 = XEXP (x14, 0);
          if (!rtx_equal_p (x17, operands[4]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && arm_hard_general_register_operand (operands[3], E_SImode)
              && 
#line 477 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
            return 456; /* *ldm3_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !low_register_operand (operands[3], E_SImode)
              || !
#line 492 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
            return -1;
          return 457; /* *thumb_ldm3_ia */

        case PLUS:
          if (GET_MODE (x9) != E_SImode)
            return -1;
          x18 = XEXP (x9, 1);
          if (GET_CODE (x18) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x19 = XEXP (x9, 0);
          operands[4] = x19;
          if (!s_register_operand (operands[4], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode)
              || !arm_hard_general_register_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x3, 1);
          x11 = XEXP (x10, 0);
          x16 = XEXP (x11, 0);
          if (!rtx_equal_p (x16, operands[4]))
            return -1;
          switch (XWINT (x18, 0))
            {
            case 4LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != 8LL)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (pattern626 (x14, 
12) != 0
                  || !
#line 582 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 463; /* *ldm3_ib */

            case -8LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -4LL)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (!rtx_equal_p (x14, operands[4])
                  || !
#line 643 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 467; /* *ldm3_da */

            case -12LL:
              x12 = XEXP (x11, 1);
              if (XWINT (x12, 0) != -8LL)
                return -1;
              x13 = XEXP (x4, 1);
              x14 = XEXP (x13, 0);
              if (pattern626 (x14, 
-4) != 0
                  || !
#line 704 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 471; /* *ldm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern452 (x1) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x10 = XEXP (x3, 1);
      operands[2] = x10;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x13 = XEXP (x4, 1);
      operands[3] = x13;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x5 = XEXP (x2, 0);
      x20 = XEXP (x5, 0);
      switch (GET_CODE (x20))
        {
        case REG:
        case SUBREG:
          operands[4] = x20;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          x21 = XEXP (x6, 0);
          x22 = XEXP (x21, 1);
          if (XWINT (x22, 0) != 4LL)
            return -1;
          x7 = XEXP (x4, 0);
          x23 = XEXP (x7, 0);
          if (GET_CODE (x23) != PLUS
              || GET_MODE (x23) != E_SImode)
            return -1;
          x24 = XEXP (x23, 1);
          if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          x26 = XEXP (x23, 0);
          if (!rtx_equal_p (x26, operands[4])
              || !
#line 537 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
            return -1;
          return 460; /* *stm3_ */

        case PLUS:
          if (GET_MODE (x20) != E_SImode)
            return -1;
          x27 = XEXP (x20, 1);
          if (GET_CODE (x27) != CONST_INT)
            return -1;
          x28 = XEXP (x20, 0);
          operands[4] = x28;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x6 = XEXP (x3, 0);
          x21 = XEXP (x6, 0);
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[4]))
            return -1;
          switch (XWINT (x27, 0))
            {
            case 4LL:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != 8LL)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (pattern629 (x23, 
12) != 0
                  || !
#line 613 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 465; /* *stm3_ib */

            case -8LL:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != -4LL)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (!rtx_equal_p (x23, operands[4])
                  || !
#line 673 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 469; /* *stm3_da */

            case -12LL:
              x22 = XEXP (x21, 1);
              if (XWINT (x22, 0) != -8LL)
                return -1;
              x7 = XEXP (x4, 0);
              x23 = XEXP (x7, 0);
              if (pattern629 (x23, 
-4) != 0
                  || !
#line 735 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                return -1;
              return 473; /* *stm3_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x5 = XEXP (x2, 0);
      operands[3] = x5;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x8 = XEXP (x2, 1);
      x9 = XEXP (x8, 0);
      if (!rtx_equal_p (x9, operands[3]))
        return -1;
      x29 = XEXP (x8, 1);
      switch (XWINT (x29, 0))
        {
        case 8LL:
          switch (pattern496 (x3))
            {
            case 0:
              x13 = XEXP (x4, 1);
              if (GET_CODE (x13) != MEM
                  || GET_MODE (x13) != E_SImode)
                return -1;
              x14 = XEXP (x13, 0);
              if (GET_CODE (x14) != PLUS
                  || GET_MODE (x14) != E_SImode)
                return -1;
              x15 = XEXP (x14, 1);
              if (GET_CODE (x15) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              x17 = XEXP (x14, 0);
              if (!rtx_equal_p (x17, operands[3]))
                return -1;
              x10 = XEXP (x3, 1);
              x11 = XEXP (x10, 0);
              switch (GET_CODE (x11))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x11, operands[3])
                      || XWINT (x15, 0) != 4LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && 
#line 880 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return 477; /* *ldm2_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !
#line 894 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 478; /* *thumb_ldm2_ia_update */

                case PLUS:
                  if (GET_MODE (x11) != E_SImode)
                    return -1;
                  x12 = XEXP (x11, 1);
                  if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x15, 0) != 8LL
                      || !arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode))
                    return -1;
                  x16 = XEXP (x11, 0);
                  if (!rtx_equal_p (x16, operands[3])
                      || !
#line 957 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 483; /* *ldm2_ib_update */

                default:
                  return -1;
                }

            case 1:
              x7 = XEXP (x4, 0);
              if (pattern453 (x7) != 0)
                return -1;
              x23 = XEXP (x7, 0);
              x24 = XEXP (x23, 1);
              if (GET_CODE (x24) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x4, 1);
              operands[2] = x13;
              x26 = XEXP (x23, 0);
              if (!rtx_equal_p (x26, operands[3]))
                return -1;
              x6 = XEXP (x3, 0);
              x21 = XEXP (x6, 0);
              switch (GET_CODE (x21))
                {
                case REG:
                case SUBREG:
                  if (!rtx_equal_p (x21, operands[3])
                      || XWINT (x24, 0) != 4LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && 
#line 917 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return 480; /* *stm2_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !
#line 930 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 481; /* *thumb_stm2_ia_update */

                case PLUS:
                  if (GET_MODE (x21) != E_SImode)
                    return -1;
                  x22 = XEXP (x21, 1);
                  if (x22 != const_int_rtx[MAX_SAVED_CONST_INT + 4]
                      || XWINT (x24, 0) != 8LL
                      || !arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode))
                    return -1;
                  x25 = XEXP (x21, 0);
                  if (!rtx_equal_p (x25, operands[3])
                      || !
#line 981 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 485; /* *stm2_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -8LL:
          x10 = XEXP (x3, 1);
          switch (GET_CODE (x10))
            {
            case MEM:
              if (pattern389 (x1) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x6 = XEXP (x3, 0);
              operands[1] = x6;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x10, 0);
              x16 = XEXP (x11, 0);
              if (!rtx_equal_p (x16, operands[3]))
                return -1;
              x12 = XEXP (x11, 1);
              switch (XWINT (x12, 0))
                {
                case -4LL:
                  x13 = XEXP (x4, 1);
                  x14 = XEXP (x13, 0);
                  if (!rtx_equal_p (x14, operands[3])
                      || !
#line 1007 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 487; /* *ldm2_da_update */

                case -8LL:
                  x13 = XEXP (x4, 1);
                  x14 = XEXP (x13, 0);
                  if (GET_CODE (x14) != PLUS
                      || GET_MODE (x14) != E_SImode)
                    return -1;
                  x15 = XEXP (x14, 1);
                  if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x17 = XEXP (x14, 0);
                  if (!rtx_equal_p (x17, operands[3])
                      || !
#line 1059 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 491; /* *ldm2_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x10;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern452 (x1) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x13 = XEXP (x4, 1);
              operands[2] = x13;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x6 = XEXP (x3, 0);
              x21 = XEXP (x6, 0);
              x25 = XEXP (x21, 0);
              if (!rtx_equal_p (x25, operands[3]))
                return -1;
              x22 = XEXP (x21, 1);
              switch (XWINT (x22, 0))
                {
                case -4LL:
                  x7 = XEXP (x4, 0);
                  x23 = XEXP (x7, 0);
                  if (!rtx_equal_p (x23, operands[3])
                      || !
#line 1031 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 489; /* *stm2_da_update */

                case -8LL:
                  x7 = XEXP (x4, 0);
                  x23 = XEXP (x7, 0);
                  if (GET_CODE (x23) != PLUS
                      || GET_MODE (x23) != E_SImode)
                    return -1;
                  x24 = XEXP (x23, 1);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x26 = XEXP (x23, 0);
                  if (!rtx_equal_p (x26, operands[3])
                      || !
#line 1083 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 3))
                    return -1;
                  return 493; /* *stm2_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      if (pattern72 (x3, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3558 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode))))
        return -1;
      return 4909; /* mve_vldrq_gather_base_z_v4si */

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode)
          || !
#line 3558 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode))))
        return -1;
      return 4910; /* mve_vldrq_gather_base_z_v4sf */

    case E_V2DImode:
      if (pattern72 (x3, 
E_V2QImode, 
E_V2DImode) != 0
          || !
#line 3558 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V2DImode))
   || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V2DImode))))
        return -1;
      return 4911; /* mve_vldrq_gather_base_z_v2di */

    default:
      return -1;
    }
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  x6 = XVECEXP (x2, 0, 1);
  operands[2] = x6;
  x7 = XVECEXP (x2, 0, 2);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern430 (x2, 
E_V8QImode, 
E_V8BImode, 
E_V8HImode) != 0
          || !
#line 3203 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4833; /* mve_vstrq_p_truncate_v8qi */

    case E_V4QImode:
      if (pattern430 (x2, 
E_V4QImode, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3203 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4834; /* mve_vstrq_p_truncate_v4qi */

    case E_V4HImode:
      if (pattern430 (x2, 
E_V4HImode, 
E_V4BImode, 
E_V4SImode) != 0
          || !
#line 3203 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4835; /* mve_vstrq_p_truncate_v4hi */

    default:
      return -1;
    }
}

 int
recog_87 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern90 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 2);
  switch (pattern509 (x3))
    {
    case 0:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !
#line 3374 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 4870; /* mve_vstrq_truncate_scatter_offset_v8qi */

    case 1:
      if (!s_register_operand (operands[2], E_V4SImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V4QImode:
          if (!
#line 3374 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4871; /* mve_vstrq_truncate_scatter_offset_v4qi */

        case E_V4HImode:
          if (!
#line 3374 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4872; /* mve_vstrq_truncate_scatter_offset_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern70 (x1))
    {
    case 0:
      if (!
#line 1918 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4138; /* mve_vpselq_uv16qi */

    case 1:
      if (!
#line 1918 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4140; /* mve_vpselq_uv8hi */

    case 2:
      if (!
#line 1918 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4142; /* mve_vpselq_uv4si */

    case 3:
      if (!
#line 1918 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4144; /* mve_vpselq_uv2di */

    default:
      return -1;
    }
}

 int
recog_103 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!neon_permissive_struct_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !s_register_operand (operands[1], E_V8QImode)
              || !
#line 287 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1107; /* *movmisalignv8qi_neon_store */

        case E_V4HImode:
          if (!neon_permissive_struct_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !s_register_operand (operands[1], E_V4HImode)
              || !
#line 287 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1108; /* *movmisalignv4hi_neon_store */

        case E_V4HFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !s_register_operand (operands[1], E_V4HFmode)
              || !
#line 287 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1109; /* *movmisalignv4hf_neon_store */

        case E_V4BFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !s_register_operand (operands[1], E_V4BFmode)
              || !
#line 287 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1110; /* *movmisalignv4bf_neon_store */

        case E_V2SImode:
          if (!neon_permissive_struct_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !s_register_operand (operands[1], E_V2SImode)
              || !
#line 287 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1111; /* *movmisalignv2si_neon_store */

        case E_V2SFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !s_register_operand (operands[1], E_V2SFmode)
              || !
#line 287 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1112; /* *movmisalignv2sf_neon_store */

        case E_DImode:
          if (!neon_permissive_struct_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !s_register_operand (operands[1], E_DImode)
              || !
#line 287 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1113; /* *movmisaligndi_neon_store */

        case E_V16QImode:
          if (GET_MODE (x3) != E_V16QImode
              || !s_register_operand (operands[1], E_V16QImode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V16QImode)
              && 
#line 304 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1121; /* *movmisalignv16qi_neon_store */
          if (!mve_memory_operand (operands[0], E_V16QImode)
              || !
#line 4555 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5057; /* movmisalignv16qi_mve_store */

        case E_V8HImode:
          if (GET_MODE (x3) != E_V8HImode
              || !s_register_operand (operands[1], E_V8HImode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V8HImode)
              && 
#line 304 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1122; /* *movmisalignv8hi_neon_store */
          if (!mve_memory_operand (operands[0], E_V8HImode)
              || !
#line 4555 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5058; /* movmisalignv8hi_mve_store */

        case E_V8HFmode:
          if (GET_MODE (x3) != E_V8HFmode
              || !s_register_operand (operands[1], E_V8HFmode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V8HFmode)
              && 
#line 304 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1123; /* *movmisalignv8hf_neon_store */
          if (!mve_memory_operand (operands[0], E_V8HFmode)
              || !
#line 4555 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5060; /* movmisalignv8hf_mve_store */

        case E_V8BFmode:
          if (!neon_permissive_struct_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !s_register_operand (operands[1], E_V8BFmode)
              || !
#line 304 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1124; /* *movmisalignv8bf_neon_store */

        case E_V4SImode:
          if (GET_MODE (x3) != E_V4SImode
              || !s_register_operand (operands[1], E_V4SImode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V4SImode)
              && 
#line 304 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1125; /* *movmisalignv4si_neon_store */
          if (!mve_memory_operand (operands[0], E_V4SImode)
              || !
#line 4555 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5059; /* movmisalignv4si_mve_store */

        case E_V4SFmode:
          if (GET_MODE (x3) != E_V4SFmode
              || !s_register_operand (operands[1], E_V4SFmode))
            return -1;
          if (neon_permissive_struct_operand (operands[0], E_V4SFmode)
              && 
#line 304 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1126; /* *movmisalignv4sf_neon_store */
          if (!mve_memory_operand (operands[0], E_V4SFmode)
              || !
#line 4555 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5061; /* movmisalignv4sf_mve_store */

        case E_V2DImode:
          if (!neon_permissive_struct_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !s_register_operand (operands[1], E_V2DImode)
              || !
#line 304 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1127; /* *movmisalignv2di_neon_store */

        default:
          return -1;
        }

    case MEM:
      switch (GET_MODE (operands[0]))
        {
        case E_V8QImode:
          if (!s_register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !neon_permissive_struct_operand (operands[1], E_V8QImode)
              || !
#line 296 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1114; /* *movmisalignv8qi_neon_load */

        case E_V4HImode:
          if (!s_register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !neon_permissive_struct_operand (operands[1], E_V4HImode)
              || !
#line 296 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1115; /* *movmisalignv4hi_neon_load */

        case E_V4HFmode:
          if (!s_register_operand (operands[0], E_V4HFmode)
              || GET_MODE (x3) != E_V4HFmode
              || !neon_permissive_struct_operand (operands[1], E_V4HFmode)
              || !
#line 296 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1116; /* *movmisalignv4hf_neon_load */

        case E_V4BFmode:
          if (!s_register_operand (operands[0], E_V4BFmode)
              || GET_MODE (x3) != E_V4BFmode
              || !neon_permissive_struct_operand (operands[1], E_V4BFmode)
              || !
#line 296 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1117; /* *movmisalignv4bf_neon_load */

        case E_V2SImode:
          if (!s_register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !neon_permissive_struct_operand (operands[1], E_V2SImode)
              || !
#line 296 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1118; /* *movmisalignv2si_neon_load */

        case E_V2SFmode:
          if (!s_register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !neon_permissive_struct_operand (operands[1], E_V2SFmode)
              || !
#line 296 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1119; /* *movmisalignv2sf_neon_load */

        case E_DImode:
          if (!s_register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !neon_permissive_struct_operand (operands[1], E_DImode)
              || !
#line 296 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1120; /* *movmisaligndi_neon_load */

        case E_V16QImode:
          if (!s_register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V16QImode)
              && 
#line 313 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1128; /* *movmisalignv16qi_neon_load */
          if (!mve_memory_operand (operands[1], E_V16QImode)
              || !
#line 4568 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V16QImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V16QImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5062; /* movmisalignv16qi_mve_load */

        case E_V8HImode:
          if (!s_register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V8HImode)
              && 
#line 313 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1129; /* *movmisalignv8hi_neon_load */
          if (!mve_memory_operand (operands[1], E_V8HImode)
              || !
#line 4568 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5063; /* movmisalignv8hi_mve_load */

        case E_V8HFmode:
          if (!s_register_operand (operands[0], E_V8HFmode)
              || GET_MODE (x3) != E_V8HFmode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V8HFmode)
              && 
#line 313 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1130; /* *movmisalignv8hf_neon_load */
          if (!mve_memory_operand (operands[1], E_V8HFmode)
              || !
#line 4568 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V8HFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5065; /* movmisalignv8hf_mve_load */

        case E_V8BFmode:
          if (!s_register_operand (operands[0], E_V8BFmode)
              || GET_MODE (x3) != E_V8BFmode
              || !neon_permissive_struct_operand (operands[1], E_V8BFmode)
              || !
#line 313 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1131; /* *movmisalignv8bf_neon_load */

        case E_V4SImode:
          if (!s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V4SImode)
              && 
#line 313 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1132; /* *movmisalignv4si_neon_load */
          if (!mve_memory_operand (operands[1], E_V4SImode)
              || !
#line 4568 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SImode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5064; /* movmisalignv4si_mve_load */

        case E_V4SFmode:
          if (!s_register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode)
            return -1;
          if (neon_permissive_struct_operand (operands[1], E_V4SFmode)
              && 
#line 313 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return 1133; /* *movmisalignv4sf_neon_load */
          if (!mve_memory_operand (operands[1], E_V4SFmode)
              || !
#line 4568 "../../gcc/config/arm/mve.md"
(((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SFmode))
    || (TARGET_HAVE_MVE_FLOAT && VALID_MVE_SF_MODE (V4SFmode)))
   && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 5066; /* movmisalignv4sf_mve_load */

        case E_V2DImode:
          if (!s_register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !neon_permissive_struct_operand (operands[1], E_V2DImode)
              || !
#line 313 "../../gcc/config/arm/neon.md"
(TARGET_NEON && !BYTES_BIG_ENDIAN && unaligned_access))
            return -1;
          return 1134; /* *movmisalignv2di_neon_load */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_174 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2277; /* neon_vrshlsv8qi */

    case 1:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2281; /* neon_vrshlsv16qi */

    case 2:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2285; /* neon_vrshlsv4hi */

    case 3:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2289; /* neon_vrshlsv8hi */

    case 4:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2293; /* neon_vrshlsv2si */

    case 5:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2297; /* neon_vrshlsv4si */

    case 6:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2301; /* neon_vrshlsdi */

    case 7:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2305; /* neon_vrshlsv2di */

    default:
      return -1;
    }
}

 int
recog_184 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1509; /* neon_vqadduv8qi */

    case 1:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1511; /* neon_vqadduv16qi */

    case 2:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1513; /* neon_vqadduv4hi */

    case 3:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1515; /* neon_vqadduv8hi */

    case 4:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1517; /* neon_vqadduv2si */

    case 5:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1519; /* neon_vqadduv4si */

    case 6:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1521; /* neon_vqaddudi */

    case 7:
      if (!
#line 1600 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1523; /* neon_vqadduv2di */

    default:
      return -1;
    }
}

 int
recog_194 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern156 (x1, 
E_EImode, 
E_CImode))
    {
    case 0:
      if (!
#line 5036 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2578; /* neon_vld1x3qav16qi */

    case 1:
      if (!
#line 5036 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2579; /* neon_vld1x3qav8hi */

    case 2:
      if (!
#line 5036 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2580; /* neon_vld1x3qav8hf */

    case 3:
      if (!(
#line 5036 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2581; /* neon_vld1x3qav8bf */

    case 4:
      if (!
#line 5036 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2582; /* neon_vld1x3qav4si */

    case 5:
      if (!
#line 5036 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2583; /* neon_vld1x3qav4sf */

    case 6:
      if (!
#line 5036 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2584; /* neon_vld1x3qav2di */

    default:
      return -1;
    }
}

 int
recog_204 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern164 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5868 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2873; /* neon_vst3qav16qi */

    case 1:
      if (!
#line 5868 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2874; /* neon_vst3qav8hi */

    case 2:
      if (!
#line 5868 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2875; /* neon_vst3qav8hf */

    case 3:
      if (!(
#line 5868 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2876; /* neon_vst3qav8bf */

    case 4:
      if (!
#line 5868 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2877; /* neon_vst3qav4si */

    case 5:
      if (!
#line 5868 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2878; /* neon_vst3qav4sf */

    default:
      return -1;
    }
}

 int
recog_214 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2303 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1650; /* neon_vhsubuv8qi */

    case 1:
      if (!
#line 2303 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1652; /* neon_vhsubuv16qi */

    case 2:
      if (!
#line 2303 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1654; /* neon_vhsubuv4hi */

    case 3:
      if (!
#line 2303 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1656; /* neon_vhsubuv8hi */

    case 4:
      if (!
#line 2303 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1658; /* neon_vhsubuv2si */

    case 5:
      if (!
#line 2303 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1660; /* neon_vhsubuv4si */

    default:
      return -1;
    }
}

 int
recog_224 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern169 (x1))
    {
    case 0:
      if (!
#line 542 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3369; /* mve_vcreateq_sv16qi */

    case 1:
      if (!
#line 542 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3371; /* mve_vcreateq_sv8hi */

    case 2:
      if (!
#line 542 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3373; /* mve_vcreateq_sv4si */

    case 3:
      if (!
#line 542 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3375; /* mve_vcreateq_sv2di */

    default:
      return -1;
    }
}

 int
recog_232 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1710; /* neon_vcltv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1715; /* neon_vcltv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1730; /* neon_vcltv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1735; /* neon_vcltv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_242 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!ssat16_imm (operands[2], E_SImode)
      || !
#line 6166 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
    return -1;
  return 250; /* arm_ssat16_insn */
}

 int
recog_252 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern90 (x1) != 0)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  operands[3] = x3;
  x4 = XVECEXP (x2, 0, 2);
  switch (pattern509 (x4))
    {
    case 0:
      if (!s_register_operand (operands[2], E_V8HImode)
          || !vpr_register_operand (operands[3], E_V8BImode)
          || !
#line 3395 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V8HImode))))
        return -1;
      return 4873; /* mve_vstrq_truncate_scatter_offset_p_v8qi */

    case 1:
      if (!s_register_operand (operands[2], E_V4SImode)
          || !vpr_register_operand (operands[3], E_V4BImode))
        return -1;
      switch (GET_MODE (x4))
        {
        case E_V4QImode:
          if (!
#line 3395 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4874; /* mve_vstrq_truncate_scatter_offset_p_v4qi */

        case E_V4HImode:
          if (!
#line 3395 "../../gcc/config/arm/mve.md"
((TARGET_HAVE_MVE && VALID_MVE_SI_MODE (V4SImode))))
            return -1;
          return 4875; /* mve_vstrq_truncate_scatter_offset_p_v4hi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_256 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern198 (x1))
    {
    case 0:
      if (!
#line 4016 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2206; /* neon_vmla_lanev4hi */

    case 1:
      if (!
#line 4016 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2207; /* neon_vmla_lanev2si */

    case 2:
      if (!
#line 4016 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2208; /* neon_vmla_lanev2sf */

    case 3:
      if (!
#line 4034 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2209; /* neon_vmla_lanev8hi */

    case 4:
      if (!
#line 4034 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2210; /* neon_vmla_lanev4si */

    case 5:
      if (!
#line 4034 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2211; /* neon_vmla_lanev4sf */

    default:
      return -1;
    }
}

 int
recog_263 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 79:
      if (pattern29 (x1) != 0
          || !
#line 2792 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 86; /* arm_smlawb_insn */

    case 80:
      if (pattern29 (x1) != 0
          || !
#line 2792 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY && !ARM_Q_BIT_READ))
        return -1;
      return 88; /* arm_smlawt_insn */

    case 103:
      return recog_102 (x1, insn, pnum_clobbers);

    case 102:
      return recog_95 (x1, insn, pnum_clobbers);

    case 74:
      if (pattern29 (x1) != 0
          || !
#line 6077 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 221; /* arm_usada8 */

    case 75:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 222; /* arm_smlald */

    case 76:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 223; /* arm_smlaldx */

    case 77:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 224; /* arm_smlsld */

    case 78:
      if (pattern30 (x1) != 0
          || !
#line 6088 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD))
        return -1;
      return 225; /* arm_smlsldx */

    case 94:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 238; /* arm_smlad_insn */

    case 95:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 240; /* arm_smladx_insn */

    case 96:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 242; /* arm_smlsd_insn */

    case 97:
      if (pattern29 (x1) != 0
          || !
#line 6111 "../../gcc/config/arm/arm.md"
(TARGET_INT_SIMD && !ARM_Q_BIT_READ))
        return -1;
      return 244; /* arm_smlsdx_insn */

    case 81:
      return recog_90 (x1, insn, pnum_clobbers);

    case 2:
      return recog_93 (x1, insn, pnum_clobbers);

    case 17:
      return recog_94 (x1, insn, pnum_clobbers);

    case 11:
      if (pattern31 (x1) != 0
          || !
#line 518 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 573; /* iwmmxt_wmacs */

    case 12:
      if (pattern31 (x1) != 0
          || !
#line 539 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT))
        return -1;
      return 575; /* iwmmxt_wmacu */

    case 9:
      return recog_77 (x1, insn, pnum_clobbers);

    case 105:
      return recog_76 (x1, insn, pnum_clobbers);

    case 104:
      return recog_75 (x1, insn, pnum_clobbers);

    case 223:
      return recog_86 (x1, insn, pnum_clobbers);

    case 225:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2126 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1568; /* neon_vmlalsv8qi */

        case 1:
          if (!
#line 2126 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1570; /* neon_vmlalsv4hi */

        case 2:
          if (!
#line 2126 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1572; /* neon_vmlalsv2si */

        default:
          return -1;
        }

    case 226:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2126 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1569; /* neon_vmlaluv8qi */

        case 1:
          if (!
#line 2126 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1571; /* neon_vmlaluv4hi */

        case 2:
          if (!
#line 2126 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1573; /* neon_vmlaluv2si */

        default:
          return -1;
        }

    case 229:
      return recog_85 (x1, insn, pnum_clobbers);

    case 231:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2169 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1582; /* neon_vmlslsv8qi */

        case 1:
          if (!
#line 2169 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1584; /* neon_vmlslsv4hi */

        case 2:
          if (!
#line 2169 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1586; /* neon_vmlslsv2si */

        default:
          return -1;
        }

    case 232:
      switch (pattern35 (x1))
        {
        case 0:
          if (!
#line 2169 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1583; /* neon_vmlsluv8qi */

        case 1:
          if (!
#line 2169 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1585; /* neon_vmlsluv4hi */

        case 2:
          if (!
#line 2169 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1587; /* neon_vmlsluv2si */

        default:
          return -1;
        }

    case 361:
      return recog_101 (x1, insn, pnum_clobbers);

    case 362:
      return recog_100 (x1, insn, pnum_clobbers);

    case 264:
      switch (pattern37 (x1))
        {
        case 0:
          if (!
#line 2203 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1604; /* neon_vqdmlalv4hi */

        case 1:
          if (!
#line 2203 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1605; /* neon_vqdmlalv2si */

        default:
          return -1;
        }

    case 266:
      switch (pattern37 (x1))
        {
        case 0:
          if (!
#line 2214 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1606; /* neon_vqdmlslv4hi */

        case 1:
          if (!
#line 2214 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 1607; /* neon_vqdmlslv2si */

        default:
          return -1;
        }

    case 245:
      return recog_68 (x1, insn, pnum_clobbers);

    case 246:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2184; /* neon_vmulls_lanev4hi */

        case 1:
          if (!
#line 3926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2186; /* neon_vmulls_lanev2si */

        default:
          return -1;
        }

    case 247:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2185; /* neon_vmullu_lanev4hi */

        case 1:
          if (!
#line 3926 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2187; /* neon_vmullu_lanev2si */

        default:
          return -1;
        }

    case 273:
      switch (pattern39 (x1))
        {
        case 0:
          if (!
#line 3940 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2188; /* neon_vqdmull_lanev4hi */

        case 1:
          if (!
#line 3940 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2189; /* neon_vqdmull_lanev2si */

        default:
          return -1;
        }

    case 269:
      return recog_98 (x1, insn, pnum_clobbers);

    case 271:
      return recog_99 (x1, insn, pnum_clobbers);

    case 191:
      return recog_61 (x1, insn, pnum_clobbers);

    case 160:
      return recog_62 (x1, insn, pnum_clobbers);

    case 314:
      return recog_84 (x1, insn, pnum_clobbers);

    case 315:
      return recog_83 (x1, insn, pnum_clobbers);

    case 316:
      return recog_82 (x1, insn, pnum_clobbers);

    case 317:
      return recog_81 (x1, insn, pnum_clobbers);

    case 318:
      return recog_79 (x1, insn, pnum_clobbers);

    case 313:
      return recog_80 (x1, insn, pnum_clobbers);

    case 344:
      return recog_70 (x1, insn, pnum_clobbers);

    case 200:
      return recog_89 (x1, insn, pnum_clobbers);

    case 202:
      return recog_88 (x1, insn, pnum_clobbers);

    case 203:
      return recog_60 (x1, insn, pnum_clobbers);

    case 326:
      return recog_67 (x1, insn, pnum_clobbers);

    case 209:
      return recog_92 (x1, insn, pnum_clobbers);

    case 330:
      return recog_64 (x1, insn, pnum_clobbers);

    case 214:
      return recog_91 (x1, insn, pnum_clobbers);

    case 334:
      return recog_66 (x1, insn, pnum_clobbers);

    case 138:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3058; /* crypto_sha1su0 */

    case 140:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3059; /* crypto_sha256h */

    case 141:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3060; /* crypto_sha256h2 */

    case 143:
      if (pattern47 (x1) != 0
          || !
#line 225 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO))
        return -1;
      return 3061; /* crypto_sha256su1 */

    case 134:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3064; /* crypto_sha1c_lb */

    case 135:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3065; /* crypto_sha1m_lb */

    case 136:
      if (pattern48 (x1) != 0
          || !
#line 295 "../../gcc/config/arm/crypto.md"
(TARGET_CRYPTO && INTVAL (operands[4]) == NEON_ENDIAN_LANE_N (V2SImode, 0)))
        return -1;
      return 3066; /* crypto_sha1p_lb */

    case 611:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3871; /* mve_vcmpeqq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3877; /* mve_vcmpeqq_m_fv4sf */

        default:
          return -1;
        }

    case 712:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3872; /* mve_vcmpgeq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3878; /* mve_vcmpgeq_m_fv4sf */

        default:
          return -1;
        }

    case 724:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3873; /* mve_vcmpgtq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3879; /* mve_vcmpgtq_m_fv4sf */

        default:
          return -1;
        }

    case 741:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3874; /* mve_vcmpleq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3880; /* mve_vcmpleq_m_fv4sf */

        default:
          return -1;
        }

    case 725:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3875; /* mve_vcmpltq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3881; /* mve_vcmpltq_m_fv4sf */

        default:
          return -1;
        }

    case 736:
      switch (pattern50 (x1))
        {
        case 0:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3876; /* mve_vcmpneq_m_fv8hf */

        case 1:
          if (!
#line 1556 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3882; /* mve_vcmpneq_m_fv4sf */

        default:
          return -1;
        }

    case 612:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3883; /* mve_vcvtaq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3891; /* mve_vcvtaq_m_sv4si */

        default:
          return -1;
        }

    case 613:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3884; /* mve_vcvtaq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3892; /* mve_vcvtaq_m_uv4si */

        default:
          return -1;
        }

    case 804:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3885; /* mve_vcvtmq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3893; /* mve_vcvtmq_m_sv4si */

        default:
          return -1;
        }

    case 805:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3886; /* mve_vcvtmq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3894; /* mve_vcvtmq_m_uv4si */

        default:
          return -1;
        }

    case 806:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3887; /* mve_vcvtnq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3895; /* mve_vcvtnq_m_sv4si */

        default:
          return -1;
        }

    case 810:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3888; /* mve_vcvtnq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3896; /* mve_vcvtnq_m_uv4si */

        default:
          return -1;
        }

    case 807:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3889; /* mve_vcvtpq_m_sv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3897; /* mve_vcvtpq_m_sv4si */

        default:
          return -1;
        }

    case 808:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3890; /* mve_vcvtpq_m_uv8hi */

        case 1:
          if (!
#line 1575 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3898; /* mve_vcvtpq_m_uv4si */

        default:
          return -1;
        }

    case 614:
      switch (pattern53 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1592 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3899; /* mve_vcvtq_m_to_f_sv8hf */

        case 1:
          if (!
#line 1592 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3901; /* mve_vcvtq_m_to_f_sv4sf */

        default:
          return -1;
        }

    case 615:
      switch (pattern53 (x1, 
E_V8HImode, 
E_V4SImode))
        {
        case 0:
          if (!
#line 1592 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3900; /* mve_vcvtq_m_to_f_uv8hf */

        case 1:
          if (!
#line 1592 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 3902; /* mve_vcvtq_m_to_f_uv4sf */

        default:
          return -1;
        }

    case 617:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3903; /* mve_vqrshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3923; /* mve_vqrshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 616:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3904; /* mve_vqrshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3924; /* mve_vqrshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 777:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3905; /* mve_vqrshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3925; /* mve_vqrshrntq_n_sv4si */

        default:
          return -1;
        }

    case 776:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3906; /* mve_vqrshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3926; /* mve_vqrshrntq_n_uv4si */

        default:
          return -1;
        }

    case 618:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3907; /* mve_vqrshrunbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3927; /* mve_vqrshrunbq_n_sv4si */

        default:
          return -1;
        }

    case 720:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3908; /* mve_vqrshruntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3928; /* mve_vqrshruntq_n_sv4si */

        default:
          return -1;
        }

    case 785:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3909; /* mve_vqshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3929; /* mve_vqshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 784:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3910; /* mve_vqshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3930; /* mve_vqshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 796:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3911; /* mve_vqshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3931; /* mve_vqshrntq_n_sv4si */

        default:
          return -1;
        }

    case 795:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3912; /* mve_vqshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3932; /* mve_vqshrntq_n_uv4si */

        default:
          return -1;
        }

    case 719:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3913; /* mve_vqshrunbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3933; /* mve_vqshrunbq_n_sv4si */

        default:
          return -1;
        }

    case 727:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3914; /* mve_vqshruntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3934; /* mve_vqshruntq_n_sv4si */

        default:
          return -1;
        }

    case 788:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3915; /* mve_vrshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3935; /* mve_vrshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 789:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3916; /* mve_vrshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3936; /* mve_vrshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 771:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3917; /* mve_vrshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3937; /* mve_vrshrntq_n_sv4si */

        default:
          return -1;
        }

    case 770:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3918; /* mve_vrshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3938; /* mve_vrshrntq_n_uv4si */

        default:
          return -1;
        }

    case 787:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3919; /* mve_vshrnbq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3939; /* mve_vshrnbq_n_sv4si */

        default:
          return -1;
        }

    case 786:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3920; /* mve_vshrnbq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3940; /* mve_vshrnbq_n_uv4si */

        default:
          return -1;
        }

    case 798:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3921; /* mve_vshrntq_n_sv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3941; /* mve_vshrntq_n_sv4si */

        default:
          return -1;
        }

    case 799:
      switch (pattern56 (x1))
        {
        case 0:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3922; /* mve_vshrntq_n_uv8hi */

        case 1:
          if (!
#line 1620 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3942; /* mve_vshrntq_n_uv4si */

        default:
          return -1;
        }

    case 619:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3943; /* mve_vrmlaldavhaq_sv4si */

    case 624:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3944; /* mve_vrmlaldavhaq_uv4si */

    case 715:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3945; /* mve_vrmlaldavhaxq_sv4si */

    case 733:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3946; /* mve_vrmlsldavhaq_sv4si */

    case 734:
      if (pattern57 (x1) != 0
          || !
#line 1640 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 3947; /* mve_vrmlsldavhaxq_sv4si */

    case 620:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1658 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3948; /* mve_vabavq_sv16qi */

        case 1:
          if (!
#line 1658 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3950; /* mve_vabavq_sv8hi */

        case 2:
          if (!
#line 1658 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3952; /* mve_vabavq_sv4si */

        default:
          return -1;
        }

    case 621:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1658 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3949; /* mve_vabavq_uv16qi */

        case 1:
          if (!
#line 1658 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3951; /* mve_vabavq_uv8hi */

        case 2:
          if (!
#line 1658 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3953; /* mve_vabavq_uv4si */

        default:
          return -1;
        }

    case 625:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3960; /* mve_vabsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3967; /* mve_vabsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3974; /* mve_vabsq_m_sv4si */

        default:
          return -1;
        }

    case 628:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3961; /* mve_vclsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3968; /* mve_vclsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3975; /* mve_vclsq_m_sv4si */

        default:
          return -1;
        }

    case 629:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3962; /* mve_vclzq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3969; /* mve_vclzq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3976; /* mve_vclzq_m_sv4si */

        default:
          return -1;
        }

    case 630:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3963; /* mve_vclzq_m_uv16qi */

        case 1:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3970; /* mve_vclzq_m_uv8hi */

        case 2:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3977; /* mve_vclzq_m_uv4si */

        default:
          return -1;
        }

    case 678:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3964; /* mve_vnegq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3971; /* mve_vnegq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3978; /* mve_vnegq_m_sv4si */

        default:
          return -1;
        }

    case 681:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3965; /* mve_vqabsq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3972; /* mve_vqabsq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3979; /* mve_vqabsq_m_sv4si */

        default:
          return -1;
        }

    case 684:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3966; /* mve_vqnegq_m_sv16qi */

        case 1:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3973; /* mve_vqnegq_m_sv8hi */

        case 2:
          if (!
#line 1701 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3980; /* mve_vqnegq_m_sv4si */

        default:
          return -1;
        }

    case 626:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 1718 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3981; /* mve_vaddvaq_p_sv16qi */

        case 1:
          if (!
#line 1718 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3983; /* mve_vaddvaq_p_sv8hi */

        case 2:
          if (!
#line 1718 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3985; /* mve_vaddvaq_p_sv4si */

        default:
          return -1;
        }

    case 627:
      switch (pattern61 (x1))
        {
        case 0:
          if (!
#line 1718 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3982; /* mve_vaddvaq_p_uv16qi */

        case 1:
          if (!
#line 1718 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3984; /* mve_vaddvaq_p_uv8hi */

        case 2:
          if (!
#line 1718 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3986; /* mve_vaddvaq_p_uv4si */

        default:
          return -1;
        }

    case 631:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3987; /* mve_vcmpcsq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3997; /* mve_vcmpcsq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4007; /* mve_vcmpcsq_m_n_uv4si */

        default:
          return -1;
        }

    case 633:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3988; /* mve_vcmpeqq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3998; /* mve_vcmpeqq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4008; /* mve_vcmpeqq_m_n_sv4si */

        default:
          return -1;
        }

    case 634:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3989; /* mve_vcmpeqq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3999; /* mve_vcmpeqq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4009; /* mve_vcmpeqq_m_n_uv4si */

        default:
          return -1;
        }

    case 637:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3990; /* mve_vcmpgeq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4000; /* mve_vcmpgeq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4010; /* mve_vcmpgeq_m_n_sv4si */

        default:
          return -1;
        }

    case 639:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3991; /* mve_vcmpgtq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4001; /* mve_vcmpgtq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4011; /* mve_vcmpgtq_m_n_sv4si */

        default:
          return -1;
        }

    case 641:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3992; /* mve_vcmphiq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4002; /* mve_vcmphiq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4012; /* mve_vcmphiq_m_n_uv4si */

        default:
          return -1;
        }

    case 643:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3993; /* mve_vcmpleq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4003; /* mve_vcmpleq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4013; /* mve_vcmpleq_m_n_sv4si */

        default:
          return -1;
        }

    case 645:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3994; /* mve_vcmpltq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4004; /* mve_vcmpltq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4014; /* mve_vcmpltq_m_n_sv4si */

        default:
          return -1;
        }

    case 647:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3995; /* mve_vcmpneq_m_n_sv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4005; /* mve_vcmpneq_m_n_sv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4015; /* mve_vcmpneq_m_n_sv4si */

        default:
          return -1;
        }

    case 648:
      switch (pattern63 (x1))
        {
        case 0:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 3996; /* mve_vcmpneq_m_n_uv16qi */

        case 1:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4006; /* mve_vcmpneq_m_n_uv8hi */

        case 2:
          if (!
#line 1742 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4016; /* mve_vcmpneq_m_n_uv4si */

        default:
          return -1;
        }

    case 632:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4017; /* mve_vcmpcsq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4027; /* mve_vcmpcsq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4037; /* mve_vcmpcsq_m_uv4si */

        default:
          return -1;
        }

    case 635:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4018; /* mve_vcmpeqq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4028; /* mve_vcmpeqq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4038; /* mve_vcmpeqq_m_sv4si */

        default:
          return -1;
        }

    case 636:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4019; /* mve_vcmpeqq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4029; /* mve_vcmpeqq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4039; /* mve_vcmpeqq_m_uv4si */

        default:
          return -1;
        }

    case 638:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4020; /* mve_vcmpgeq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4030; /* mve_vcmpgeq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4040; /* mve_vcmpgeq_m_sv4si */

        default:
          return -1;
        }

    case 640:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4021; /* mve_vcmpgtq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4031; /* mve_vcmpgtq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4041; /* mve_vcmpgtq_m_sv4si */

        default:
          return -1;
        }

    case 642:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4022; /* mve_vcmphiq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4032; /* mve_vcmphiq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4042; /* mve_vcmphiq_m_uv4si */

        default:
          return -1;
        }

    case 644:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4023; /* mve_vcmpleq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4033; /* mve_vcmpleq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4043; /* mve_vcmpleq_m_sv4si */

        default:
          return -1;
        }

    case 646:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4024; /* mve_vcmpltq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4034; /* mve_vcmpltq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4044; /* mve_vcmpltq_m_sv4si */

        default:
          return -1;
        }

    case 649:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4025; /* mve_vcmpneq_m_sv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4035; /* mve_vcmpneq_m_sv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4045; /* mve_vcmpneq_m_sv4si */

        default:
          return -1;
        }

    case 650:
      switch (pattern64 (x1))
        {
        case 0:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4026; /* mve_vcmpneq_m_uv16qi */

        case 1:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4036; /* mve_vcmpneq_m_uv8hi */

        case 2:
          if (!
#line 1766 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4046; /* mve_vcmpneq_m_uv4si */

        default:
          return -1;
        }

    case 651:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1783 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4047; /* mve_vdupq_m_n_sv16qi */

        case 1:
          if (!
#line 1783 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4049; /* mve_vdupq_m_n_sv8hi */

        case 2:
          if (!
#line 1783 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4051; /* mve_vdupq_m_n_sv4si */

        default:
          return -1;
        }

    case 652:
      switch (pattern65 (x1))
        {
        case 0:
          if (!
#line 1783 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4048; /* mve_vdupq_m_n_uv16qi */

        case 1:
          if (!
#line 1783 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4050; /* mve_vdupq_m_n_uv8hi */

        case 2:
          if (!
#line 1783 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4052; /* mve_vdupq_m_n_uv4si */

        default:
          return -1;
        }

    case 657:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1801 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4053; /* mve_vmaxaq_m_sv16qi */

        case 1:
          if (!
#line 1801 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4055; /* mve_vmaxaq_m_sv8hi */

        case 2:
          if (!
#line 1801 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4057; /* mve_vmaxaq_m_sv4si */

        default:
          return -1;
        }

    case 661:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1801 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4054; /* mve_vminaq_m_sv16qi */

        case 1:
          if (!
#line 1801 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4056; /* mve_vminaq_m_sv8hi */

        case 2:
          if (!
#line 1801 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4058; /* mve_vminaq_m_sv4si */

        default:
          return -1;
        }

    case 658:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4059; /* mve_vmaxavq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4065; /* mve_vmaxavq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4071; /* mve_vmaxavq_p_sv4si */

        default:
          return -1;
        }

    case 659:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4060; /* mve_vmaxvq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4066; /* mve_vmaxvq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4072; /* mve_vmaxvq_p_sv4si */

        default:
          return -1;
        }

    case 660:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4061; /* mve_vmaxvq_p_uv16qi */

        case 1:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4067; /* mve_vmaxvq_p_uv8hi */

        case 2:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4073; /* mve_vmaxvq_p_uv4si */

        default:
          return -1;
        }

    case 662:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4062; /* mve_vminavq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4068; /* mve_vminavq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4074; /* mve_vminavq_p_sv4si */

        default:
          return -1;
        }

    case 663:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4063; /* mve_vminvq_p_sv16qi */

        case 1:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4069; /* mve_vminvq_p_sv8hi */

        case 2:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4075; /* mve_vminvq_p_sv4si */

        default:
          return -1;
        }

    case 664:
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4064; /* mve_vminvq_p_uv16qi */

        case 1:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4070; /* mve_vminvq_p_uv8hi */

        case 2:
          if (!
#line 1821 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4076; /* mve_vminvq_p_uv4si */

        default:
          return -1;
        }

    case 665:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4077; /* mve_vmladavaq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4082; /* mve_vmladavaq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4087; /* mve_vmladavaq_sv4si */

        default:
          return -1;
        }

    case 666:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4078; /* mve_vmladavaq_uv16qi */

        case 1:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4083; /* mve_vmladavaq_uv8hi */

        case 2:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4088; /* mve_vmladavaq_uv4si */

        default:
          return -1;
        }

    case 709:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4079; /* mve_vmlsdavaxq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4084; /* mve_vmlsdavaxq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4089; /* mve_vmlsdavaxq_sv4si */

        default:
          return -1;
        }

    case 710:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4080; /* mve_vmlsdavaq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4085; /* mve_vmlsdavaq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4090; /* mve_vmlsdavaq_sv4si */

        default:
          return -1;
        }

    case 711:
      switch (pattern58 (x1))
        {
        case 0:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4081; /* mve_vmladavaxq_sv16qi */

        case 1:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4086; /* mve_vmladavaxq_sv8hi */

        case 2:
          if (!
#line 1841 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4091; /* mve_vmladavaxq_sv4si */

        default:
          return -1;
        }

    case 667:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4092; /* mve_vmladavq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4097; /* mve_vmladavq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4102; /* mve_vmladavq_p_sv4si */

        default:
          return -1;
        }

    case 668:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4093; /* mve_vmladavq_p_uv16qi */

        case 1:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4098; /* mve_vmladavq_p_uv8hi */

        case 2:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4103; /* mve_vmladavq_p_uv4si */

        default:
          return -1;
        }

    case 669:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4094; /* mve_vmladavxq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4099; /* mve_vmladavxq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4104; /* mve_vmladavxq_p_sv4si */

        default:
          return -1;
        }

    case 674:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4095; /* mve_vmlsdavq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4100; /* mve_vmlsdavq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4105; /* mve_vmlsdavq_p_sv4si */

        default:
          return -1;
        }

    case 675:
      switch (pattern67 (x1))
        {
        case 0:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4096; /* mve_vmlsdavxq_p_sv16qi */

        case 1:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4101; /* mve_vmlsdavxq_p_sv8hi */

        case 2:
          if (!
#line 1862 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4106; /* mve_vmlsdavxq_p_sv4si */

        default:
          return -1;
        }

    case 670:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4107; /* mve_vmlaq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4115; /* mve_vmlaq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4123; /* mve_vmlaq_n_sv4si */

        default:
          return -1;
        }

    case 671:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4108; /* mve_vmlaq_n_uv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4116; /* mve_vmlaq_n_uv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4124; /* mve_vmlaq_n_uv4si */

        default:
          return -1;
        }

    case 672:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4109; /* mve_vmlasq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4117; /* mve_vmlasq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4125; /* mve_vmlasq_n_sv4si */

        default:
          return -1;
        }

    case 673:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4110; /* mve_vmlasq_n_uv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4118; /* mve_vmlasq_n_uv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4126; /* mve_vmlasq_n_uv4si */

        default:
          return -1;
        }

    case 682:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4111; /* mve_vqdmlahq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4119; /* mve_vqdmlahq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4127; /* mve_vqdmlahq_n_sv4si */

        default:
          return -1;
        }

    case 683:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4112; /* mve_vqdmlashq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4120; /* mve_vqdmlashq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4128; /* mve_vqdmlashq_n_sv4si */

        default:
          return -1;
        }

    case 687:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4113; /* mve_vqrdmlahq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4121; /* mve_vqrdmlahq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4129; /* mve_vqrdmlahq_n_sv4si */

        default:
          return -1;
        }

    case 688:
      switch (pattern69 (x1))
        {
        case 0:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4114; /* mve_vqrdmlashq_n_sv16qi */

        case 1:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4122; /* mve_vqrdmlashq_n_sv8hi */

        case 2:
          if (!
#line 1884 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4130; /* mve_vqrdmlashq_n_sv4si */

        default:
          return -1;
        }

    case 676:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1901 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4131; /* mve_vmvnq_m_sv16qi */

        case 1:
          if (!
#line 1901 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4133; /* mve_vmvnq_m_sv8hi */

        case 2:
          if (!
#line 1901 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4135; /* mve_vmvnq_m_sv4si */

        default:
          return -1;
        }

    case 677:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1901 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4132; /* mve_vmvnq_m_uv16qi */

        case 1:
          if (!
#line 1901 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4134; /* mve_vmvnq_m_uv8hi */

        case 2:
          if (!
#line 1901 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4136; /* mve_vmvnq_m_uv4si */

        default:
          return -1;
        }

    case 679:
      return recog_97 (x1, insn, pnum_clobbers);

    case 680:
      return recog_96 (x1, insn, pnum_clobbers);

    case 708:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4145; /* mve_vqdmladhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4153; /* mve_vqdmladhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4161; /* mve_vqdmladhq_sv4si */

        default:
          return -1;
        }

    case 707:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4146; /* mve_vqdmladhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4154; /* mve_vqdmladhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4162; /* mve_vqdmladhxq_sv4si */

        default:
          return -1;
        }

    case 706:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4147; /* mve_vqdmlsdhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4155; /* mve_vqdmlsdhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4163; /* mve_vqdmlsdhq_sv4si */

        default:
          return -1;
        }

    case 705:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4148; /* mve_vqdmlsdhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4156; /* mve_vqdmlsdhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4164; /* mve_vqdmlsdhxq_sv4si */

        default:
          return -1;
        }

    case 685:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4149; /* mve_vqrdmladhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4157; /* mve_vqrdmladhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4165; /* mve_vqrdmladhq_sv4si */

        default:
          return -1;
        }

    case 686:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4150; /* mve_vqrdmladhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4158; /* mve_vqrdmladhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4166; /* mve_vqrdmladhxq_sv4si */

        default:
          return -1;
        }

    case 689:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4151; /* mve_vqrdmlsdhq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4159; /* mve_vqrdmlsdhq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4167; /* mve_vqrdmlsdhq_sv4si */

        default:
          return -1;
        }

    case 690:
      switch (pattern71 (x1))
        {
        case 0:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4152; /* mve_vqrdmlsdhxq_sv16qi */

        case 1:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4160; /* mve_vqrdmlsdhxq_sv8hi */

        case 2:
          if (!
#line 1942 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4168; /* mve_vqrdmlsdhxq_sv4si */

        default:
          return -1;
        }

    case 691:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4169; /* mve_vqrshlq_m_n_sv16qi */

        case 1:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4173; /* mve_vqrshlq_m_n_sv8hi */

        case 2:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4177; /* mve_vqrshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 692:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4170; /* mve_vqrshlq_m_n_uv16qi */

        case 1:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4174; /* mve_vqrshlq_m_n_uv8hi */

        case 2:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4178; /* mve_vqrshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 697:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4171; /* mve_vrshlq_m_n_sv16qi */

        case 1:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4175; /* mve_vrshlq_m_n_sv8hi */

        case 2:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4179; /* mve_vrshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 698:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4172; /* mve_vrshlq_m_n_uv16qi */

        case 1:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4176; /* mve_vrshlq_m_n_uv8hi */

        case 2:
          if (!
#line 1960 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4180; /* mve_vrshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 693:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4181; /* mve_vqshlq_m_r_sv16qi */

        case 1:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4185; /* mve_vqshlq_m_r_sv8hi */

        case 2:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4189; /* mve_vqshlq_m_r_sv4si */

        default:
          return -1;
        }

    case 694:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4182; /* mve_vqshlq_m_r_uv16qi */

        case 1:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4186; /* mve_vqshlq_m_r_uv8hi */

        case 2:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4190; /* mve_vqshlq_m_r_uv4si */

        default:
          return -1;
        }

    case 699:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4183; /* mve_vshlq_m_r_sv16qi */

        case 1:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4187; /* mve_vshlq_m_r_sv8hi */

        case 2:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4191; /* mve_vshlq_m_r_sv4si */

        default:
          return -1;
        }

    case 700:
      switch (pattern73 (x1))
        {
        case 0:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4184; /* mve_vshlq_m_r_uv16qi */

        case 1:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4188; /* mve_vshlq_m_r_uv8hi */

        case 2:
          if (!
#line 1978 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4192; /* mve_vshlq_m_r_uv4si */

        default:
          return -1;
        }

    case 695:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1995 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4193; /* mve_vrev64q_m_sv16qi */

        case 1:
          if (!
#line 1995 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4195; /* mve_vrev64q_m_sv8hi */

        case 2:
          if (!
#line 1995 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4197; /* mve_vrev64q_m_sv4si */

        default:
          return -1;
        }

    case 696:
      switch (pattern60 (x1))
        {
        case 0:
          if (!
#line 1995 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4194; /* mve_vrev64q_m_uv16qi */

        case 1:
          if (!
#line 1995 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4196; /* mve_vrev64q_m_uv8hi */

        case 2:
          if (!
#line 1995 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4198; /* mve_vrev64q_m_uv4si */

        default:
          return -1;
        }

    case 701:
      switch (pattern74 (x1))
        {
        case 0:
          if (!
#line 2012 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4199; /* mve_vsliq_n_sv16qi */

        case 1:
          if (!
#line 2012 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4201; /* mve_vsliq_n_sv8hi */

        case 2:
          if (!
#line 2012 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4203; /* mve_vsliq_n_sv4si */

        default:
          return -1;
        }

    case 702:
      switch (pattern74 (x1))
        {
        case 0:
          if (!
#line 2012 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4200; /* mve_vsliq_n_uv16qi */

        case 1:
          if (!
#line 2012 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4202; /* mve_vsliq_n_uv8hi */

        case 2:
          if (!
#line 2012 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4204; /* mve_vsliq_n_uv4si */

        default:
          return -1;
        }

    case 703:
      switch (pattern75 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4205; /* mve_vsriq_n_sv16qi */

        case 1:
          if (!
#line 2029 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4207; /* mve_vsriq_n_sv8hi */

        case 2:
          if (!
#line 2029 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4209; /* mve_vsriq_n_sv4si */

        default:
          return -1;
        }

    case 704:
      switch (pattern75 (x1))
        {
        case 0:
          if (!
#line 2029 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4206; /* mve_vsriq_n_uv16qi */

        case 1:
          if (!
#line 2029 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4208; /* mve_vsriq_n_uv8hi */

        case 2:
          if (!
#line 2029 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4210; /* mve_vsriq_n_uv4si */

        default:
          return -1;
        }

    case 728:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4211; /* mve_vabsq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4219; /* mve_vabsq_m_fv4sf */

        default:
          return -1;
        }

    case 750:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4212; /* mve_vnegq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4220; /* mve_vnegq_m_fv4sf */

        default:
          return -1;
        }

    case 737:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4213; /* mve_vrndaq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4221; /* mve_vrndaq_m_fv4sf */

        default:
          return -1;
        }

    case 751:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4214; /* mve_vrndmq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4222; /* mve_vrndmq_m_fv4sf */

        default:
          return -1;
        }

    case 754:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4215; /* mve_vrndnq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4223; /* mve_vrndnq_m_fv4sf */

        default:
          return -1;
        }

    case 738:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4216; /* mve_vrndpq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4224; /* mve_vrndpq_m_fv4sf */

        default:
          return -1;
        }

    case 761:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4217; /* mve_vrndq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4225; /* mve_vrndq_m_fv4sf */

        default:
          return -1;
        }

    case 743:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4218; /* mve_vrndxq_m_fv8hf */

        case 1:
          if (!
#line 2053 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4226; /* mve_vrndxq_m_fv4sf */

        default:
          return -1;
        }

    case 817:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 2070 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4227; /* mve_vaddlvaq_p_uv4si */

    case 739:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SImode, 
E_DImode) != 0
          || !
#line 2070 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4228; /* mve_vaddlvaq_p_sv4si */

    case 759:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4237; /* mve_vcmpeqq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4243; /* mve_vcmpeqq_m_n_fv4sf */

        default:
          return -1;
        }

    case 753:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4238; /* mve_vcmpgeq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4244; /* mve_vcmpgeq_m_n_fv4sf */

        default:
          return -1;
        }

    case 713:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4239; /* mve_vcmpgtq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4245; /* mve_vcmpgtq_m_n_fv4sf */

        default:
          return -1;
        }

    case 752:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4240; /* mve_vcmpleq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4246; /* mve_vcmpleq_m_n_fv4sf */

        default:
          return -1;
        }

    case 735:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4241; /* mve_vcmpltq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4247; /* mve_vcmpltq_m_n_fv4sf */

        default:
          return -1;
        }

    case 756:
      switch (pattern78 (x1))
        {
        case 0:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4242; /* mve_vcmpneq_m_n_fv8hf */

        case 1:
          if (!
#line 2112 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4248; /* mve_vcmpneq_m_n_fv4sf */

        default:
          return -1;
        }

    case 800:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 2130 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4249; /* mve_vcvtbq_m_f16_f32v8hf */

    case 802:
      if (pattern77 (x1, 
E_V4BImode, 
E_V4SFmode, 
E_V8HFmode) != 0
          || !
#line 2130 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4250; /* mve_vcvttq_m_f16_f32v8hf */

    case 801:
      if (pattern77 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4SFmode) != 0
          || !
#line 2148 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4251; /* mve_vcvtbq_m_f32_f16v4sf */

    case 803:
      if (pattern77 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4SFmode) != 0
          || !
#line 2148 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4252; /* mve_vcvttq_m_f32_f16v4sf */

    case 723:
      switch (pattern53 (x1, 
E_HFmode, 
E_SFmode))
        {
        case 0:
          if (!
#line 2165 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4253; /* mve_vdupq_m_n_fv8hf */

        case 1:
          if (!
#line 2165 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4254; /* mve_vdupq_m_n_fv4sf */

        default:
          return -1;
        }

    case 717:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2183 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4255; /* mve_vfmaq_fv8hf */

        case 1:
          if (!
#line 2183 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4257; /* mve_vfmaq_fv4sf */

        default:
          return -1;
        }

    case 744:
      switch (pattern79 (x1))
        {
        case 0:
          if (!
#line 2183 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4256; /* mve_vfmsq_fv8hf */

        case 1:
          if (!
#line 2183 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4258; /* mve_vfmsq_fv4sf */

        default:
          return -1;
        }

    case 730:
      switch (pattern80 (x1))
        {
        case 0:
          if (!
#line 2201 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4259; /* mve_vfmaq_n_fv8hf */

        case 1:
          if (!
#line 2201 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4261; /* mve_vfmaq_n_fv4sf */

        default:
          return -1;
        }

    case 722:
      switch (pattern80 (x1))
        {
        case 0:
          if (!
#line 2201 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4260; /* mve_vfmasq_n_fv8hf */

        case 1:
          if (!
#line 2201 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4262; /* mve_vfmasq_n_fv4sf */

        default:
          return -1;
        }

    case 760:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2219 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4263; /* mve_vmaxnmaq_m_fv8hf */

        case 1:
          if (!
#line 2219 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4265; /* mve_vmaxnmaq_m_fv4sf */

        default:
          return -1;
        }

    case 721:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2219 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4264; /* mve_vminnmaq_m_fv8hf */

        case 1:
          if (!
#line 2219 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4266; /* mve_vminnmaq_m_fv4sf */

        default:
          return -1;
        }

    case 729:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4267; /* mve_vmaxnmavq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4271; /* mve_vmaxnmavq_p_fv4sf */

        default:
          return -1;
        }

    case 746:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4268; /* mve_vmaxnmvq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4272; /* mve_vmaxnmvq_p_fv4sf */

        default:
          return -1;
        }

    case 755:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4269; /* mve_vminnmavq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4273; /* mve_vminnmavq_p_fv4sf */

        default:
          return -1;
        }

    case 745:
      switch (pattern81 (x1))
        {
        case 0:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4270; /* mve_vminnmvq_p_fv8hf */

        case 1:
          if (!
#line 2239 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4274; /* mve_vminnmvq_p_fv4sf */

        default:
          return -1;
        }

    case 782:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4275; /* mve_vmlaldavaq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4280; /* mve_vmlaldavaq_sv4si */

        default:
          return -1;
        }

    case 783:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4276; /* mve_vmlaldavaq_uv8hi */

        case 1:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4281; /* mve_vmlaldavaq_uv4si */

        default:
          return -1;
        }

    case 797:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4277; /* mve_vmlaldavaxq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4282; /* mve_vmlaldavaxq_sv4si */

        default:
          return -1;
        }

    case 718:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4278; /* mve_vmlsldavaq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4283; /* mve_vmlsldavaq_sv4si */

        default:
          return -1;
        }

    case 742:
      switch (pattern82 (x1))
        {
        case 0:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4279; /* mve_vmlsldavaxq_sv8hi */

        case 1:
          if (!
#line 2259 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4284; /* mve_vmlsldavaxq_sv4si */

        default:
          return -1;
        }

    case 763:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4285; /* mve_vmlaldavq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4290; /* mve_vmlaldavq_p_sv4si */

        default:
          return -1;
        }

    case 762:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4286; /* mve_vmlaldavq_p_uv8hi */

        case 1:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4291; /* mve_vmlaldavq_p_uv4si */

        default:
          return -1;
        }

    case 790:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4287; /* mve_vmlaldavxq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4292; /* mve_vmlaldavxq_p_sv4si */

        default:
          return -1;
        }

    case 714:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4288; /* mve_vmlsldavq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4293; /* mve_vmlsldavq_p_sv4si */

        default:
          return -1;
        }

    case 716:
      switch (pattern83 (x1))
        {
        case 0:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4289; /* mve_vmlsldavxq_p_sv8hi */

        case 1:
          if (!
#line 2280 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4294; /* mve_vmlsldavxq_p_sv4si */

        default:
          return -1;
        }

    case 780:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4295; /* mve_vmovlbq_m_uv16qi */

        case 1:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4299; /* mve_vmovlbq_m_uv8hi */

        default:
          return -1;
        }

    case 781:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4296; /* mve_vmovlbq_m_sv16qi */

        case 1:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4300; /* mve_vmovlbq_m_sv8hi */

        default:
          return -1;
        }

    case 766:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4297; /* mve_vmovltq_m_uv16qi */

        case 1:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4301; /* mve_vmovltq_m_uv8hi */

        default:
          return -1;
        }

    case 767:
      switch (pattern52 (x1, 
E_V16BImode, 
E_V16QImode, 
E_V8BImode, 
E_V8HImode))
        {
        case 0:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4298; /* mve_vmovltq_m_sv16qi */

        case 1:
          if (!
#line 2298 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4302; /* mve_vmovltq_m_sv8hi */

        default:
          return -1;
        }

    case 769:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4303; /* mve_vmovnbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4313; /* mve_vmovnbq_m_sv4si */

        default:
          return -1;
        }

    case 768:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4304; /* mve_vmovnbq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4314; /* mve_vmovnbq_m_uv4si */

        default:
          return -1;
        }

    case 779:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4305; /* mve_vmovntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4315; /* mve_vmovntq_m_sv4si */

        default:
          return -1;
        }

    case 778:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4306; /* mve_vmovntq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4316; /* mve_vmovntq_m_uv4si */

        default:
          return -1;
        }

    case 764:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4307; /* mve_vqmovnbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4317; /* mve_vqmovnbq_m_sv4si */

        default:
          return -1;
        }

    case 765:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4308; /* mve_vqmovnbq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4318; /* mve_vqmovnbq_m_uv4si */

        default:
          return -1;
        }

    case 792:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4309; /* mve_vqmovntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4319; /* mve_vqmovntq_m_sv4si */

        default:
          return -1;
        }

    case 791:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4310; /* mve_vqmovntq_m_uv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4320; /* mve_vqmovntq_m_uv4si */

        default:
          return -1;
        }

    case 740:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4311; /* mve_vqmovunbq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4321; /* mve_vqmovunbq_m_sv4si */

        default:
          return -1;
        }

    case 748:
      switch (pattern84 (x1))
        {
        case 0:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4312; /* mve_vqmovuntq_m_sv8hi */

        case 1:
          if (!
#line 2320 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4322; /* mve_vqmovuntq_m_sv4si */

        default:
          return -1;
        }

    case 793:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2337 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4323; /* mve_vmvnq_m_n_uv8hi */

        case 1:
          if (!
#line 2337 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4325; /* mve_vmvnq_m_n_uv4si */

        default:
          return -1;
        }

    case 794:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2337 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4324; /* mve_vmvnq_m_n_sv8hi */

        case 1:
          if (!
#line 2337 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4326; /* mve_vmvnq_m_n_sv4si */

        default:
          return -1;
        }

    case 609:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4327; /* mve_vbicq_m_n_sv8hi */

        case 1:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4331; /* mve_vbicq_m_n_sv4si */

        default:
          return -1;
        }

    case 610:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4328; /* mve_vbicq_m_n_uv8hi */

        case 1:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4332; /* mve_vbicq_m_n_uv4si */

        default:
          return -1;
        }

    case 772:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4329; /* mve_vorrq_m_n_sv8hi */

        case 1:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4333; /* mve_vorrq_m_n_sv4si */

        default:
          return -1;
        }

    case 773:
      switch (pattern85 (x1))
        {
        case 0:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4330; /* mve_vorrq_m_n_uv8hi */

        case 1:
          if (!
#line 2355 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4334; /* mve_vorrq_m_n_uv4si */

        default:
          return -1;
        }

    case 747:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2372 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4335; /* mve_vpselq_fv8hf */

        case 1:
          if (!
#line 2372 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4336; /* mve_vpselq_fv4sf */

        default:
          return -1;
        }

    case 732:
      if (pattern86 (x1, 
E_V8BImode, 
E_V8HFmode) != 0
          || !
#line 2389 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
        return -1;
      return 4337; /* mve_vrev32q_m_fv8hf */

    case 774:
      switch (pattern87 (x1))
        {
        case 0:
          if (!
#line 2406 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4338; /* mve_vrev32q_m_sv16qi */

        case 1:
          if (!
#line 2406 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4340; /* mve_vrev32q_m_sv8hi */

        default:
          return -1;
        }

    case 775:
      switch (pattern87 (x1))
        {
        case 0:
          if (!
#line 2406 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4339; /* mve_vrev32q_m_uv16qi */

        case 1:
          if (!
#line 2406 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4341; /* mve_vrev32q_m_uv8hi */

        default:
          return -1;
        }

    case 749:
      switch (pattern76 (x1))
        {
        case 0:
          if (!
#line 2423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4342; /* mve_vrev64q_m_fv8hf */

        case 1:
          if (!
#line 2423 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4343; /* mve_vrev64q_m_fv4sf */

        default:
          return -1;
        }

    case 757:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4344; /* mve_vrmlaldavhq_p_sv4si */

    case 816:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4345; /* mve_vrmlaldavhq_p_uv4si */

    case 758:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4346; /* mve_vrmlaldavhxq_p_sv4si */

    case 726:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4347; /* mve_vrmlsldavhq_p_sv4si */

    case 731:
      if (pattern88 (x1) != 0
          || !
#line 2443 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4348; /* mve_vrmlsldavhxq_p_sv4si */

    case 811:
      if (pattern86 (x1, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 2479 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4353; /* mve_vrev16q_m_sv16qi */

    case 812:
      if (pattern86 (x1, 
E_V16BImode, 
E_V16QImode) != 0
          || !
#line 2479 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4354; /* mve_vrev16q_m_uv16qi */

    case 814:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 2496 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4355; /* mve_vcvtq_m_from_f_uv8hi */

        case 1:
          if (!
#line 2496 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4357; /* mve_vcvtq_m_from_f_uv4si */

        default:
          return -1;
        }

    case 815:
      switch (pattern52 (x1, 
E_V8BImode, 
E_V8HFmode, 
E_V4BImode, 
E_V4SFmode))
        {
        case 0:
          if (!
#line 2496 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4356; /* mve_vcvtq_m_from_f_sv8hi */

        case 1:
          if (!
#line 2496 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4358; /* mve_vcvtq_m_from_f_sv4si */

        default:
          return -1;
        }

    case 1020:
      return recog_71 (x1, insn, pnum_clobbers);

    case 1022:
      return recog_78 (x1, insn, pnum_clobbers);

    case 1001:
      return recog_69 (x1, insn, pnum_clobbers);

    case 1003:
      return recog_87 (x1, insn, pnum_clobbers);

    case 999:
      return recog_74 (x1, insn, pnum_clobbers);

    case 1009:
      return recog_63 (x1, insn, pnum_clobbers);

    case 1014:
      return recog_73 (x1, insn, pnum_clobbers);

    case 1015:
      return recog_65 (x1, insn, pnum_clobbers);

    case 1025:
      return recog_72 (x1, insn, pnum_clobbers);

    case 1027:
      if (pattern93 (x1) != 0
          || !
#line 3678 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4931; /* mve_vstrq_truncate_scatter_shifted_offset_v4si */

    default:
      return -1;
    }
}

 int
recog_348 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 25
          || GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x8 = XVECEXP (x5, 0, 0);
      operands[1] = x8;
      if (!memory_operand (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5036 "../../gcc/config/arm/arm.md"
(unaligned_access && TARGET_32BIT)))
        return -1;
      return 6475; /* *p unaligned_loadhis */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x5;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      switch (GET_MODE (operands[0]))
        {
        case E_SImode:
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x4) != E_SImode)
            return -1;
          if (nonimmediate_operand (operands[1], E_HImode))
            {
              if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5927 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
                return 6494; /* *p *arm_extendhisi2 */
              if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5940 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && arm_arch6)))
                return 6495; /* *p *arm_extendhisi2_v6 */
            }
          if (arm_reg_or_extendqisi_mem_op (operands[1], E_QImode))
            {
              if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6021 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4 && !arm_arch6)))
                return 6497; /* *p *arm_extendqisi */
              if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 6034 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch6)))
                return 6498; /* *p *arm_extendqisi_v6 */
            }
          if (!nonimmediate_operand (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1094 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && arm_arch6)))
            return -1;
          return 6983; /* *p *thumb2_extendqisi_v6 */

        case E_HImode:
          if (!s_register_operand (operands[0], E_HImode)
              || GET_MODE (x4) != E_HImode
              || !arm_extendqisi_mem_op (operands[1], E_QImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 5984 "../../gcc/config/arm/arm.md"
(TARGET_ARM && arm_arch4)))
            return -1;
          return 6496; /* *p *arm_extendqihi_insn */

        default:
          return -1;
        }

    case BSWAP:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x1, 0);
      operands[2] = x6;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!s_register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      x9 = XEXP (x5, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_HImode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12555 "../../gcc/config/arm/arm.md"
(arm_arch6)))
        return -1;
      return 6604; /* *p *arm_revsh */

    case VEC_SELECT:
      x10 = XEXP (x5, 1);
      if (GET_CODE (x10) != PARALLEL
          || XVECLEN (x10, 0) != 1)
        return -1;
      x6 = XEXP (x1, 0);
      operands[3] = x6;
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (pattern543 (x5))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 736 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6727; /* *p iwmmxt_textrmsb */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 758 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6729; /* *p iwmmxt_textrmsh */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_357 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != FIX)
    return -1;
  x5 = XEXP (x2, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x6 = XEXP (x4, 0);
  switch (GET_CODE (x6))
    {
    case REG:
    case SUBREG:
      operands[1] = x6;
      x7 = XEXP (x1, 0);
      operands[2] = x7;
      x8 = XEXP (x7, 0);
      operands[3] = x8;
      switch (GET_MODE (x4))
        {
        case E_SFmode:
          if (!s_register_operand (operands[1], E_SFmode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1512 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT)))
            return -1;
          return 6949; /* *p *truncsisf2_vfp */

        case E_DFmode:
          if (!s_register_operand (operands[1], E_DFmode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1521 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP_DOUBLE)))
            return -1;
          return 6950; /* *p *truncsidf2_vfp */

        default:
          return -1;
        }

    case MULT:
      if (GET_MODE (x6) != E_SFmode)
        return -1;
      x7 = XEXP (x1, 0);
      operands[3] = x7;
      x8 = XEXP (x7, 0);
      operands[4] = x8;
      if (GET_MODE (x4) != E_SFmode)
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!s_register_operand (operands[1], E_SFmode))
        return -1;
      x10 = XEXP (x6, 1);
      operands[2] = x10;
      if (!const_double_vcvt_power_of_two (operands[2], E_VOIDmode)
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1895 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_VFP3 && !flag_rounding_math)))
        return -1;
      return 6971; /* *p *combine_vcvtf2i */

    default:
      return -1;
    }
}

 int
recog_361 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != MULT
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XEXP (x4, 1);
  if (!s_register_operand (x7, E_SImode))
    return -1;
  x8 = XEXP (x5, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[4] = x8;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x9 = XEXP (x6, 1);
      if (pattern563 (x9, 
LSHIFTRT, 
E_SImode, 
TRUNCATE, 
PLUS) != 0)
        return -1;
      x10 = XEXP (x9, 0);
      x11 = XEXP (x10, 0);
      x12 = XEXP (x11, 0);
      if (GET_CODE (x12) != PLUS
          || GET_MODE (x12) != E_DImode)
        return -1;
      x13 = XEXP (x12, 0);
      if (GET_CODE (x13) != MULT
          || GET_MODE (x13) != E_DImode)
        return -1;
      x14 = XEXP (x12, 1);
      if (GET_CODE (x14) != ZERO_EXTEND
          || GET_MODE (x14) != E_DImode)
        return -1;
      x15 = XEXP (x11, 1);
      if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 32])
        return -1;
      x16 = XEXP (x1, 0);
      operands[6] = x16;
      x17 = XEXP (x16, 0);
      operands[7] = x17;
      x18 = XEXP (x5, 1);
      operands[5] = x18;
      if (!s_register_operand (operands[5], E_SImode))
        return -1;
      operands[1] = x7;
      x19 = XEXP (x6, 0);
      operands[2] = x19;
      if (!s_register_operand (operands[2], E_SImode))
        return -1;
      x20 = XEXP (x13, 0);
      if (GET_MODE (x20) != E_DImode)
        return -1;
      x21 = XEXP (x13, 1);
      if (GET_MODE (x21) != E_DImode)
        return -1;
      x22 = XEXP (x9, 1);
      operands[3] = x22;
      if (!s_register_operand (operands[3], E_SImode))
        return -1;
      x23 = XEXP (x14, 0);
      if (!rtx_equal_p (x23, operands[1]))
        return -1;
      switch (GET_CODE (x20))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x21) != SIGN_EXTEND)
            return -1;
          x24 = XEXP (x20, 0);
          if (!rtx_equal_p (x24, operands[4]))
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[5])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2485 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6421; /* *p smlal */

        case ZERO_EXTEND:
          if (GET_CODE (x21) != ZERO_EXTEND)
            return -1;
          x24 = XEXP (x20, 0);
          if (!rtx_equal_p (x24, operands[4]))
            return -1;
          x25 = XEXP (x21, 0);
          if (!rtx_equal_p (x25, operands[5])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2485 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6422; /* *p umlal */

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x18 = XEXP (x5, 1);
      if (GET_CODE (x18) != SIGN_EXTEND
          || GET_MODE (x18) != E_SImode
          || pattern596 (x1, 
E_HImode) != 0)
        return -1;
      x26 = XEXP (x18, 0);
      operands[2] = x26;
      if (!s_register_operand (operands[2], E_HImode))
        return -1;
      operands[3] = x7;
      if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2618 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
        return -1;
      return 6430; /* *p arm_smlabb_setq */

    case ASHIFTRT:
      if (GET_MODE (x8) != E_SImode)
        return -1;
      x27 = XEXP (x8, 1);
      if (x27 != const_int_rtx[MAX_SAVED_CONST_INT + 16]
          || pattern596 (x1, 
E_SImode) != 0)
        return -1;
      x18 = XEXP (x5, 1);
      if (GET_MODE (x18) != E_SImode)
        return -1;
      operands[3] = x7;
      switch (GET_CODE (x18))
        {
        case SIGN_EXTEND:
          x26 = XEXP (x18, 0);
          operands[2] = x26;
          if (!s_register_operand (operands[2], E_HImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2666 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6432; /* *p arm_smlatb_setq */

        case ASHIFTRT:
          x28 = XEXP (x18, 1);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
            return -1;
          x26 = XEXP (x18, 0);
          operands[2] = x26;
          if (!s_register_operand (operands[2], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 2716 "../../gcc/config/arm/arm.md"
(TARGET_DSP_MULTIPLY)))
            return -1;
          return 6434; /* *p arm_smlatt_setq */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_377 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (XVECLEN (x1, 0))
    {
    case 1:
      switch (XINT (x1, 1))
        {
        case 0:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 305; /* blockage */

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 391; /* align_4 */

        case 12:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 392; /* align_8 */

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          return 393; /* consttable_end */

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 394; /* consttable_1 */

        case 6:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 395; /* consttable_2 */

        case 7:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 396; /* consttable_4 */

        case 8:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 397; /* consttable_8 */

        case 9:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          return 398; /* consttable_16 */

        case 16:
          if (pnum_clobbers == NULL)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!s_register_operand (operands[0], E_SImode))
            return -1;
          if (
#line 12275 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            {
              *pnum_clobbers = 1;
              return 404; /* arm_eh_return */
            }
          if (
#line 2096 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            {
              *pnum_clobbers = 1;
              return 1005; /* thumb_eh_return */
            }
          if (!
#line 1239 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          *pnum_clobbers = 1;
          return 1051; /* thumb2_eh_return */

        case 51:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 13090 "../../gcc/config/arm/arm.md"
(arm_arch7 || arm_arch8))
            return -1;
          return 513; /* *speculation_barrier_insn */

        case 60:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 13121 "../../gcc/config/arm/arm.md"
(arm_arch8m_main))
            return -1;
          return 517; /* bti_nop */

        case 56:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != MEM
              || GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 1725 "../../gcc/config/arm/vfp.md"
(use_cmse && reload_completed))
            return -1;
          return 859; /* lazy_store_multiple_insn */

        case 57:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != MEM
              || GET_MODE (x2) != E_BLKmode)
            return -1;
          x3 = XEXP (x2, 0);
          operands[0] = x3;
          if (!s_register_operand (operands[0], E_SImode)
              || !
#line 1735 "../../gcc/config/arm/vfp.md"
(use_cmse && reload_completed))
            return -1;
          return 860; /* lazy_load_multiple_insn */

        case 30:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!register_operand (operands[0], E_SImode)
              || !
#line 2116 "../../gcc/config/arm/vfp.md"
(TARGET_VFP_BASE))
            return -1;
          return 925; /* set_fpscr */

        case 2:
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 2028 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 1001; /* prologue_thumb1_interwork */

        case 1:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != RETURN
              || !
#line 2036 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 1002; /* *epilogue_insns */

        case 54:
          if (pnum_clobbers == NULL
              || GET_MODE (x1) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
              || !
#line 1699 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && TARGET_HAVE_FPCXT_CMSE && use_cmse))
            return -1;
          *pnum_clobbers = 1;
          return 1070; /* *clear_apsr */

        default:
          return -1;
        }

    case 6:
      x2 = XVECEXP (x1, 0, 0);
      operands[0] = x2;
      if (!immediate_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      operands[1] = x4;
      if (!immediate_operand (operands[1], E_SImode))
        return -1;
      x5 = XVECEXP (x1, 0, 2);
      operands[2] = x5;
      if (!immediate_operand (operands[2], E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      operands[3] = x6;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x7 = XVECEXP (x1, 0, 4);
      operands[4] = x7;
      if (!immediate_operand (operands[4], E_SImode))
        return -1;
      x8 = XVECEXP (x1, 0, 5);
      operands[5] = x8;
      if (!immediate_operand (operands[5], E_SImode))
        return -1;
      switch (XINT (x1, 1))
        {
        case 33:
          if (!
#line 12948 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_CDP)))
            return -1;
          return 495; /* arm_cdp */

        case 34:
          if (!
#line 12948 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_CDP2)))
            return -1;
          return 496; /* arm_cdp2 */

        default:
          return -1;
        }

    case 3:
      switch (XINT (x1, 1))
        {
        case 35:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDC)))
            return -1;
          return 497; /* *ldc */

        case 36:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDC2)))
            return -1;
          return 498; /* *ldc */

        case 37:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDCL)))
            return -1;
          return 499; /* *ldc */

        case 38:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12965 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_LDC2L)))
            return -1;
          return 500; /* *ldc */

        case 39:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STC)))
            return -1;
          return 501; /* *stc */

        case 40:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STC2)))
            return -1;
          return 502; /* *stc */

        case 41:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STCL)))
            return -1;
          return 503; /* *stc */

        case 42:
          x2 = XVECEXP (x1, 0, 0);
          operands[0] = x2;
          if (!immediate_operand (operands[0], E_SImode))
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          operands[1] = x4;
          if (!immediate_operand (operands[1], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          operands[2] = x5;
          if (!memory_operand (operands[2], E_SImode)
              || !
#line 12978 "../../gcc/config/arm/arm.md"
(arm_coproc_builtin_available (VUNSPEC_STC2L)))
            return -1;
          return 504; /* *stc */

        case 59:
          if (GET_MODE (x1) != E_SImode)
            return -1;
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != REG
              || REGNO (x2) != 12
              || GET_MODE (x2) != E_SImode)
            return -1;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != REG
              || REGNO (x4) != 13
              || GET_MODE (x4) != E_SImode)
            return -1;
          x5 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 14
              || GET_MODE (x5) != E_SImode
              || !
#line 13115 "../../gcc/config/arm/arm.md"
(arm_arch8m_main))
            return -1;
          return 516; /* aut_nop */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_6 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) == E_SImode)
    {
      res = split_5 (x1, insn);
      if (res != NULL_RTX)
        return res;
    }
  operands[1] = x3;
  if (!logical_binary_operator (operands[1], E_SImode))
    return NULL;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[8] = x5;
  if (!s_register_operand (operands[8], E_SImode))
    return NULL;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case ZERO_EXTRACT:
      if (pattern547 (x3, 
LSHIFTRT) != 0
          || !
#line 3949 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
        return NULL;
      return gen_split_18 (insn, operands);

    case AND:
    case IOR:
    case XOR:
      operands[9] = x6;
      if (!logical_binary_operator (operands[9], E_SImode))
        return NULL;
      x7 = XEXP (x6, 0);
      if (GET_MODE (x7) != E_SImode)
        return NULL;
      x8 = XEXP (x6, 1);
      operands[7] = x8;
      if (!s_register_operand (operands[7], E_SImode))
        return NULL;
      x9 = XEXP (x3, 1);
      if (GET_MODE (x9) != E_SImode)
        return NULL;
      switch (GET_CODE (x7))
        {
        case LSHIFTRT:
          if (pattern607 (x3, 
ZERO_EXTRACT) != 0
              || !
#line 3975 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
            return NULL;
          return gen_split_19 (insn, operands);

        case ASHIFTRT:
          if (pattern607 (x3, 
SIGN_EXTRACT) != 0
              || !
#line 4027 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
            return NULL;
          return gen_split_21 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      if (pattern547 (x3, 
ASHIFTRT) != 0
          || !
#line 4001 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && GET_CODE (operands[1]) == GET_CODE (operands[9])
   && INTVAL (operands[3]) == 32 - INTVAL (operands[6])))
        return NULL;
      return gen_split_20 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_10 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          switch (GET_CODE (x3))
            {
            case MINUS:
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            case PLUS:
            case AND:
            case IOR:
            case XOR:
              res = split_7 (x1, insn);
              if (res != NULL_RTX)
                return res;
              break;

            default:
              break;
            }
          operands[1] = x3;
          if (!shiftable_operator (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x4, 0);
          if (!s_register_operand (x6, E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case ZERO_EXTRACT:
              if (pattern475 (x1) != 0
                  || !
#line 3248 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return NULL;
              return gen_split_11 (insn, operands);

            case SIGN_EXTRACT:
              if (pattern475 (x1) != 0
                  || !
#line 3270 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return NULL;
              return gen_split_12 (insn, operands);

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[2] = x7;
              if (!shiftable_operator (operands[2], E_SImode))
                return NULL;
              x8 = XEXP (x7, 0);
              if (!shift_operator (x8, E_SImode))
                return NULL;
              operands[3] = x8;
              x9 = XEXP (x8, 0);
              operands[4] = x9;
              if (!s_register_operand (operands[4], E_SImode))
                return NULL;
              x10 = XEXP (x8, 1);
              operands[5] = x10;
              if (!reg_or_int_operand (operands[5], E_SImode))
                return NULL;
              x11 = XEXP (x7, 1);
              operands[6] = x11;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x12 = XEXP (x3, 1);
              operands[7] = x12;
              if (!arm_rhs_operand (operands[7], E_SImode))
                return NULL;
              operands[8] = x6;
              if (!
#line 9717 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
                return NULL;
              return gen_split_77 (insn, operands);

            default:
              return NULL;
            }

        case IF_THEN_ELSE:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case LTGT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNEQ:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              x11 = XEXP (x7, 1);
              if (x11 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  && pattern255 (x1) == 0)
                {
                  x8 = XEXP (x7, 0);
                  if (GET_MODE (x8) == E_SImode)
                    {
                      if (GET_CODE (x8) == ZERO_EXTRACT)
                        {
                          res = split_8 (x1, insn);
                          if (res != NULL_RTX)
                            return res;
                        }
                      if (GET_CODE (x8) == PLUS)
                        {
                          operands[5] = x7;
                          if (comparison_operator (operands[5], E_VOIDmode)
                              && pattern575 (x3) == 0
                              && (
#line 10767 "../../gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 10769 "../../gcc/config/arm/arm.md"
( reload_completed)))
                            return gen_split_95 (insn, operands);
                        }
                    }
                }
              if (!arm_comparison_operator (x7, E_VOIDmode))
                return NULL;
              operands[1] = x7;
              if (pattern255 (x1) != 0)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[2] = x8;
              operands[3] = x11;
              x13 = XEXP (x3, 2);
              operands[4] = x13;
              x12 = XEXP (x3, 1);
              if (rtx_equal_p (x12, operands[0])
                  && 
#line 11710 "../../gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return gen_split_100 (insn, operands);
              operands[4] = x12;
              if (rtx_equal_p (x13, operands[0])
                  && 
#line 11738 "../../gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return gen_split_101 (insn, operands);
              operands[5] = x13;
              if (
#line 11759 "../../gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return gen_split_102 (insn, operands);
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || GET_CODE (x13) != NOT
                  || GET_MODE (x13) != E_SImode
                  || !s_register_operand (operands[2], E_SImode)
                  || !arm_add_operand (operands[3], E_SImode))
                return NULL;
              x14 = XEXP (x13, 0);
              operands[5] = x14;
              if (!s_register_operand (operands[5], E_SImode)
                  || !
#line 11791 "../../gcc/config/arm/arm.md"
(TARGET_ARM && reload_completed))
                return NULL;
              return gen_split_103 (insn, operands);

            default:
              return NULL;
            }

        case SMAX:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4092 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_22 (insn, operands);
          if (!
#line 37 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_134 (insn, operands);

        case SMIN:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4142 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_23 (insn, operands);
          if (!
#line 58 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_135 (insn, operands);

        case UMAX:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4175 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_24 (insn, operands);
          if (!
#line 79 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_136 (insn, operands);

        case UMIN:
          if (pattern254 (x1) != 0)
            return NULL;
          if (
#line 4208 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return gen_split_25 (insn, operands);
          if (!
#line 100 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed))
            return NULL;
          return gen_split_137 (insn, operands);

        case ABS:
          if (pattern14 (x1) != 0)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x4, 0);
          if (GET_CODE (x6) == REG
              && REGNO (x6) == 100
              && GET_MODE (x6) == E_CCmode)
            {
              if ((
#line 5255 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5257 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_27 (insn, operands);
              if ((
#line 117 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 122 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                return gen_split_138 (insn, operands);
            }
          operands[2] = x6;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 336 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed))
            return NULL;
          return gen_split_116 (insn, operands);

        case NEG:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          switch (GET_CODE (x7))
            {
            case ABS:
              if (GET_MODE (x7) != E_SImode)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) == REG
                  && REGNO (x6) == 100
                  && GET_MODE (x6) == E_CCmode)
                {
                  if ((
#line 5319 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 5321 "../../gcc/config/arm/arm.md"
( reload_completed)))
                    return gen_split_28 (insn, operands);
                  if ((
#line 170 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 175 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                    return gen_split_139 (insn, operands);
                }
              operands[2] = x6;
              if (!scratch_operand (operands[2], E_SImode)
                  || !
#line 351 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1 && reload_completed))
                return NULL;
              return gen_split_117 (insn, operands);

            case NE:
            case EQ:
            case GE:
            case GT:
            case LE:
            case LT:
            case GEU:
            case GTU:
            case LEU:
            case LTU:
            case UNORDERED:
            case ORDERED:
            case UNGE:
            case UNGT:
            case UNLE:
            case UNLT:
              operands[3] = x7;
              if (!arm_comparison_operator (operands[3], E_VOIDmode))
                return NULL;
              x6 = XEXP (x4, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 100
                  || GET_MODE (x6) != E_CCmode)
                return NULL;
              x8 = XEXP (x7, 0);
              operands[1] = x8;
              if (!s_register_operand (operands[1], E_SImode))
                return NULL;
              x11 = XEXP (x7, 1);
              operands[2] = x11;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return NULL;
              if ((
#line 10692 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 10694 "../../gcc/config/arm/arm.md"
( reload_completed)))
                return gen_split_94 (insn, operands);
              if (!(
#line 899 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH) && 
#line 901 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
                return NULL;
              return gen_split_150 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x7 = XEXP (x3, 0);
          if (GET_CODE (x7) != SUBREG)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!s_register_operand (operands[0], E_SImode)
              || GET_MODE (x7) != E_QImode)
            return NULL;
          x8 = XEXP (x7, 0);
          operands[1] = x8;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!s_register_operand (operands[2], E_SImode))
            return NULL;
          switch (SUBREG_BYTE (x7))
            {
            case 0:
              if (!
#line 5791 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && (!MEM_P (operands[1])) && ! BYTES_BIG_ENDIAN))
                return NULL;
              return gen_split_33 (insn, operands);

            case 3:
              if (!
#line 5801 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && (!MEM_P (operands[1])) && BYTES_BIG_ENDIAN))
                return NULL;
              return gen_split_34 (insn, operands);

            default:
              return NULL;
            }

        case SIGN_EXTEND:
          if (GET_MODE (x3) != E_SImode)
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x4) != CLOBBER)
            return NULL;
          x5 = XEXP (x2, 0);
          operands[0] = x5;
          if (!register_operand (operands[0], E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_HImode))
            return NULL;
          x6 = XEXP (x4, 0);
          operands[2] = x6;
          if (!scratch_operand (operands[2], E_SImode)
              || !
#line 5870 "../../gcc/config/arm/arm.md"
(!arm_arch6))
            return NULL;
          return gen_split_37 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (pattern255 (x1) != 0)
            return NULL;
          if (GET_MODE (x3) == E_SImode)
            {
              res = split_9 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x3;
          if (!arm_comparison_operator (operands[1], E_SImode))
            return NULL;
          x7 = XEXP (x3, 0);
          operands[2] = x7;
          if (!s_register_operand (operands[2], E_SImode))
            return NULL;
          x12 = XEXP (x3, 1);
          operands[3] = x12;
          if (!arm_add_operand (operands[3], E_SImode)
              || !(
#line 9952 "../../gcc/config/arm/arm.md"
(TARGET_32BIT) && 
#line 9954 "../../gcc/config/arm/arm.md"
( reload_completed)))
            return NULL;
          return gen_split_86 (insn, operands);

        case COMPARE:
          x7 = XEXP (x3, 0);
          if (GET_MODE (x7) != E_SImode)
            return NULL;
          switch (GET_CODE (x7))
            {
            case IOR:
              x12 = XEXP (x3, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x8 = XEXP (x7, 0);
              switch (GET_CODE (x8))
                {
                case NE:
                case EQ:
                case GE:
                case GT:
                case LE:
                case LT:
                case GEU:
                case GTU:
                case LEU:
                case LTU:
                case UNORDERED:
                case ORDERED:
                case UNGE:
                case UNGT:
                case UNLE:
                case UNLT:
                  if (!arm_comparison_operator (x8, E_SImode))
                    return NULL;
                  x9 = XEXP (x8, 0);
                  if (!s_register_operand (x9, E_SImode))
                    return NULL;
                  x10 = XEXP (x8, 1);
                  if (!arm_add_operand (x10, E_SImode))
                    return NULL;
                  x11 = XEXP (x7, 1);
                  switch (GET_CODE (x11))
                    {
                    case NE:
                    case EQ:
                    case GE:
                    case GT:
                    case LE:
                    case LT:
                    case GEU:
                    case GTU:
                    case LEU:
                    case LTU:
                    case UNORDERED:
                    case ORDERED:
                    case UNGE:
                    case UNGT:
                    case UNLE:
                    case UNLT:
                      operands[6] = x11;
                      if (!arm_comparison_operator (operands[6], E_SImode))
                        return NULL;
                      x4 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x4) != SET)
                        return NULL;
                      x15 = XEXP (x4, 1);
                      if (GET_CODE (x15) != IOR
                          || GET_MODE (x15) != E_SImode)
                        return NULL;
                      x16 = XEXP (x15, 0);
                      switch (GET_CODE (x16))
                        {
                        case NE:
                        case EQ:
                        case GE:
                        case GT:
                        case LE:
                        case LT:
                        case GEU:
                        case GTU:
                        case LEU:
                        case LTU:
                        case UNORDERED:
                        case ORDERED:
                        case UNGE:
                        case UNGT:
                        case UNLE:
                        case UNLT:
                          x17 = XEXP (x15, 1);
                          switch (GET_CODE (x17))
                            {
                            case NE:
                            case EQ:
                            case GE:
                            case GT:
                            case LE:
                            case LT:
                            case GEU:
                            case GTU:
                            case LEU:
                            case LTU:
                            case UNORDERED:
                            case ORDERED:
                            case UNGE:
                            case UNGT:
                            case UNLE:
                            case UNLT:
                              if (!rtx_equal_p (x17, operands[6]))
                                return NULL;
                              x5 = XEXP (x2, 0);
                              operands[0] = x5;
                              if (!dominant_cc_register (operands[0], E_VOIDmode))
                                return NULL;
                              operands[3] = x8;
                              operands[1] = x9;
                              operands[2] = x10;
                              x18 = XEXP (x11, 0);
                              operands[4] = x18;
                              if (!s_register_operand (operands[4], E_SImode))
                                return NULL;
                              x19 = XEXP (x11, 1);
                              operands[5] = x19;
                              if (!arm_add_operand (operands[5], E_SImode))
                                return NULL;
                              x6 = XEXP (x4, 0);
                              operands[7] = x6;
                              if (!s_register_operand (operands[7], E_SImode)
                                  || !rtx_equal_p (x16, operands[3])
                                  || !
#line 10532 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                                return NULL;
                              return gen_split_88 (insn, operands);

                            default:
                              return NULL;
                            }

                        default:
                          return NULL;
                        }

                    case AND:
                      if (GET_MODE (x11) != E_SImode)
                        return NULL;
                      x19 = XEXP (x11, 1);
                      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                        return NULL;
                      x5 = XEXP (x2, 0);
                      if (GET_CODE (x5) != REG
                          || REGNO (x5) != 100
                          || GET_MODE (x5) != E_CC_NZmode)
                        return NULL;
                      x4 = XVECEXP (x1, 0, 1);
                      if (GET_CODE (x4) != CLOBBER
                          || GET_MODE (x3) != E_CC_NZmode)
                        return NULL;
                      operands[1] = x8;
                      operands[2] = x9;
                      operands[3] = x10;
                      x18 = XEXP (x11, 0);
                      operands[0] = x18;
                      if (!s_register_operand (operands[0], E_SImode))
                        return NULL;
                      x6 = XEXP (x4, 0);
                      operands[4] = x6;
                      if (!s_register_operand (operands[4], E_SImode)
                          || !
#line 10676 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                        return NULL;
                      return gen_split_93 (insn, operands);

                    default:
                      return NULL;
                    }

                case AND:
                  if (GET_MODE (x8) != E_SImode)
                    return NULL;
                  x10 = XEXP (x8, 1);
                  if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                    return NULL;
                  x11 = XEXP (x7, 1);
                  if (!arm_comparison_operator (x11, E_SImode))
                    return NULL;
                  operands[1] = x11;
                  if (pattern444 (x1, 
E_CC_NZmode) != 0
                      || !s_register_operand (operands[0], E_SImode))
                    return NULL;
                  x18 = XEXP (x11, 0);
                  operands[2] = x18;
                  if (!s_register_operand (operands[2], E_SImode))
                    return NULL;
                  x19 = XEXP (x11, 1);
                  operands[3] = x19;
                  if (!arm_add_operand (operands[3], E_SImode))
                    return NULL;
                  x4 = XVECEXP (x1, 0, 1);
                  x6 = XEXP (x4, 0);
                  operands[4] = x6;
                  if (!s_register_operand (operands[4], E_SImode)
                      || !
#line 10657 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                    return NULL;
                  return gen_split_92 (insn, operands);

                default:
                  return NULL;
                }

            case AND:
              x8 = XEXP (x7, 0);
              if (!arm_comparison_operator (x8, E_SImode))
                return NULL;
              operands[3] = x8;
              x11 = XEXP (x7, 1);
              if (!arm_comparison_operator (x11, E_SImode))
                return NULL;
              operands[6] = x11;
              x12 = XEXP (x3, 1);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
                  || pattern383 (x1, 
AND) != 0
                  || !
#line 10596 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                return NULL;
              return gen_split_90 (insn, operands);

            case ASHIFT:
              x8 = XEXP (x7, 0);
              if (GET_CODE (x8) != SUBREG
                  || maybe_ne (SUBREG_BYTE (x8), 0)
                  || GET_MODE (x8) != E_SImode)
                return NULL;
              x11 = XEXP (x7, 1);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 24]
                  || pattern444 (x1, 
E_CC_Zmode) != 0
                  || !memory_operand (operands[0], E_QImode))
                return NULL;
              x12 = XEXP (x3, 1);
              operands[1] = x12;
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x4 = XVECEXP (x1, 0, 1);
              x6 = XEXP (x4, 0);
              operands[2] = x6;
              if (!scratch_operand (operands[2], E_SImode)
                  || !
#line 11609 "../../gcc/config/arm/arm.md"
(TARGET_ARM
   && ((UINTVAL (operands[1]))
       == ((UINTVAL (operands[1])) >> 24) << 24)))
                return NULL;
              return gen_split_99 (insn, operands);

            default:
              return NULL;
            }

        case CONST_DOUBLE:
          switch (pattern15 (x1))
            {
            case 0:
              if (!(
#line 2142 "../../gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !arm_const_double_rtx (operands[1])
   && !(TARGET_VFP_DOUBLE && vfp3_const_double_rtx (operands[1]))) && 
#line 2147 "../../gcc/config/arm/vfp.md"
( 1)))
                return NULL;
              return gen_split_111 (insn, operands);

            case 1:
              if (!(
#line 2169 "../../gcc/config/arm/vfp.md"
(arm_disable_literal_pool
   && TARGET_VFP_BASE
   && !vfp3_const_double_rtx (operands[1])) && 
#line 2173 "../../gcc/config/arm/vfp.md"
( 1)))
                return NULL;
              return gen_split_112 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTRACT:
          if (pattern14 (x1) != 0)
            return NULL;
          x12 = XEXP (x3, 1);
          operands[2] = x12;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          x13 = XEXP (x3, 2);
          operands[3] = x13;
          if (!const_int_operand (operands[3], E_SImode))
            return NULL;
          x4 = XVECEXP (x1, 0, 1);
          x6 = XEXP (x4, 0);
          operands[4] = x6;
          if (!s_register_operand (operands[4], E_SImode)
              || !
#line 204 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return NULL;
          return gen_split_114 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x2, 0) != 1
          || XINT (x2, 1) != 16)
        return NULL;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != CLOBBER)
        return NULL;
      x20 = XVECEXP (x2, 0, 0);
      operands[0] = x20;
      if (!s_register_operand (operands[0], E_SImode))
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      if (!scratch_operand (operands[1], E_SImode))
        return NULL;
      if ((
#line 12275 "../../gcc/config/arm/arm.md"
(TARGET_ARM) && 
#line 12277 "../../gcc/config/arm/arm.md"
( reload_completed)))
        return gen_split_105 (insn, operands);
      if ((
#line 2096 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1) && 
#line 2098 "../../gcc/config/arm/thumb1.md"
( reload_completed)))
        return gen_split_133 (insn, operands);
      if (!(
#line 1239 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2) && 
#line 1241 "../../gcc/config/arm/thumb2.md"
( reload_completed)))
        return NULL;
      return gen_split_151 (insn, operands);

    default:
      return NULL;
    }
}
