/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != i1
      || GET_MODE (x2) != i1)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  switch (GET_CODE (x6))
    {
    case PLUS:
      if (GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x6, 0);
      operands[3] = x7;
      if (!arm_borrow_operation (operands[3], E_DImode))
        return -1;
      return 0;

    case GEU:
    case LTU:
      operands[2] = x6;
      if (!arm_borrow_operation (operands[2], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern17 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != USE)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XVECEXP (x3, 0, 0);
  operands[0] = x4;
  if (!immediate_operand (operands[0], E_SImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[1] = x5;
  if (!immediate_operand (operands[1], E_SImode))
    return -1;
  x6 = XVECEXP (x3, 0, 2);
  operands[2] = x6;
  if (!s_register_operand (operands[2], i1))
    return -1;
  x7 = XVECEXP (x3, 0, 3);
  operands[3] = x7;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern29 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!s_register_operand (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern36 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V4HImode:
      return pattern32 (x3, 
E_V4HImode); /* [-1, 0] */

    case E_V2SImode:
      if (pattern32 (x3, 
E_V2SImode) != 0)
        return -1;
      return 1;

    case E_V8HImode:
      if (pattern32 (x3, 
E_V8HImode) != 0)
        return -1;
      return 2;

    case E_V4SImode:
      if (pattern32 (x3, 
E_V4SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SImode)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!register_operand (operands[0], E_V4SImode))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_V4SImode))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!register_operand (operands[2], E_V4SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 2);
  operands[3] = x6;
  if (!register_operand (operands[3], E_V4SImode))
    return -1;
  return 0;
}

int
pattern54 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], E_V16QImode)
      || GET_MODE (x1) != E_V16QImode
      || !s_register_operand (operands[1], E_V16QImode)
      || !s_register_operand (operands[2], i1)
      || !mve_imm_8 (operands[3], E_SImode))
    return -1;
  return 0;
}

int
pattern60 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern59 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern59 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern59 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    case E_V2DImode:
      if (pattern59 (x3, 
E_V2QImode, 
E_V2DImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern81 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_HFmode:
      return pattern51 (x3, 
E_V8BImode, 
E_V8HFmode, 
E_HFmode); /* [-1, 0] */

    case E_SFmode:
      if (pattern51 (x3, 
E_V4BImode, 
E_V4SFmode, 
E_SFmode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern90 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != MEM
      || GET_MODE (x4) != E_BLKmode)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != SCRATCH)
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[1] = x7;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  return 0;
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V2SFmode:
      if (!s_register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern112 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HFmode:
      if (!s_register_operand (operands[0], E_V8HFmode)
          || GET_MODE (x1) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode))
        return -1;
      return 0;

    case E_V4SFmode:
      if (!s_register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern117 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || !s_register_operand (operands[1], i1))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || !s_register_operand (operands[1], i2))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern126 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern125 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern125 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern125 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern125 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern125 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern125 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern138 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern41 (x3, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern41 (x3, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern41 (x3, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern41 (x3, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern41 (x3, 
E_V4SImode) != 0)
        return -1;
      return 5;

    case E_DImode:
      if (pattern41 (x3, 
E_DImode) != 0)
        return -1;
      return 6;

    case E_V2DImode:
      if (pattern41 (x3, 
E_V2DImode) != 0)
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern154 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i2)
    return -1;
  x3 = XEXP (x1, 0);
  operands[0] = x3;
  if (!s_register_operand (operands[0], i2))
    return -1;
  x4 = XVECEXP (x2, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], i1))
    return -1;
  x5 = XVECEXP (x2, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern160 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (x3))
    {
    case E_V8QImode:
      return 0;

    case E_V4HImode:
      return 1;

    case E_V4HFmode:
      return 2;

    case E_V4BFmode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V2SFmode:
      return 5;

    case E_DImode:
      return 6;

    default:
      return -1;
    }
}

int
pattern169 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_DImode))
    return -1;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!s_register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode)
        return -1;
      return 0;

    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode)
        return -1;
      return 1;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode)
        return -1;
      return 2;

    case E_V2DImode:
      if (!s_register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  if (!immediate_operand (operands[2], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  if (!immediate_operand (operands[4], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SImode:
      return pattern34 (x3, 
E_V4HImode, 
E_V4SImode); /* [-1, 0] */

    case E_V2DImode:
      if (pattern34 (x3, 
E_V2SImode, 
E_V2DImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern210 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern209 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern209 (x3, 
E_V8BImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern209 (x3, 
E_V4BImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  x6 = XVECEXP (x3, 0, 2);
  operands[3] = x6;
  x7 = XVECEXP (x3, 0, 3);
  operands[4] = x7;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern205 (x3, 
E_V16BImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern201 (x3, 
E_V8BImode, 
E_V8HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern206 (x3, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern231 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_BLKmode)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != SCRATCH)
    return -1;
  x5 = XVECEXP (x2, 0, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_SImode))
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  operands[1] = x6;
  x7 = XVECEXP (x2, 0, 2);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 3);
  operands[3] = x8;
  return 0;
}

int
pattern243 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (XVECLEN (x2, 0))
    {
    case 1:
      if (XINT (x2, 1) != 25
          || GET_MODE (x2) != E_HImode
          || !s_register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      return 0;

    case 3:
      x4 = XVECEXP (x2, 0, 2);
      if (GET_CODE (x4) != MEM
          || GET_MODE (x4) != E_BLKmode)
        return -1;
      x5 = XEXP (x4, 0);
      if (GET_CODE (x5) != SCRATCH)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      switch (XINT (x2, 1))
        {
        case 1011:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x1) != E_V8HImode
                  || GET_MODE (x2) != E_V8QImode
                  || !s_register_operand (operands[2], E_V8HImode))
                return -1;
              return 1;

            case E_V4SImode:
              if (!s_register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x1) != E_V4SImode
                  || !s_register_operand (operands[2], E_V4SImode))
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4QImode:
                  return 2;

                case E_V4HImode:
                  return 3;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1017:
          if (GET_MODE (x2) != E_V4HImode
              || !s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !s_register_operand (operands[2], E_V4SImode))
            return -1;
          return 4;

        default:
          return -1;
        }

    case 4:
      x7 = XVECEXP (x2, 0, 3);
      if (GET_CODE (x7) != MEM
          || GET_MODE (x7) != E_BLKmode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != SCRATCH)
        return -1;
      x3 = XVECEXP (x2, 0, 0);
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x6 = XVECEXP (x2, 0, 1);
      operands[2] = x6;
      x4 = XVECEXP (x2, 0, 2);
      operands[3] = x4;
      switch (XINT (x2, 1))
        {
        case 1012:
          switch (GET_MODE (operands[0]))
            {
            case E_V8HImode:
              if (!s_register_operand (operands[0], E_V8HImode)
                  || GET_MODE (x1) != E_V8HImode
                  || GET_MODE (x2) != E_V8QImode
                  || !s_register_operand (operands[2], E_V8HImode)
                  || !vpr_register_operand (operands[3], E_V8BImode))
                return -1;
              return 5;

            case E_V4SImode:
              if (!s_register_operand (operands[0], E_V4SImode)
                  || GET_MODE (x1) != E_V4SImode
                  || !s_register_operand (operands[2], E_V4SImode)
                  || !vpr_register_operand (operands[3], E_V4BImode))
                return -1;
              switch (GET_MODE (x2))
                {
                case E_V4QImode:
                  return 6;

                case E_V4HImode:
                  return 7;

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1018:
          if (GET_MODE (x2) != E_V4HImode
              || !s_register_operand (operands[0], E_V4SImode)
              || GET_MODE (x1) != E_V4SImode
              || !s_register_operand (operands[2], E_V4SImode)
              || !vpr_register_operand (operands[3], E_V4BImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern282 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      return pattern281 (x1, 
E_V8QImode); /* [-1, 0] */

    case E_V16QImode:
      if (pattern281 (x1, 
E_V16QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern281 (x1, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V8HImode:
      if (pattern281 (x1, 
E_V8HImode) != 0)
        return -1;
      return 3;

    case E_V2SImode:
      if (pattern281 (x1, 
E_V2SImode) != 0)
        return -1;
      return 4;

    case E_V4SImode:
      if (pattern281 (x1, 
E_V4SImode) != 0)
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern290 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  if (!arm_add_operand (operands[2], E_SImode))
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  if (!s_register_operand (operands[4], E_SImode))
    return -1;
  x7 = XEXP (x5, 1);
  operands[5] = x7;
  if (!arm_add_operand (operands[5], E_SImode))
    return -1;
  return 0;
}

int
pattern301 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8QImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4QImode:
          if (!mve_memory_operand (operands[1], E_V4QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!mve_memory_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern312 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[3] = x2;
  x3 = XEXP (x2, 0);
  operands[4] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      return pattern310 (x6, 
E_SImode); /* [-1, 0] */

    case E_V8QImode:
      if (pattern311 (x6, 
E_V8QImode) != 0)
        return -1;
      return 1;

    case E_V4HImode:
      if (pattern311 (x6, 
E_V4HImode) != 0)
        return -1;
      return 2;

    case E_V2SImode:
      if (pattern311 (x6, 
E_V2SImode) != 0)
        return -1;
      return 3;

    case E_V4QQmode:
      if (pattern310 (x6, 
E_V4QQmode) != 0)
        return -1;
      return 4;

    case E_V2HQmode:
      if (pattern310 (x6, 
E_V2HQmode) != 0)
        return -1;
      return 5;

    case E_QQmode:
      if (pattern310 (x6, 
E_QQmode) != 0)
        return -1;
      return 6;

    case E_HQmode:
      if (pattern310 (x6, 
E_HQmode) != 0)
        return -1;
      return 7;

    case E_V2HAmode:
      if (pattern310 (x6, 
E_V2HAmode) != 0)
        return -1;
      return 8;

    case E_HAmode:
      if (pattern310 (x6, 
E_HAmode) != 0)
        return -1;
      return 9;

    case E_SQmode:
      if (pattern310 (x6, 
E_SQmode) != 0)
        return -1;
      return 10;

    case E_SAmode:
      if (pattern310 (x6, 
E_SAmode) != 0)
        return -1;
      return 11;

    default:
      return -1;
    }
}

int
pattern335 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 101
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!s_register_operand (operands[0], E_V4SImode))
    return -1;
  x6 = XEXP (x4, 1);
  x7 = XVECEXP (x6, 0, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_V4SImode))
    return -1;
  x8 = XVECEXP (x6, 0, 1);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_V4SImode))
    return -1;
  x9 = XVECEXP (x6, 0, 2);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_V4SImode))
    return -1;
  x10 = XVECEXP (x6, 0, 3);
  operands[4] = x10;
  if (!vpr_register_operand (operands[4], E_V4BImode))
    return -1;
  return 0;
}

int
pattern346 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V8HImode:
      if (!s_register_operand (operands[0], E_V8HImode)
          || GET_MODE (x1) != E_V8HImode
          || GET_MODE (x2) != E_V8HImode
          || !mve_memory_operand (operands[1], E_V8QImode)
          || !vpr_register_operand (operands[2], E_V8BImode))
        return -1;
      return 0;

    case E_V4SImode:
      if (!s_register_operand (operands[0], E_V4SImode)
          || GET_MODE (x1) != E_V4SImode
          || GET_MODE (x2) != E_V4SImode
          || !vpr_register_operand (operands[2], E_V4BImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_V4QImode:
          if (!mve_memory_operand (operands[1], E_V4QImode))
            return -1;
          return 1;

        case E_V4HImode:
          if (!mve_memory_operand (operands[1], E_V4HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern362 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || !vfp_compare_operand (operands[1], E_SFmode))
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || !vfp_compare_operand (operands[1], E_DFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern372 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1)
      || !neon_logic_op2 (operands[2], i1))
    return -1;
  return 0;
}

int
pattern378 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x1, 0);
  operands[3] = x5;
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return pattern377 (x3); /* [-1, 4] */
}

int
pattern383 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      if (!rtx_equal_p (x4, operands[3]))
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          if (!rtx_equal_p (x5, operands[6]))
            return -1;
          x6 = XVECEXP (x1, 0, 0);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          if (!dominant_cc_register (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x6, 1);
          x9 = XEXP (x8, 0);
          x10 = XEXP (x9, 0);
          x11 = XEXP (x10, 0);
          operands[1] = x11;
          if (!s_register_operand (operands[1], E_SImode))
            return -1;
          x12 = XEXP (x10, 1);
          operands[2] = x12;
          if (!arm_add_operand (operands[2], E_SImode))
            return -1;
          x13 = XEXP (x9, 1);
          x14 = XEXP (x13, 0);
          operands[4] = x14;
          if (!s_register_operand (operands[4], E_SImode))
            return -1;
          x15 = XEXP (x13, 1);
          operands[5] = x15;
          if (!arm_add_operand (operands[5], E_SImode))
            return -1;
          x16 = XEXP (x2, 0);
          operands[7] = x16;
          if (!s_register_operand (operands[7], E_SImode))
            return -1;
          return 0;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern414 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 100
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x1, 0);
  operands[2] = x5;
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  x7 = XVECEXP (x2, 0, 0);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  return 0;
}

int
pattern422 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT
      || pattern421 (x1) != 0)
    return -1;
  return 0;
}

int
pattern429 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !neon_struct_operand (operands[1], i2)
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern436 (rtx x1, machine_mode i1, machine_mode i2, machine_mode i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i3
      || !s_register_operand (operands[1], i2))
    return -1;
  return 0;
}

int
pattern443 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case MEM:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      x5 = XEXP (x4, 1);
      if (GET_CODE (x5) != MEM)
        return -1;
      return 0;

    case REG:
      operands[1] = x3;
      if (!arm_hard_general_register_operand (operands[1], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != MEM
          || GET_MODE (x6) != E_SImode)
        return -1;
      return 1;

    case PLUS:
      if (GET_MODE (x3) != E_SImode)
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != CONST_INT)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern457 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!neon_struct_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[1], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 1);
  switch (GET_MODE (x2))
    {
    case E_V8QImode:
      return 0;

    case E_V16QImode:
      return 1;

    case E_V4HImode:
      return 2;

    case E_V8HImode:
      return 3;

    case E_V2SImode:
      return 4;

    case E_V4SImode:
      return 5;

    case E_V4HFmode:
      return 6;

    case E_V8HFmode:
      return 7;

    case E_V4BFmode:
      return 8;

    case E_V8BFmode:
      return 9;

    case E_V2SFmode:
      return 10;

    case E_V4SFmode:
      return 11;

    case E_DImode:
      return 12;

    case E_V2DImode:
      return 13;

    default:
      return -1;
    }
}

int
pattern473 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x4 = XEXP (x1, 1);
  operands[2] = x4;
  if (!const_double_vcvt_power_of_two_reciprocal (operands[2], E_VOIDmode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_SFmode:
      if (!s_register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || GET_MODE (x2) != E_SFmode)
        return -1;
      return 0;

    case E_DFmode:
      if (!s_register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || GET_MODE (x2) != E_DFmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern487 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != i1
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
      || !register_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x1, 0);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_SImode))
    return -1;
  return 0;
}

int
pattern497 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V4SImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != CONST_INT
      || XWINT (x2, 0) != 32768LL)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != CONST_INT
      || XWINT (x3, 0) != 32768LL)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CONST_INT
      || XWINT (x4, 0) != 32768LL)
    return -1;
  return 0;
}

int
pattern504 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_OImode:
      if (!s_register_operand (operands[1], E_OImode)
          || GET_MODE (x1) != i1)
        return -1;
      return 0;

    case E_XImode:
      if (!s_register_operand (operands[1], E_XImode)
          || GET_MODE (x1) != i2)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern514 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!mem_noofs_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern523 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_SImode
      || !arm_general_register_operand (operands[0], E_SImode)
      || !arm_general_register_operand (operands[1], i1)
      || !immediate_operand (operands[2], E_SImode))
    return -1;
  return 0;
}

int
pattern532 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_V8HImode)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x6 = XVECEXP (x1, 0, 4);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x7 = XVECEXP (x1, 0, 5);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XVECEXP (x1, 0, 7);
  if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  return 0;
}

int
pattern547 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XEXP (x1, 1);
  if (!logical_binary_operator (x3, E_SImode))
    return -1;
  operands[9] = x3;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  if (!s_register_operand (operands[2], E_SImode))
    return -1;
  x6 = XEXP (x2, 1);
  operands[3] = x6;
  if (!const_int_operand (operands[3], E_SImode))
    return -1;
  x7 = XEXP (x2, 2);
  operands[4] = x7;
  if (!const_int_operand (operands[4], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[5] = x8;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[6] = x9;
  if (!const_int_operand (operands[6], E_SImode))
    return -1;
  x10 = XEXP (x3, 1);
  operands[7] = x10;
  if (!s_register_operand (operands[7], E_SImode))
    return -1;
  return 0;
}

int
pattern569 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[3], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern576 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1
      || !s_register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern584 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern590 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != MEM
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_CODE (x8) != PLUS
      || GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != CONST_INT)
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  if (GET_CODE (x11) != MEM
      || GET_MODE (x11) != E_SImode)
    return -1;
  return 0;
}

int
pattern602 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i1
      || !s_register_operand (operands[2], i1)
      || !s_register_operand (operands[1], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern610 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (GET_CODE (x1))
    {
    case REG:
    case SUBREG:
      operands[3] = x1;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 0;

    case ASHIFTRT:
      if (GET_MODE (x1) != E_SImode)
        return -1;
      x2 = XEXP (x1, 1);
      if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + 16])
        return -1;
      x3 = XEXP (x1, 0);
      operands[3] = x3;
      if (!register_operand (operands[3], E_SImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern622 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!s_register_operand (operands[0], i1)
      || !mem_noofs_operand (operands[1], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !reg_or_int_operand (operands[2], i1)
      || !scratch_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern629 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[4]))
    return -1;
  return 0;
}

int
pattern637 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (!rtx_equal_p (x5, operands[3]))
    return -1;
  x6 = XEXP (x2, 0);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  if (!rtx_equal_p (x8, operands[2]))
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 1);
  x11 = XEXP (x10, 0);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  x12 = XVECEXP (x1, 0, 3);
  x13 = XEXP (x12, 1);
  x14 = XEXP (x13, 0);
  if (!rtx_equal_p (x14, operands[3]))
    return -1;
  return 0;
}

int
pattern644 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != i1)
    return -1;
  x8 = XEXP (x5, 1);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != i1)
    return -1;
  x10 = XEXP (x2, 0);
  x11 = XEXP (x10, 0);
  x12 = XEXP (x11, 0);
  operands[1] = x12;
  if (!register_operand (operands[1], E_V4HImode))
    return -1;
  x13 = XEXP (x4, 0);
  operands[2] = x13;
  if (!register_operand (operands[2], E_V4HImode))
    return -1;
  x14 = XEXP (x7, 0);
  if (!rtx_equal_p (x14, operands[1]))
    return -1;
  x15 = XEXP (x9, 0);
  if (!rtx_equal_p (x15, operands[2]))
    return -1;
  return 0;
}

int
pattern654 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != PLUS
      || GET_MODE (x1) != E_SImode)
    return -1;
  x2 = XEXP (x1, 1);
  if (x2 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x3 = XEXP (x1, 0);
  if (!rtx_equal_p (x3, operands[5]))
    return -1;
  return 0;
}

 int
recog_3 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_CC_RSBmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != E_CC_RSBmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case SET:
      x6 = XEXP (x5, 1);
      if (GET_CODE (x6) != MINUS
          || GET_MODE (x6) != E_SImode)
        return -1;
      x7 = XEXP (x4, 1);
      operands[3] = x7;
      if (!const_int_operand (operands[3], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!s_register_operand (operands[0], E_SImode))
        return -1;
      x9 = XEXP (x6, 0);
      operands[1] = x9;
      if (!arm_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x10 = XEXP (x6, 1);
      if (!rtx_equal_p (x10, operands[2])
          || !
#line 2101 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && ~UINTVAL (operands[1]) == UINTVAL (operands[3])))
        return -1;
      return 48; /* rsb_imm_compare */

    case CLOBBER:
      x7 = XEXP (x4, 1);
      operands[1] = x7;
      if (!arm_not_immediate_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x5, 0);
      operands[0] = x8;
      if (!scratch_operand (operands[0], E_SImode)
          || !
#line 2113 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
        return -1;
      return 49; /* rsb_imm_compare_scratch */

    default:
      return -1;
    }
}

 int
recog_12 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_CODE (operands[1]))
    {
    case REG:
    case SUBREG:
      x5 = XVECEXP (x1, 0, 1);
      if (pattern256 (x5) != 0)
        return -1;
      x6 = XEXP (x3, 1);
      switch (GET_CODE (x6))
        {
        case SMIN:
        case SMAX:
        case UMIN:
        case UMAX:
          operands[4] = x6;
          if (!minmax_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0
              || !
#line 4301 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1])
   && !(arm_restrict_it && CONST_INT_P (operands[3]))))
            return -1;
          return 126; /* *minmax_arithsi_non_canon */

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[4] = x6;
          if (!arm_comparison_operator (operands[4], E_SImode)
              || pattern550 (x3) != 0)
            return -1;
          if (
#line 10136 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return 339; /* *cond_sub */
          if (!
#line 868 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2))
            return -1;
          return 1038; /* *thumb2_cond_sub */

        case REG:
        case SUBREG:
          operands[2] = x6;
          if (!register_operand (operands[2], E_DImode)
              || !register_operand (operands[0], E_DImode)
              || GET_MODE (x3) != E_DImode
              || !register_operand (operands[1], E_DImode)
              || !
#line 132 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 943; /* *thumb_subdi3 */

        default:
          return -1;
        }

    case MEM:
      if (pnum_clobbers == NULL)
        return -1;
      switch (pattern292 (x1))
        {
        case 0:
          if (!
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3142; /* atomic_sub_fetchqi */

        case 1:
          if (!
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXBH && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3147; /* atomic_sub_fetchhi */

        case 2:
          if (!
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREX && TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3152; /* atomic_sub_fetchsi */

        case 3:
          if (!
#line 457 "../../gcc/config/arm/sync.md"
(TARGET_HAVE_LDREXD && ARM_DOUBLEWORD_ALIGN
	&& TARGET_HAVE_MEMORY_BARRIER))
            return -1;
          *pnum_clobbers = 2;
          return 3157; /* atomic_sub_fetchdi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case NE:
    case EQ:
      res = recog_18 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  if (!arm_comparison_operator (x4, E_VOIDmode))
    return -1;
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      if (!s_register_operand (x5, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x3, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case REG:
        case SUBREG:
          operands[1] = x7;
          if (pattern449 (x1) != 0)
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[2] = x8;
              if (!arm_rhs_operand (operands[2], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              if (
#line 10807 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return 351; /* movcond */
              if (!
#line 1012 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && !TARGET_COND_ARITH))
                return -1;
              return 1043; /* *thumb2_movcond */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (arm_add_operand (operands[3], E_SImode)
                  && GET_CODE (x8) == PLUS
                  && GET_MODE (x8) == E_SImode
                  && 
#line 10917 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return 354; /* *ifcompare_move_plus */
              if (!arm_rhs_operand (operands[3], E_SImode))
                return -1;
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode)
                  || !
#line 11061 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 360; /* *ifcompare_move_arith */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11128 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 362; /* *ifcompare_move_not */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[7] = x8;
              if (!shift_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11241 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 368; /* *ifcompare_move_shift */

            case NEG:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode)
                  || !
#line 11429 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 378; /* *ifcompare_move_neg */

            default:
              return -1;
            }

        case PLUS:
        case MINUS:
        case AND:
        case IOR:
        case XOR:
          if (pattern449 (x1) != 0)
            return -1;
          x9 = XEXP (x4, 1);
          operands[5] = x9;
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          if (!shiftable_operator (x7, E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[9] = x4;
              operands[5] = x5;
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 10962 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 356; /* *ifcompare_arith_arith */

            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_rhs_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[2] = x5;
              operands[3] = x9;
              operands[7] = x7;
              operands[4] = x12;
              operands[5] = x13;
              if (!
#line 10996 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 358; /* *ifcompare_arith_move */

            case NOT:
              if (GET_MODE (x8) != E_SImode)
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              x10 = XEXP (x8, 0);
              operands[1] = x10;
              if (!s_register_operand (operands[1], E_SImode)
                  || !
#line 11361 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 374; /* *ifcompare_arith_not */

            default:
              return -1;
            }

        case NOT:
          if (GET_MODE (x7) != E_SImode
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[5] = x4;
              operands[3] = x5;
              x9 = XEXP (x4, 1);
              operands[4] = x9;
              operands[2] = x12;
              if (!
#line 11163 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 364; /* *ifcompare_not_move */

            case PLUS:
            case MINUS:
            case AND:
            case IOR:
            case XOR:
              operands[7] = x8;
              if (!shiftable_operator (operands[7], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[1] = x12;
              x10 = XEXP (x8, 0);
              operands[2] = x10;
              if (!s_register_operand (operands[2], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[3] = x11;
              if (!arm_rhs_operand (operands[3], E_SImode)
                  || !
#line 11327 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 372; /* *ifcompare_not_arith */

            default:
              return -1;
            }

        case MULT:
        case ASHIFT:
        case ROTATE:
        case ASHIFTRT:
        case LSHIFTRT:
        case ROTATERT:
          if (!shift_operator (x7, E_SImode)
              || pattern449 (x1) != 0)
            return -1;
          x12 = XEXP (x7, 0);
          if (!s_register_operand (x12, E_SImode))
            return -1;
          x13 = XEXP (x7, 1);
          if (!arm_rhs_operand (x13, E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          switch (GET_CODE (x8))
            {
            case CONST_INT:
            case REG:
            case SUBREG:
              operands[1] = x8;
              if (!arm_not_operand (operands[1], E_SImode))
                return -1;
              operands[6] = x4;
              operands[4] = x5;
              x9 = XEXP (x4, 1);
              operands[5] = x9;
              operands[7] = x7;
              operands[2] = x12;
              operands[3] = x13;
              if (!
#line 11198 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 366; /* *ifcompare_shift_move */

            case MULT:
            case ASHIFT:
            case ROTATE:
            case ASHIFTRT:
            case LSHIFTRT:
            case ROTATERT:
              operands[9] = x8;
              if (!shift_operator (operands[9], E_SImode))
                return -1;
              operands[7] = x4;
              operands[5] = x5;
              x9 = XEXP (x4, 1);
              operands[6] = x9;
              operands[8] = x7;
              operands[1] = x12;
              operands[2] = x13;
              x10 = XEXP (x8, 0);
              operands[3] = x10;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x11 = XEXP (x8, 1);
              operands[4] = x11;
              if (!arm_rhs_operand (operands[4], E_SImode)
                  || !
#line 11286 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
                return -1;
              return 370; /* *ifcompare_shift_shift */

            default:
              return -1;
            }

        case NEG:
          if (GET_MODE (x7) != E_SImode
              || pattern450 (x1) != 0)
            return -1;
          operands[5] = x4;
          operands[3] = x5;
          x9 = XEXP (x4, 1);
          operands[4] = x9;
          if (!arm_add_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[2] = x12;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x8 = XEXP (x3, 2);
          operands[1] = x8;
          if (!arm_not_operand (operands[1], E_SImode)
              || !
#line 11393 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return -1;
          return 376; /* *ifcompare_neg_move */

        case LABEL_REF:
          x8 = XEXP (x3, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          x14 = XEXP (x2, 0);
          if (GET_CODE (x14) != PC)
            return -1;
          operands[4] = x4;
          operands[1] = x5;
          x9 = XEXP (x4, 1);
          operands[2] = x9;
          if (!thumb1_cmpneg_operand (operands[2], E_SImode))
            return -1;
          x12 = XEXP (x7, 0);
          operands[3] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1271 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1))
            return -1;
          return 976; /* cbranchsi4_scratch */

        default:
          return -1;
        }

    case PLUS:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x9 = XEXP (x4, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      x7 = XEXP (x3, 1);
      if (GET_CODE (x7) != LABEL_REF)
        return -1;
      x8 = XEXP (x3, 2);
      if (GET_CODE (x8) != PC)
        return -1;
      x14 = XEXP (x2, 0);
      if (GET_CODE (x14) != PC)
        return -1;
      x16 = XEXP (x5, 0);
      if (!s_register_operand (x16, E_SImode))
        return -1;
      x17 = XEXP (x5, 1);
      if (!reg_or_int_operand (x17, E_SImode))
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      switch (GET_CODE (x6))
        {
        case SET:
          if (pnum_clobbers == NULL)
            return -1;
          x18 = XEXP (x6, 1);
          if (GET_CODE (x18) != PLUS
              || GET_MODE (x18) != E_SImode)
            return -1;
          operands[4] = x4;
          operands[2] = x16;
          operands[3] = x17;
          x12 = XEXP (x7, 0);
          operands[5] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!thumb_cbrch_target_operand (operands[0], E_SImode))
            return -1;
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[2]))
            return -1;
          x20 = XEXP (x18, 1);
          if (!rtx_equal_p (x20, operands[3])
              || !
#line 1582 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[4]) == EQ
       || GET_CODE (operands[4]) == NE
       || GET_CODE (operands[4]) == GE
       || GET_CODE (operands[4]) == LT)))
            return -1;
          *pnum_clobbers = 1;
          return 982; /* *addsi3_cbranch */

        case CLOBBER:
          operands[3] = x4;
          operands[1] = x16;
          operands[2] = x17;
          x12 = XEXP (x7, 0);
          operands[4] = x12;
          x15 = XEXP (x6, 0);
          operands[0] = x15;
          if (!scratch_operand (operands[0], E_SImode)
              || !
#line 1661 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && (GET_CODE (operands[3]) == EQ
       || GET_CODE (operands[3]) == NE
       || GET_CODE (operands[3]) == GE
       || GET_CODE (operands[3]) == LT)))
            return -1;
          return 983; /* *addsi3_cbranch_scratch */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_44 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != SET)
    return -1;
  x5 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x5) != SET)
    return -1;
  switch (pattern299 (x1))
    {
    case 0:
      if (pattern422 (x1) != 0
          || !load_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x6 = XEXP (x2, 0);
      operands[1] = x6;
      x7 = XEXP (x3, 0);
      operands[2] = x7;
      x8 = XEXP (x4, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 0);
      operands[4] = x9;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      switch (GET_CODE (x11))
        {
        case REG:
        case SUBREG:
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x14 = XEXP (x13, 1);
          if (XWINT (x14, 0) != 4LL)
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x17 = XEXP (x16, 1);
          if (XWINT (x17, 0) != 8LL)
            return -1;
          x18 = XEXP (x5, 1);
          x19 = XEXP (x18, 0);
          if (GET_CODE (x19) != PLUS
              || GET_MODE (x19) != E_SImode)
            return -1;
          x20 = XEXP (x19, 1);
          if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x19, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          if (arm_hard_general_register_operand (operands[1], E_SImode)
              && arm_hard_general_register_operand (operands[2], E_SImode)
              && arm_hard_general_register_operand (operands[3], E_SImode)
              && arm_hard_general_register_operand (operands[4], E_SImode)
              && 
#line 37 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return 437; /* *ldm4_ */
          if (!low_register_operand (operands[1], E_SImode)
              || !low_register_operand (operands[2], E_SImode)
              || !low_register_operand (operands[3], E_SImode)
              || !low_register_operand (operands[4], E_SImode)
              || !
#line 55 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 438; /* *thumb_ldm4_ia */

        case PLUS:
          if (GET_MODE (x11) != E_SImode)
            return -1;
          x24 = XEXP (x11, 1);
          if (GET_CODE (x24) != CONST_INT
              || !arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x25 = XEXP (x11, 0);
          operands[5] = x25;
          if (!s_register_operand (operands[5], E_SImode)
              || !arm_hard_general_register_operand (operands[2], E_SImode)
              || !arm_hard_general_register_operand (operands[3], E_SImode)
              || !arm_hard_general_register_operand (operands[4], E_SImode))
            return -1;
          x12 = XEXP (x3, 1);
          x13 = XEXP (x12, 0);
          x21 = XEXP (x13, 0);
          if (!rtx_equal_p (x21, operands[5]))
            return -1;
          x15 = XEXP (x4, 1);
          x16 = XEXP (x15, 0);
          x22 = XEXP (x16, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          switch (XWINT (x24, 0))
            {
            case 4LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != 8LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != 12LL)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
16) != 0
                  || !
#line 160 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 444; /* *ldm4_ib */

            case -12LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -8LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -4LL)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (!rtx_equal_p (x19, operands[5])
                  || !
#line 231 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 448; /* *ldm4_da */

            case -16LL:
              x14 = XEXP (x13, 1);
              if (XWINT (x14, 0) != -12LL)
                return -1;
              x17 = XEXP (x16, 1);
              if (XWINT (x17, 0) != -8LL)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (pattern645 (x19, 
-4) != 0
                  || !
#line 302 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 452; /* *ldm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pattern480 (x1) != 0
          || !store_multiple_operation (operands[0], E_VOIDmode))
        return -1;
      x12 = XEXP (x3, 1);
      operands[2] = x12;
      if (!arm_hard_general_register_operand (operands[2], E_SImode))
        return -1;
      x15 = XEXP (x4, 1);
      operands[3] = x15;
      if (!arm_hard_general_register_operand (operands[3], E_SImode))
        return -1;
      x18 = XEXP (x5, 1);
      operands[4] = x18;
      if (!arm_hard_general_register_operand (operands[4], E_SImode))
        return -1;
      x6 = XEXP (x2, 0);
      x26 = XEXP (x6, 0);
      switch (GET_CODE (x26))
        {
        case REG:
        case SUBREG:
          operands[5] = x26;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x28 = XEXP (x27, 1);
          if (XWINT (x28, 0) != 4LL)
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x30 = XEXP (x29, 1);
          if (XWINT (x30, 0) != 8LL)
            return -1;
          x9 = XEXP (x5, 0);
          x31 = XEXP (x9, 0);
          if (GET_CODE (x31) != PLUS
              || GET_MODE (x31) != E_SImode)
            return -1;
          x32 = XEXP (x31, 1);
          if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + 12])
            return -1;
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x31, 0);
          if (!rtx_equal_p (x35, operands[5])
              || !
#line 108 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
            return -1;
          return 441; /* *stm4_ */

        case PLUS:
          if (GET_MODE (x26) != E_SImode)
            return -1;
          x36 = XEXP (x26, 1);
          if (GET_CODE (x36) != CONST_INT)
            return -1;
          x37 = XEXP (x26, 0);
          operands[5] = x37;
          if (!s_register_operand (operands[5], E_SImode))
            return -1;
          x7 = XEXP (x3, 0);
          x27 = XEXP (x7, 0);
          x33 = XEXP (x27, 0);
          if (!rtx_equal_p (x33, operands[5]))
            return -1;
          x8 = XEXP (x4, 0);
          x29 = XEXP (x8, 0);
          x34 = XEXP (x29, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          switch (XWINT (x36, 0))
            {
            case 4LL:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != 8LL)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != 12LL)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
16) != 0
                  || !
#line 196 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 446; /* *stm4_ib */

            case -12LL:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -8LL)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -4LL)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (!rtx_equal_p (x31, operands[5])
                  || !
#line 266 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 450; /* *stm4_da */

            case -16LL:
              x28 = XEXP (x27, 1);
              if (XWINT (x28, 0) != -12LL)
                return -1;
              x30 = XEXP (x29, 1);
              if (XWINT (x30, 0) != -8LL)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (pattern646 (x31, 
-4) != 0
                  || !
#line 338 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                return -1;
              return 454; /* *stm4_db */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x6 = XEXP (x2, 0);
      operands[4] = x6;
      if (!s_register_operand (operands[4], E_SImode))
        return -1;
      x10 = XEXP (x2, 1);
      x11 = XEXP (x10, 0);
      if (!rtx_equal_p (x11, operands[4]))
        return -1;
      x38 = XEXP (x10, 1);
      switch (XWINT (x38, 0))
        {
        case 12LL:
          switch (pattern496 (x3))
            {
            case 0:
              if (pattern421 (x1) != 0)
                return -1;
              x18 = XEXP (x5, 1);
              x19 = XEXP (x18, 0);
              if (GET_CODE (x19) != PLUS
                  || GET_MODE (x19) != E_SImode)
                return -1;
              x20 = XEXP (x19, 1);
              if (GET_CODE (x20) != CONST_INT
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x23 = XEXP (x19, 0);
              if (!rtx_equal_p (x23, operands[4]))
                return -1;
              switch (pattern633 (x1))
                {
                case 0:
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  if (!rtx_equal_p (x13, operands[4]))
                    return -1;
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != 4LL
                      || XWINT (x20, 0) != 8LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 508 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 458; /* *ldm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 525 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 459; /* *thumb_ldm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x12 = XEXP (x3, 1);
                  x13 = XEXP (x12, 0);
                  x21 = XEXP (x13, 0);
                  if (!rtx_equal_p (x21, operands[4])
                      || !
#line 600 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 464; /* *ldm3_ib_update */

                default:
                  return -1;
                }

            case 1:
              if (pattern479 (x1) != 0)
                return -1;
              x9 = XEXP (x5, 0);
              x31 = XEXP (x9, 0);
              if (GET_CODE (x31) != PLUS
                  || GET_MODE (x31) != E_SImode)
                return -1;
              x32 = XEXP (x31, 1);
              if (GET_CODE (x32) != CONST_INT
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x35 = XEXP (x31, 0);
              if (!rtx_equal_p (x35, operands[4]))
                return -1;
              switch (pattern635 (x1))
                {
                case 0:
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  if (!rtx_equal_p (x27, operands[4]))
                    return -1;
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != 4LL
                      || XWINT (x32, 0) != 8LL)
                    return -1;
                  if (arm_hard_general_register_operand (operands[1], E_SImode)
                      && arm_hard_general_register_operand (operands[2], E_SImode)
                      && arm_hard_general_register_operand (operands[3], E_SImode)
                      && 
#line 552 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return 461; /* *stm3_ia_update */
                  if (!low_register_operand (operands[1], E_SImode)
                      || !low_register_operand (operands[2], E_SImode)
                      || !low_register_operand (operands[3], E_SImode)
                      || !
#line 567 "../../gcc/config/arm/ldmstm.md"
(TARGET_THUMB1 && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 462; /* *thumb_stm3_ia_update */

                case 1:
                  if (!arm_hard_general_register_operand (operands[1], E_SImode)
                      || !arm_hard_general_register_operand (operands[2], E_SImode)
                      || !arm_hard_general_register_operand (operands[3], E_SImode))
                    return -1;
                  x7 = XEXP (x3, 0);
                  x27 = XEXP (x7, 0);
                  x33 = XEXP (x27, 0);
                  if (!rtx_equal_p (x33, operands[4])
                      || !
#line 628 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 466; /* *stm3_ib_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case -12LL:
          x12 = XEXP (x3, 1);
          switch (GET_CODE (x12))
            {
            case MEM:
              if (pattern422 (x1) != 0
                  || !load_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x7 = XEXP (x3, 0);
              operands[1] = x7;
              if (!arm_hard_general_register_operand (operands[1], E_SImode))
                return -1;
              x8 = XEXP (x4, 0);
              operands[2] = x8;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x9 = XEXP (x5, 0);
              operands[3] = x9;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x13 = XEXP (x12, 0);
              x21 = XEXP (x13, 0);
              if (!rtx_equal_p (x21, operands[4]))
                return -1;
              x15 = XEXP (x4, 1);
              x16 = XEXP (x15, 0);
              x22 = XEXP (x16, 0);
              if (!rtx_equal_p (x22, operands[4]))
                return -1;
              x14 = XEXP (x13, 1);
              switch (XWINT (x14, 0))
                {
                case -8LL:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -4LL)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (!rtx_equal_p (x19, operands[4])
                      || !
#line 660 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 468; /* *ldm3_da_update */

                case -12LL:
                  x17 = XEXP (x16, 1);
                  if (XWINT (x17, 0) != -8LL)
                    return -1;
                  x18 = XEXP (x5, 1);
                  x19 = XEXP (x18, 0);
                  if (GET_CODE (x19) != PLUS
                      || GET_MODE (x19) != E_SImode)
                    return -1;
                  x20 = XEXP (x19, 1);
                  if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x23 = XEXP (x19, 0);
                  if (!rtx_equal_p (x23, operands[4])
                      || !
#line 722 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 472; /* *ldm3_db_update */

                default:
                  return -1;
                }

            case REG:
              operands[1] = x12;
              if (!arm_hard_general_register_operand (operands[1], E_SImode)
                  || pattern480 (x1) != 0
                  || !store_multiple_operation (operands[0], E_VOIDmode))
                return -1;
              x15 = XEXP (x4, 1);
              operands[2] = x15;
              if (!arm_hard_general_register_operand (operands[2], E_SImode))
                return -1;
              x18 = XEXP (x5, 1);
              operands[3] = x18;
              if (!arm_hard_general_register_operand (operands[3], E_SImode))
                return -1;
              x7 = XEXP (x3, 0);
              x27 = XEXP (x7, 0);
              x33 = XEXP (x27, 0);
              if (!rtx_equal_p (x33, operands[4]))
                return -1;
              x8 = XEXP (x4, 0);
              x29 = XEXP (x8, 0);
              x34 = XEXP (x29, 0);
              if (!rtx_equal_p (x34, operands[4]))
                return -1;
              x28 = XEXP (x27, 1);
              switch (XWINT (x28, 0))
                {
                case -8LL:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -4LL)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (!rtx_equal_p (x31, operands[4])
                      || !
#line 688 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 470; /* *stm3_da_update */

                case -12LL:
                  x30 = XEXP (x29, 1);
                  if (XWINT (x30, 0) != -8LL)
                    return -1;
                  x9 = XEXP (x5, 0);
                  x31 = XEXP (x9, 0);
                  if (GET_CODE (x31) != PLUS
                      || GET_MODE (x31) != E_SImode)
                    return -1;
                  x32 = XEXP (x31, 1);
                  if (x32 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                    return -1;
                  x35 = XEXP (x31, 0);
                  if (!rtx_equal_p (x35, operands[4])
                      || !
#line 750 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 4))
                    return -1;
                  return 474; /* *stm3_db_update */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern43 (x1))
    {
    case 0:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2434; /* neon_vsrau_nv8qi */

    case 1:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2438; /* neon_vsrau_nv16qi */

    case 2:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2442; /* neon_vsrau_nv4hi */

    case 3:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2446; /* neon_vsrau_nv8hi */

    case 4:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2450; /* neon_vsrau_nv2si */

    case 5:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2454; /* neon_vsrau_nv4si */

    case 6:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2458; /* neon_vsrau_ndi */

    case 7:
      if (!
#line 4630 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2462; /* neon_vsrau_nv2di */

    default:
      return -1;
    }
}

 int
recog_92 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern46 (x1, 
E_CImode, 
E_EImode))
    {
    case 0:
      if (!
#line 5696 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2841; /* neon_vld3qbv16qi */

    case 1:
      if (!
#line 5696 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2842; /* neon_vld3qbv8hi */

    case 2:
      if (!
#line 5696 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2843; /* neon_vld3qbv8hf */

    case 3:
      if (!(
#line 5696 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2844; /* neon_vld3qbv8bf */

    case 4:
      if (!
#line 5696 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2845; /* neon_vld3qbv4si */

    case 5:
      if (!
#line 5696 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2846; /* neon_vld3qbv4sf */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (!neon_struct_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !s_register_operand (operands[1], E_V8QImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2646; /* neon_vst1v8qi */

    case E_V16QImode:
      if (!neon_struct_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !s_register_operand (operands[1], E_V16QImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2647; /* neon_vst1v16qi */

    case E_V4HImode:
      if (!neon_struct_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !s_register_operand (operands[1], E_V4HImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2648; /* neon_vst1v4hi */

    case E_V8HImode:
      if (!neon_struct_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !s_register_operand (operands[1], E_V8HImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2649; /* neon_vst1v8hi */

    case E_V2SImode:
      if (!neon_struct_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !s_register_operand (operands[1], E_V2SImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2650; /* neon_vst1v2si */

    case E_V4SImode:
      if (!neon_struct_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !s_register_operand (operands[1], E_V4SImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2651; /* neon_vst1v4si */

    case E_V4HFmode:
      if (!neon_struct_operand (operands[0], E_V4HFmode)
          || GET_MODE (x3) != E_V4HFmode
          || !s_register_operand (operands[1], E_V4HFmode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2652; /* neon_vst1v4hf */

    case E_V8HFmode:
      if (!neon_struct_operand (operands[0], E_V8HFmode)
          || GET_MODE (x3) != E_V8HFmode
          || !s_register_operand (operands[1], E_V8HFmode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2653; /* neon_vst1v8hf */

    case E_V4BFmode:
      if (!neon_struct_operand (operands[0], E_V4BFmode)
          || GET_MODE (x3) != E_V4BFmode
          || !s_register_operand (operands[1], E_V4BFmode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2654; /* neon_vst1v4bf */

    case E_V8BFmode:
      if (!neon_struct_operand (operands[0], E_V8BFmode)
          || GET_MODE (x3) != E_V8BFmode
          || !s_register_operand (operands[1], E_V8BFmode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2655; /* neon_vst1v8bf */

    case E_V2SFmode:
      if (!neon_struct_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !s_register_operand (operands[1], E_V2SFmode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2656; /* neon_vst1v2sf */

    case E_V4SFmode:
      if (!neon_struct_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !s_register_operand (operands[1], E_V4SFmode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2657; /* neon_vst1v4sf */

    case E_DImode:
      if (!neon_struct_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !s_register_operand (operands[1], E_DImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2658; /* neon_vst1di */

    case E_V2DImode:
      if (!neon_struct_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !s_register_operand (operands[1], E_V2DImode)
          || !
#line 5228 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2659; /* neon_vst1v2di */

    default:
      return -1;
    }
}

 int
recog_124 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != TRUNCATE)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern369 (x2, 
E_V8QImode, 
E_V8HImode) != 0
          || !
#line 3179 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4830; /* mve_vstrq_truncate_v8qi */

    case E_V4QImode:
      if (pattern369 (x2, 
E_V4QImode, 
E_V4SImode) != 0
          || !
#line 3179 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4831; /* mve_vstrq_truncate_v4qi */

    case E_V4HImode:
      if (pattern369 (x2, 
E_V4HImode, 
E_V4SImode) != 0
          || !
#line 3179 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4832; /* mve_vstrq_truncate_v4hi */

    default:
      return -1;
    }
}

 int
recog_133 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_SImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != MEM
      || GET_MODE (x3) != E_SImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_SImode))
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!guard_addr_operand (operands[1], E_SImode))
    return -1;
  *pnum_clobbers = 2;
  return 308; /* *stack_protect_combined_set_insn */
}

 int
recog_139 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  switch (pattern159 (x1))
    {
    case 0:
      if (!neon_struct_operand (operands[0], E_TImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_TImode
          || !s_register_operand (operands[1], E_TImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5544 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2804; /* neon_vst2v8qi */

        case E_V4HImode:
          if (!
#line 5544 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2805; /* neon_vst2v4hi */

        case E_V4HFmode:
          if (!
#line 5544 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2806; /* neon_vst2v4hf */

        case E_V4BFmode:
          if (!(
#line 5544 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 98 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2807; /* neon_vst2v4bf */

        case E_V2SImode:
          if (!
#line 5544 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2808; /* neon_vst2v2si */

        case E_V2SFmode:
          if (!
#line 5544 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2809; /* neon_vst2v2sf */

        case E_DImode:
          if (!
#line 5544 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2810; /* neon_vst2di */

        default:
          return -1;
        }

    case 1:
      if (!neon_struct_operand (operands[0], E_OImode))
        return -1;
      x2 = XEXP (x1, 1);
      if (GET_MODE (x2) != E_OImode
          || !s_register_operand (operands[1], E_OImode))
        return -1;
      x3 = XVECEXP (x2, 0, 1);
      switch (GET_MODE (x3))
        {
        case E_V16QImode:
          if (!
#line 5562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2811; /* neon_vst2v16qi */

        case E_V8HImode:
          if (!
#line 5562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2812; /* neon_vst2v8hi */

        case E_V8HFmode:
          if (!
#line 5562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2813; /* neon_vst2v8hf */

        case E_V8BFmode:
          if (!(
#line 5562 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2814; /* neon_vst2v8bf */

        case E_V4SImode:
          if (!
#line 5562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2815; /* neon_vst2v4si */

        case E_V4SFmode:
          if (!
#line 5562 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2816; /* neon_vst2v4sf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_146 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern157 (x1))
    {
    case 0:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2702; /* neon_vst1x3qav8qi */

    case 1:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2703; /* neon_vst1x3qav16qi */

    case 2:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2704; /* neon_vst1x3qav4hi */

    case 3:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2705; /* neon_vst1x3qav8hi */

    case 4:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2706; /* neon_vst1x3qav2si */

    case 5:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2707; /* neon_vst1x3qav4si */

    case 6:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2708; /* neon_vst1x3qav4hf */

    case 7:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2709; /* neon_vst1x3qav8hf */

    case 8:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2710; /* neon_vst1x3qav4bf */

    case 9:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2711; /* neon_vst1x3qav8bf */

    case 10:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2712; /* neon_vst1x3qav2sf */

    case 11:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2713; /* neon_vst1x3qav4sf */

    case 12:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2714; /* neon_vst1x3qadi */

    case 13:
      if (!
#line 5270 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2715; /* neon_vst1x3qav2di */

    default:
      return -1;
    }
}

 int
recog_155 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern145 (x1))
    {
    case 0:
      if (!
#line 2681 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1829; /* neon_vminsv8qi */

    case 1:
      if (!
#line 2681 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1833; /* neon_vminsv16qi */

    case 2:
      if (!
#line 2681 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1837; /* neon_vminsv4hi */

    case 3:
      if (!
#line 2681 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1841; /* neon_vminsv8hi */

    case 4:
      if (!
#line 2681 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1845; /* neon_vminsv2si */

    case 5:
      if (!
#line 2681 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1849; /* neon_vminsv4si */

    case 6:
      if (!
#line 2691 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1852; /* neon_vminfv2sf */

    case 7:
      if (!
#line 2691 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1854; /* neon_vminfv4sf */

    case 8:
      if (!
#line 2702 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1856; /* neon_vminfv8hf */

    case 9:
      if (!
#line 2702 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1858; /* neon_vminfv4hf */

    default:
      return -1;
    }
}

 int
recog_164 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern151 (x1))
    {
    case 0:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2395; /* neon_vshl_nv8qi */

    case 1:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2396; /* neon_vshl_nv16qi */

    case 2:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2397; /* neon_vshl_nv4hi */

    case 3:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2398; /* neon_vshl_nv8hi */

    case 4:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2399; /* neon_vshl_nv2si */

    case 5:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2400; /* neon_vshl_nv4si */

    case 6:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2401; /* neon_vshl_ndi */

    case 7:
      if (!
#line 4575 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2402; /* neon_vshl_nv2di */

    default:
      return -1;
    }
}

 int
recog_173 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern138 (x1))
    {
    case 0:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2278; /* neon_vrshluv8qi */

    case 1:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2282; /* neon_vrshluv16qi */

    case 2:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2286; /* neon_vrshluv4hi */

    case 3:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2290; /* neon_vrshluv8hi */

    case 4:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2294; /* neon_vrshluv2si */

    case 5:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2298; /* neon_vrshluv4si */

    case 6:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2302; /* neon_vrshludi */

    case 7:
      if (!
#line 4498 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2306; /* neon_vrshluv2di */

    default:
      return -1;
    }
}

 int
recog_183 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XVECEXP (x3, 0, 0);
  operands[1] = x4;
  x5 = XVECEXP (x3, 0, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V8QImode:
      if (pattern41 (x3, 
E_V8QImode) != 0
          || !
#line 1621 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1530; /* neon_vmulpv8qi */

    case E_V16QImode:
      if (pattern41 (x3, 
E_V16QImode) != 0
          || !
#line 1621 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1531; /* neon_vmulpv16qi */

    case E_V2SFmode:
      if (pattern41 (x3, 
E_V2SFmode) != 0
          || !
#line 1621 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1532; /* neon_vmulfv2sf */

    case E_V4SFmode:
      if (pattern41 (x3, 
E_V4SFmode) != 0
          || !
#line 1621 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1533; /* neon_vmulfv4sf */

    default:
      return -1;
    }
}

 int
recog_192 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern158 (x1))
    {
    case 0:
      if (!
#line 5327 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2744; /* neon_vst1x4qav16qi */

    case 1:
      if (!
#line 5327 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2745; /* neon_vst1x4qav8hi */

    case 2:
      if (!
#line 5327 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2746; /* neon_vst1x4qav8hf */

    case 3:
      if (!(
#line 5327 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 132 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2747; /* neon_vst1x4qav8bf */

    case 4:
      if (!
#line 5327 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2748; /* neon_vst1x4qav4si */

    case 5:
      if (!
#line 5327 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2749; /* neon_vst1x4qav4sf */

    case 6:
      if (!
#line 5327 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2750; /* neon_vst1x4qav2di */

    default:
      return -1;
    }
}

 int
recog_202 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern161 (x1, 
E_OImode, 
E_XImode))
    {
    case 0:
      if (!
#line 6004 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2903; /* neon_vld4qav16qi */

    case 1:
      if (!
#line 6004 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2904; /* neon_vld4qav8hi */

    case 2:
      if (!
#line 6004 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2905; /* neon_vld4qav8hf */

    case 3:
      if (!(
#line 6004 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 120 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
        return -1;
      return 2906; /* neon_vld4qav8bf */

    case 4:
      if (!
#line 6004 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2907; /* neon_vld4qav4si */

    case 5:
      if (!
#line 6004 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 2908; /* neon_vld4qav4sf */

    default:
      return -1;
    }
}

 int
recog_212 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern137 (x1))
    {
    case 0:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1788; /* neon_vabduv8qi */

    case 1:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1790; /* neon_vabduv16qi */

    case 2:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1792; /* neon_vabduv4hi */

    case 3:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1794; /* neon_vabduv8hi */

    case 4:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1796; /* neon_vabduv2si */

    case 5:
      if (!
#line 2593 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1798; /* neon_vabduv4si */

    default:
      return -1;
    }
}

 int
recog_222 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern126 (x1))
    {
    case 0:
      if (!
#line 376 "../../gcc/config/arm/vec-common.md"
(ARM_HAVE_V8QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 518; /* mve_vshlq_sv8qi */

    case 1:
      if (!
#line 376 "../../gcc/config/arm/vec-common.md"
(ARM_HAVE_V16QI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 520; /* mve_vshlq_sv16qi */

    case 2:
      if (!
#line 376 "../../gcc/config/arm/vec-common.md"
(ARM_HAVE_V4HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 522; /* mve_vshlq_sv4hi */

    case 3:
      if (!
#line 376 "../../gcc/config/arm/vec-common.md"
(ARM_HAVE_V8HI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 524; /* mve_vshlq_sv8hi */

    case 4:
      if (!
#line 376 "../../gcc/config/arm/vec-common.md"
(ARM_HAVE_V2SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 526; /* mve_vshlq_sv2si */

    case 5:
      if (!
#line 376 "../../gcc/config/arm/vec-common.md"
(ARM_HAVE_V4SI_ARITH && !TARGET_REALLY_IWMMXT))
        return -1;
      return 528; /* mve_vshlq_sv4si */

    default:
      return -1;
    }
}

 int
recog_235 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern143 (x1))
    {
    case 0:
      if (!
#line 2391 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1707; /* neon_vceqv2sf_insn_unspec */

    case 1:
      if (!
#line 2391 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
        return -1;
      return 1712; /* neon_vceqv4sf_insn_unspec */

    case 2:
      if (!
#line 2458 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1727; /* neon_vceqv8hf_fp16insn_unspec */

    case 3:
      if (!
#line 2458 "../../gcc/config/arm/neon.md"
(TARGET_NEON_FP16INST))
        return -1;
      return 1732; /* neon_vceqv4hf_fp16insn_unspec */

    default:
      return -1;
    }
}

 int
recog_246 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x3) != UNSPEC
      || XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 335)
    return -1;
  x4 = XVECEXP (x3, 0, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  x6 = XVECEXP (x2, 0, 0);
  operands[1] = x6;
  if (!neon_struct_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XVECEXP (x2, 0, 1);
  operands[2] = x7;
  x8 = XVECEXP (x2, 0, 2);
  operands[3] = x8;
  if (!immediate_operand (operands[3], E_SImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_EImode:
      if (!s_register_operand (operands[0], E_EImode)
          || GET_MODE (x2) != E_EImode
          || !s_register_operand (operands[2], E_EImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8QImode:
          if (!
#line 5719 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2847; /* neon_vld3_lanev8qi */

        case E_V4HImode:
          if (!
#line 5719 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2848; /* neon_vld3_lanev4hi */

        case E_V4HFmode:
          if (!
#line 5719 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2849; /* neon_vld3_lanev4hf */

        case E_V4BFmode:
          if (!
#line 5719 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2850; /* neon_vld3_lanev4bf */

        case E_V2SImode:
          if (!
#line 5719 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2851; /* neon_vld3_lanev2si */

        case E_V2SFmode:
          if (!
#line 5719 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2852; /* neon_vld3_lanev2sf */

        default:
          return -1;
        }

    case E_CImode:
      if (!s_register_operand (operands[0], E_CImode)
          || GET_MODE (x2) != E_CImode
          || !s_register_operand (operands[2], E_CImode))
        return -1;
      switch (GET_MODE (x3))
        {
        case E_V8HImode:
          if (!
#line 5745 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2853; /* neon_vld3_lanev8hi */

        case E_V8HFmode:
          if (!
#line 5745 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2854; /* neon_vld3_lanev8hf */

        case E_V4SImode:
          if (!
#line 5745 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2855; /* neon_vld3_lanev4si */

        case E_V4SFmode:
          if (!
#line 5745 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2856; /* neon_vld3_lanev4sf */

        case E_V8BFmode:
          if (!(
#line 5745 "../../gcc/config/arm/neon.md"
(TARGET_NEON) && 
#line 123 "../../gcc/config/arm/iterators.md"
(TARGET_BF16_SIMD)))
            return -1;
          return 2857; /* neon_vld3_lanev8bf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_264 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XINT (x2, 1))
    {
    case 103:
      return recog_259 (x1, insn, pnum_clobbers);

    case 102:
      return recog_257 (x1, insn, pnum_clobbers);

    case 105:
      return recog_254 (x1, insn, pnum_clobbers);

    case 104:
      return recog_253 (x1, insn, pnum_clobbers);

    case 361:
      return recog_261 (x1, insn, pnum_clobbers);

    case 362:
      return recog_260 (x1, insn, pnum_clobbers);

    case 224:
      return recog_256 (x1, insn, pnum_clobbers);

    case 227:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4052 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2212; /* neon_vmlals_lanev4hi */

        case 1:
          if (!
#line 4052 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2214; /* neon_vmlals_lanev2si */

        default:
          return -1;
        }

    case 228:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4052 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2213; /* neon_vmlalu_lanev4hi */

        case 1:
          if (!
#line 4052 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2215; /* neon_vmlalu_lanev2si */

        default:
          return -1;
        }

    case 265:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4067 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2216; /* neon_vqdmlal_lanev4hi */

        case 1:
          if (!
#line 4067 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2217; /* neon_vqdmlal_lanev2si */

        default:
          return -1;
        }

    case 230:
      return recog_255 (x1, insn, pnum_clobbers);

    case 233:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4118 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2224; /* neon_vmlsls_lanev4hi */

        case 1:
          if (!
#line 4118 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2226; /* neon_vmlsls_lanev2si */

        default:
          return -1;
        }

    case 234:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4118 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2225; /* neon_vmlslu_lanev4hi */

        case 1:
          if (!
#line 4118 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2227; /* neon_vmlslu_lanev2si */

        default:
          return -1;
        }

    case 267:
      switch (pattern199 (x1))
        {
        case 0:
          if (!
#line 4133 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2228; /* neon_vqdmlsl_lanev4hi */

        case 1:
          if (!
#line 4133 "../../gcc/config/arm/neon.md"
(TARGET_NEON))
            return -1;
          return 2229; /* neon_vqdmlsl_lanev2si */

        default:
          return -1;
        }

    case 206:
      return recog_245 (x1, insn, pnum_clobbers);

    case 211:
      return recog_246 (x1, insn, pnum_clobbers);

    case 216:
      return recog_244 (x1, insn, pnum_clobbers);

    case 809:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4349; /* mve_vcvtq_m_n_from_f_sv8hi */

        case 1:
          if (!
#line 2462 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4351; /* mve_vcvtq_m_n_from_f_sv4si */

        default:
          return -1;
        }

    case 818:
      switch (pattern202 (x1))
        {
        case 0:
          if (!
#line 2462 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4350; /* mve_vcvtq_m_n_from_f_uv8hi */

        case 1:
          if (!
#line 2462 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4352; /* mve_vcvtq_m_n_from_f_uv4si */

        default:
          return -1;
        }

    case 820:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4359; /* mve_vabavq_p_sv16qi */

        case 1:
          if (!
#line 2514 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4361; /* mve_vabavq_p_sv8hi */

        case 2:
          if (!
#line 2514 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4363; /* mve_vabavq_p_sv4si */

        default:
          return -1;
        }

    case 821:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2514 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4360; /* mve_vabavq_p_uv16qi */

        case 1:
          if (!
#line 2514 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4362; /* mve_vabavq_p_uv8hi */

        case 2:
          if (!
#line 2514 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4364; /* mve_vabavq_p_uv4si */

        default:
          return -1;
        }

    case 819:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2532 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4365; /* mve_vqshluq_m_n_sv16qi */

        case 1:
          if (!
#line 2532 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4366; /* mve_vqshluq_m_n_sv8hi */

        case 2:
          if (!
#line 2532 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4367; /* mve_vqshluq_m_n_sv4si */

        default:
          return -1;
        }

    case 824:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4368; /* mve_vsriq_m_n_sv16qi */

        case 1:
          if (!
#line 2550 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4370; /* mve_vsriq_m_n_sv8hi */

        case 2:
          if (!
#line 2550 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4372; /* mve_vsriq_m_n_sv4si */

        default:
          return -1;
        }

    case 825:
      switch (pattern207 (x1))
        {
        case 0:
          if (!
#line 2550 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4369; /* mve_vsriq_m_n_uv16qi */

        case 1:
          if (!
#line 2550 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4371; /* mve_vsriq_m_n_uv8hi */

        case 2:
          if (!
#line 2550 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4373; /* mve_vsriq_m_n_uv4si */

        default:
          return -1;
        }

    case 828:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4374; /* mve_vcvtq_m_n_to_f_uv8hf */

        case 1:
          if (!
#line 2568 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4376; /* mve_vcvtq_m_n_to_f_uv4sf */

        default:
          return -1;
        }

    case 829:
      switch (pattern208 (x1))
        {
        case 0:
          if (!
#line 2568 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4375; /* mve_vcvtq_m_n_to_f_sv8hf */

        case 1:
          if (!
#line 2568 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4377; /* mve_vcvtq_m_n_to_f_sv4sf */

        default:
          return -1;
        }

    case 552:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4378; /* mve_vabdq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4416; /* mve_vabdq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4454; /* mve_vabdq_m_sv4si */

        default:
          return -1;
        }

    case 553:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4379; /* mve_vabdq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4417; /* mve_vabdq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4455; /* mve_vabdq_m_uv4si */

        default:
          return -1;
        }

    case 842:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4380; /* mve_vhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4418; /* mve_vhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4456; /* mve_vhaddq_m_sv4si */

        default:
          return -1;
        }

    case 838:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4381; /* mve_vhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4419; /* mve_vhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4457; /* mve_vhaddq_m_uv4si */

        default:
          return -1;
        }

    case 924:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4382; /* mve_vhsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4420; /* mve_vhsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4458; /* mve_vhsubq_m_sv4si */

        default:
          return -1;
        }

    case 925:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4383; /* mve_vhsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4421; /* mve_vhsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4459; /* mve_vhsubq_m_uv4si */

        default:
          return -1;
        }

    case 876:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4384; /* mve_vmaxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4422; /* mve_vmaxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4460; /* mve_vmaxq_m_sv4si */

        default:
          return -1;
        }

    case 856:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4385; /* mve_vmaxq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4423; /* mve_vmaxq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4461; /* mve_vmaxq_m_uv4si */

        default:
          return -1;
        }

    case 884:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4386; /* mve_vminq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4424; /* mve_vminq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4462; /* mve_vminq_m_sv4si */

        default:
          return -1;
        }

    case 885:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4387; /* mve_vminq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4425; /* mve_vminq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4463; /* mve_vminq_m_uv4si */

        default:
          return -1;
        }

    case 891:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4388; /* mve_vmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4426; /* mve_vmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4464; /* mve_vmulhq_m_sv4si */

        default:
          return -1;
        }

    case 892:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4389; /* mve_vmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4427; /* mve_vmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4465; /* mve_vmulhq_m_uv4si */

        default:
          return -1;
        }

    case 831:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4390; /* mve_vqaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4428; /* mve_vqaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4466; /* mve_vqaddq_m_sv4si */

        default:
          return -1;
        }

    case 830:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4391; /* mve_vqaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4429; /* mve_vqaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4467; /* mve_vqaddq_m_uv4si */

        default:
          return -1;
        }

    case 942:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4392; /* mve_vqdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4430; /* mve_vqdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4468; /* mve_vqdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 933:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4393; /* mve_vqdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4431; /* mve_vqdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4469; /* mve_vqdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 938:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4394; /* mve_vqdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4432; /* mve_vqdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4470; /* mve_vqdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 939:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4395; /* mve_vqdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4433; /* mve_vqdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4471; /* mve_vqdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 931:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4396; /* mve_vqdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4434; /* mve_vqdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4472; /* mve_vqdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 941:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4397; /* mve_vqrdmladhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4435; /* mve_vqrdmladhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4473; /* mve_vqrdmladhq_m_sv4si */

        default:
          return -1;
        }

    case 930:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4398; /* mve_vqrdmladhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4436; /* mve_vqrdmladhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4474; /* mve_vqrdmladhxq_m_sv4si */

        default:
          return -1;
        }

    case 928:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4399; /* mve_vqrdmlsdhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4437; /* mve_vqrdmlsdhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4475; /* mve_vqrdmlsdhq_m_sv4si */

        default:
          return -1;
        }

    case 929:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4400; /* mve_vqrdmlsdhxq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4438; /* mve_vqrdmlsdhxq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4476; /* mve_vqrdmlsdhxq_m_sv4si */

        default:
          return -1;
        }

    case 934:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4401; /* mve_vqrdmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4439; /* mve_vqrdmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4477; /* mve_vqrdmulhq_m_sv4si */

        default:
          return -1;
        }

    case 860:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4402; /* mve_vqrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4440; /* mve_vqrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4478; /* mve_vqrshlq_m_sv4si */

        default:
          return -1;
        }

    case 881:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4403; /* mve_vqrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4441; /* mve_vqrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4479; /* mve_vqrshlq_m_uv4si */

        default:
          return -1;
        }

    case 912:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4404; /* mve_vqshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4442; /* mve_vqshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4480; /* mve_vqshlq_m_sv4si */

        default:
          return -1;
        }

    case 911:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4405; /* mve_vqshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4443; /* mve_vqshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4481; /* mve_vqshlq_m_uv4si */

        default:
          return -1;
        }

    case 846:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4406; /* mve_vqsubq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4444; /* mve_vqsubq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4482; /* mve_vqsubq_m_sv4si */

        default:
          return -1;
        }

    case 845:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4407; /* mve_vqsubq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4445; /* mve_vqsubq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4483; /* mve_vqsubq_m_uv4si */

        default:
          return -1;
        }

    case 864:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4408; /* mve_vrhaddq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4446; /* mve_vrhaddq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4484; /* mve_vrhaddq_m_sv4si */

        default:
          return -1;
        }

    case 862:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4409; /* mve_vrhaddq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4447; /* mve_vrhaddq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4485; /* mve_vrhaddq_m_uv4si */

        default:
          return -1;
        }

    case 883:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4410; /* mve_vrmulhq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4448; /* mve_vrmulhq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4486; /* mve_vrmulhq_m_sv4si */

        default:
          return -1;
        }

    case 882:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4411; /* mve_vrmulhq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4449; /* mve_vrmulhq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4487; /* mve_vrmulhq_m_uv4si */

        default:
          return -1;
        }

    case 869:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4412; /* mve_vrshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4450; /* mve_vrshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4488; /* mve_vrshlq_m_sv4si */

        default:
          return -1;
        }

    case 870:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4413; /* mve_vrshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4451; /* mve_vrshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4489; /* mve_vrshlq_m_uv4si */

        default:
          return -1;
        }

    case 822:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4414; /* mve_vshlq_m_sv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4452; /* mve_vshlq_m_sv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4490; /* mve_vshlq_m_sv4si */

        default:
          return -1;
        }

    case 823:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4415; /* mve_vshlq_m_uv16qi */

        case 1:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4453; /* mve_vshlq_m_uv8hi */

        case 2:
          if (!
#line 2609 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4491; /* mve_vshlq_m_uv4si */

        default:
          return -1;
        }

    case 873:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4492; /* mve_vaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4498; /* mve_vaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4504; /* mve_vaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 874:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4493; /* mve_vaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4499; /* mve_vaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4505; /* mve_vaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 852:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4494; /* mve_vmulq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4500; /* mve_vmulq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4506; /* mve_vmulq_m_n_sv4si */

        default:
          return -1;
        }

    case 841:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4495; /* mve_vmulq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4501; /* mve_vmulq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4507; /* mve_vmulq_m_n_uv4si */

        default:
          return -1;
        }

    case 833:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4496; /* mve_vsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4502; /* mve_vsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4508; /* mve_vsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 834:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4497; /* mve_vsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4503; /* mve_vsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2629 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4509; /* mve_vsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 918:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4510; /* mve_vaddq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4516; /* mve_vaddq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4522; /* mve_vaddq_m_sv4si */

        default:
          return -1;
        }

    case 897:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4511; /* mve_vaddq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4517; /* mve_vaddq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4523; /* mve_vaddq_m_uv4si */

        default:
          return -1;
        }

    case 865:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4512; /* mve_vmulq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4518; /* mve_vmulq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4524; /* mve_vmulq_m_sv4si */

        default:
          return -1;
        }

    case 866:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4513; /* mve_vmulq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4519; /* mve_vmulq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4525; /* mve_vmulq_m_uv4si */

        default:
          return -1;
        }

    case 827:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4514; /* mve_vsubq_m_sv16qi */

        case 1:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4520; /* mve_vsubq_m_sv8hi */

        case 2:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4526; /* mve_vsubq_m_sv4si */

        default:
          return -1;
        }

    case 826:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4515; /* mve_vsubq_m_uv16qi */

        case 1:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4521; /* mve_vsubq_m_uv8hi */

        case 2:
          if (!
#line 2649 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4527; /* mve_vsubq_m_uv4si */

        default:
          return -1;
        }

    case 888:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4528; /* mve_vandq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4538; /* mve_vandq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4548; /* mve_vandq_m_sv4si */

        default:
          return -1;
        }

    case 887:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4529; /* mve_vandq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4539; /* mve_vandq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4549; /* mve_vandq_m_uv4si */

        default:
          return -1;
        }

    case 840:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4530; /* mve_vbicq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4540; /* mve_vbicq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4550; /* mve_vbicq_m_sv4si */

        default:
          return -1;
        }

    case 839:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4531; /* mve_vbicq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4541; /* mve_vbicq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4551; /* mve_vbicq_m_uv4si */

        default:
          return -1;
        }

    case 922:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4532; /* mve_veorq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4542; /* mve_veorq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4552; /* mve_veorq_m_sv4si */

        default:
          return -1;
        }

    case 923:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4533; /* mve_veorq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4543; /* mve_veorq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4553; /* mve_veorq_m_uv4si */

        default:
          return -1;
        }

    case 915:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4534; /* mve_vornq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4544; /* mve_vornq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4554; /* mve_vornq_m_sv4si */

        default:
          return -1;
        }

    case 914:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4535; /* mve_vornq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4545; /* mve_vornq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4555; /* mve_vornq_m_uv4si */

        default:
          return -1;
        }

    case 878:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4536; /* mve_vorrq_m_sv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4546; /* mve_vorrq_m_sv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4556; /* mve_vorrq_m_sv4si */

        default:
          return -1;
        }

    case 879:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4537; /* mve_vorrq_m_uv16qi */

        case 1:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4547; /* mve_vorrq_m_uv8hi */

        case 2:
          if (!
#line 2671 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4557; /* mve_vorrq_m_uv4si */

        default:
          return -1;
        }

    case 902:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4558; /* mve_vbrsrq_m_n_uv16qi */

        case 1:
          if (!
#line 2689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4560; /* mve_vbrsrq_m_n_uv8hi */

        case 2:
          if (!
#line 2689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4562; /* mve_vbrsrq_m_n_uv4si */

        default:
          return -1;
        }

    case 835:
      switch (pattern215 (x1))
        {
        case 0:
          if (!
#line 2689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4559; /* mve_vbrsrq_m_n_sv16qi */

        case 1:
          if (!
#line 2689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4561; /* mve_vbrsrq_m_n_sv8hi */

        case 2:
          if (!
#line 2689 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4563; /* mve_vbrsrq_m_n_sv4si */

        default:
          return -1;
        }

    case 927:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4564; /* mve_vhcaddq_rot90_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4568; /* mve_vhcaddq_rot90_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4572; /* mve_vhcaddq_rot90_m_sv4si */

        default:
          return -1;
        }

    case 937:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4565; /* mve_vhcaddq_rot270_m_sv16qi */

        case 1:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4569; /* mve_vhcaddq_rot270_m_sv8hi */

        case 2:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4573; /* mve_vhcaddq_rot270_m_sv4si */

        default:
          return -1;
        }

    case 913:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4566; /* mve_vcaddq_rot90_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4570; /* mve_vcaddq_rot90_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4574; /* mve_vcaddq_rot90_m_v4si */

        default:
          return -1;
        }

    case 859:
      switch (pattern210 (x1))
        {
        case 0:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4567; /* mve_vcaddq_rot270_m_v16qi */

        case 1:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4571; /* mve_vcaddq_rot270_m_v8hi */

        case 2:
          if (!
#line 2710 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4575; /* mve_vcaddq_rot270_m_v4si */

        default:
          return -1;
        }

    case 919:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4576; /* mve_vhaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4594; /* mve_vhaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4612; /* mve_vhaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 926:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4577; /* mve_vhaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4595; /* mve_vhaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4613; /* mve_vhaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 889:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4578; /* mve_vhsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4596; /* mve_vhsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4614; /* mve_vhsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 890:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4579; /* mve_vhsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4597; /* mve_vhsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4615; /* mve_vhsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 844:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4580; /* mve_vmlaq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4598; /* mve_vmlaq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4616; /* mve_vmlaq_m_n_sv4si */

        default:
          return -1;
        }

    case 847:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4581; /* mve_vmlaq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4599; /* mve_vmlaq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4617; /* mve_vmlaq_m_n_uv4si */

        default:
          return -1;
        }

    case 855:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4582; /* mve_vmlasq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4600; /* mve_vmlasq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4618; /* mve_vmlasq_m_n_sv4si */

        default:
          return -1;
        }

    case 854:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4583; /* mve_vmlasq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4601; /* mve_vmlasq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4619; /* mve_vmlasq_m_n_uv4si */

        default:
          return -1;
        }

    case 906:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4584; /* mve_vqdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4602; /* mve_vqdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4620; /* mve_vqdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 867:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4585; /* mve_vqdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4603; /* mve_vqdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4621; /* mve_vqdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 877:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4586; /* mve_vqrdmlahq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4604; /* mve_vqrdmlahq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4622; /* mve_vqrdmlahq_m_n_sv4si */

        default:
          return -1;
        }

    case 868:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4587; /* mve_vqrdmlashq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4605; /* mve_vqrdmlashq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4623; /* mve_vqrdmlashq_m_n_sv4si */

        default:
          return -1;
        }

    case 899:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4588; /* mve_vqaddq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4606; /* mve_vqaddq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4624; /* mve_vqaddq_m_n_sv4si */

        default:
          return -1;
        }

    case 921:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4589; /* mve_vqaddq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4607; /* mve_vqaddq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4625; /* mve_vqaddq_m_n_uv4si */

        default:
          return -1;
        }

    case 849:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4590; /* mve_vqsubq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4608; /* mve_vqsubq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4626; /* mve_vqsubq_m_n_sv4si */

        default:
          return -1;
        }

    case 848:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4591; /* mve_vqsubq_m_n_uv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4609; /* mve_vqsubq_m_n_uv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4627; /* mve_vqsubq_m_n_uv4si */

        default:
          return -1;
        }

    case 936:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4592; /* mve_vqdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4610; /* mve_vqdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4628; /* mve_vqdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 966:
      switch (pattern212 (x1))
        {
        case 0:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4593; /* mve_vqrdmulhq_m_n_sv16qi */

        case 1:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4611; /* mve_vqrdmulhq_m_n_sv8hi */

        case 2:
          if (!
#line 2739 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4629; /* mve_vqrdmulhq_m_n_sv4si */

        default:
          return -1;
        }

    case 909:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4630; /* mve_vmladavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4635; /* mve_vmladavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4640; /* mve_vmladavaq_p_sv4si */

        default:
          return -1;
        }

    case 908:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4631; /* mve_vmladavaq_p_uv16qi */

        case 1:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4636; /* mve_vmladavaq_p_uv8hi */

        case 2:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4641; /* mve_vmladavaq_p_uv4si */

        default:
          return -1;
        }

    case 935:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4632; /* mve_vmlsdavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4637; /* mve_vmlsdavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4642; /* mve_vmlsdavaxq_p_sv4si */

        default:
          return -1;
        }

    case 940:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4633; /* mve_vmlsdavaq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4638; /* mve_vmlsdavaq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4643; /* mve_vmlsdavaq_p_sv4si */

        default:
          return -1;
        }

    case 932:
      switch (pattern203 (x1))
        {
        case 0:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4634; /* mve_vmladavaxq_p_sv16qi */

        case 1:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4639; /* mve_vmladavaxq_p_sv8hi */

        case 2:
          if (!
#line 2761 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4644; /* mve_vmladavaxq_p_sv4si */

        default:
          return -1;
        }

    case 893:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4645; /* mve_vmullbq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4649; /* mve_vmullbq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4653; /* mve_vmullbq_int_m_uv4si */

        default:
          return -1;
        }

    case 894:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4646; /* mve_vmullbq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4650; /* mve_vmullbq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4654; /* mve_vmullbq_int_m_sv4si */

        default:
          return -1;
        }

    case 851:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4647; /* mve_vmulltq_int_m_uv16qi */

        case 1:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4651; /* mve_vmulltq_int_m_uv8hi */

        case 2:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4655; /* mve_vmulltq_int_m_uv4si */

        default:
          return -1;
        }

    case 850:
      switch (pattern217 (x1))
        {
        case 0:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4648; /* mve_vmulltq_int_m_sv16qi */

        case 1:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4652; /* mve_vmulltq_int_m_sv8hi */

        case 2:
          if (!
#line 2780 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4656; /* mve_vmulltq_int_m_sv4si */

        default:
          return -1;
        }

    case 916:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4657; /* mve_vqshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4661; /* mve_vqshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4665; /* mve_vqshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 917:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4658; /* mve_vqshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4662; /* mve_vqshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4666; /* mve_vqshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 904:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4659; /* mve_vshlq_m_n_sv16qi */

        case 1:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4663; /* mve_vshlq_m_n_sv8hi */

        case 2:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4667; /* mve_vshlq_m_n_sv4si */

        default:
          return -1;
        }

    case 907:
      switch (pattern218 (x1))
        {
        case 0:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4660; /* mve_vshlq_m_n_uv16qi */

        case 1:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4664; /* mve_vshlq_m_n_uv8hi */

        case 2:
          if (!
#line 2799 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4668; /* mve_vshlq_m_n_uv4si */

        default:
          return -1;
        }

    case 832:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4669; /* mve_vrshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4673; /* mve_vrshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4677; /* mve_vrshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 871:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4670; /* mve_vrshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4674; /* mve_vrshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4678; /* mve_vrshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 896:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4671; /* mve_vshrq_m_n_sv16qi */

        case 1:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4675; /* mve_vshrq_m_n_sv8hi */

        case 2:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4679; /* mve_vshrq_m_n_sv4si */

        default:
          return -1;
        }

    case 863:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4672; /* mve_vshrq_m_n_uv16qi */

        case 1:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4676; /* mve_vshrq_m_n_uv8hi */

        case 2:
          if (!
#line 2818 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4680; /* mve_vshrq_m_n_uv4si */

        default:
          return -1;
        }

    case 898:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4681; /* mve_vsliq_m_n_uv16qi */

        case 1:
          if (!
#line 2836 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4683; /* mve_vsliq_m_n_uv8hi */

        case 2:
          if (!
#line 2836 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4685; /* mve_vsliq_m_n_uv4si */

        default:
          return -1;
        }

    case 910:
      switch (pattern204 (x1))
        {
        case 0:
          if (!
#line 2836 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4682; /* mve_vsliq_m_n_sv16qi */

        case 1:
          if (!
#line 2836 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4684; /* mve_vsliq_m_n_sv8hi */

        case 2:
          if (!
#line 2836 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4686; /* mve_vsliq_m_n_sv4si */

        default:
          return -1;
        }

    case 944:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4687; /* mve_vmlaldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4692; /* mve_vmlaldavaq_p_sv4si */

        default:
          return -1;
        }

    case 943:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4688; /* mve_vmlaldavaq_p_uv8hi */

        case 1:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4693; /* mve_vmlaldavaq_p_uv4si */

        default:
          return -1;
        }

    case 962:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4689; /* mve_vmlaldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4694; /* mve_vmlaldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 968:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4690; /* mve_vmlsldavaq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4695; /* mve_vmlsldavaq_p_sv4si */

        default:
          return -1;
        }

    case 969:
      switch (pattern220 (x1))
        {
        case 0:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4691; /* mve_vmlsldavaxq_p_sv8hi */

        case 1:
          if (!
#line 2857 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4696; /* mve_vmlsldavaxq_p_sv4si */

        default:
          return -1;
        }

    case 946:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4697; /* mve_vqrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4717; /* mve_vqrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 945:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4698; /* mve_vqrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4718; /* mve_vqrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 947:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4699; /* mve_vqrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4719; /* mve_vqrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 963:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4700; /* mve_vqrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4720; /* mve_vqrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 976:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4701; /* mve_vqrshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4721; /* mve_vqrshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 983:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4702; /* mve_vqrshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4722; /* mve_vqrshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 949:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4703; /* mve_vqshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4723; /* mve_vqshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 948:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4704; /* mve_vqshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4724; /* mve_vqshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 950:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4705; /* mve_vqshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4725; /* mve_vqshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 964:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4706; /* mve_vqshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4726; /* mve_vqshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 977:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4707; /* mve_vqshrunbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4727; /* mve_vqshrunbq_m_n_sv4si */

        default:
          return -1;
        }

    case 978:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4708; /* mve_vqshruntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4728; /* mve_vqshruntq_m_n_sv4si */

        default:
          return -1;
        }

    case 952:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4709; /* mve_vrshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4729; /* mve_vrshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 951:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4710; /* mve_vrshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4730; /* mve_vrshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 965:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4711; /* mve_vrshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4731; /* mve_vrshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 953:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4712; /* mve_vrshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4732; /* mve_vrshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 958:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4713; /* mve_vshrnbq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4733; /* mve_vshrnbq_m_n_sv4si */

        default:
          return -1;
        }

    case 959:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4714; /* mve_vshrnbq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4734; /* mve_vshrnbq_m_n_uv4si */

        default:
          return -1;
        }

    case 960:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4715; /* mve_vshrntq_m_n_sv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4735; /* mve_vshrntq_m_n_sv4si */

        default:
          return -1;
        }

    case 961:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4716; /* mve_vshrntq_m_n_uv8hi */

        case 1:
          if (!
#line 2886 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4736; /* mve_vshrntq_m_n_uv4si */

        default:
          return -1;
        }

    case 967:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4737; /* mve_vrmlaldavhaq_p_sv4si */

    case 979:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4738; /* mve_vrmlaldavhaq_p_uv4si */

    case 980:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4739; /* mve_vrmlaldavhaxq_p_sv4si */

    case 981:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4740; /* mve_vrmlsldavhaq_p_sv4si */

    case 982:
      if (pattern222 (x1) != 0
          || !
#line 2907 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4741; /* mve_vrmlsldavhaxq_p_sv4si */

    case 954:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4742; /* mve_vshllbq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4746; /* mve_vshllbq_m_n_uv8hi */

        default:
          return -1;
        }

    case 955:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4743; /* mve_vshllbq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4747; /* mve_vshllbq_m_n_sv8hi */

        default:
          return -1;
        }

    case 956:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4744; /* mve_vshlltq_m_n_uv16qi */

        case 1:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4748; /* mve_vshlltq_m_n_uv8hi */

        default:
          return -1;
        }

    case 957:
      switch (pattern224 (x1))
        {
        case 0:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4745; /* mve_vshlltq_m_n_sv16qi */

        case 1:
          if (!
#line 2926 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4749; /* mve_vshlltq_m_n_sv8hi */

        default:
          return -1;
        }

    case 970:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4750; /* mve_vmullbq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4752; /* mve_vmullbq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 971:
      switch (pattern225 (x1))
        {
        case 0:
          if (!
#line 2945 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4751; /* mve_vmulltq_poly_m_pv16qi */

        case 1:
          if (!
#line 2945 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4753; /* mve_vmulltq_poly_m_pv8hi */

        default:
          return -1;
        }

    case 972:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4754; /* mve_vqdmullbq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4756; /* mve_vqdmullbq_m_n_sv4si */

        default:
          return -1;
        }

    case 974:
      switch (pattern227 (x1))
        {
        case 0:
          if (!
#line 2964 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4755; /* mve_vqdmulltq_m_n_sv8hi */

        case 1:
          if (!
#line 2964 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4757; /* mve_vqdmulltq_m_n_sv4si */

        default:
          return -1;
        }

    case 973:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4758; /* mve_vqdmullbq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4760; /* mve_vqdmullbq_m_sv4si */

        default:
          return -1;
        }

    case 975:
      switch (pattern228 (x1))
        {
        case 0:
          if (!
#line 2983 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4759; /* mve_vqdmulltq_m_sv8hi */

        case 1:
          if (!
#line 2983 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
            return -1;
          return 4761; /* mve_vqdmulltq_m_sv4si */

        default:
          return -1;
        }

    case 901:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4762; /* mve_vabdq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4770; /* mve_vabdq_m_fv4sf */

        default:
          return -1;
        }

    case 920:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4763; /* mve_vaddq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4771; /* mve_vaddq_m_fv4sf */

        default:
          return -1;
        }

    case 992:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4764; /* mve_vfmaq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4772; /* mve_vfmaq_m_fv4sf */

        default:
          return -1;
        }

    case 995:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4765; /* mve_vfmsq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4773; /* mve_vfmsq_m_fv4sf */

        default:
          return -1;
        }

    case 996:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4766; /* mve_vmaxnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4774; /* mve_vmaxnmq_m_fv4sf */

        default:
          return -1;
        }

    case 997:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4767; /* mve_vminnmq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4775; /* mve_vminnmq_m_fv4sf */

        default:
          return -1;
        }

    case 861:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4768; /* mve_vmulq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4776; /* mve_vmulq_m_fv4sf */

        default:
          return -1;
        }

    case 998:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4769; /* mve_vsubq_m_fv8hf */

        case 1:
          if (!
#line 3008 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4777; /* mve_vsubq_m_fv4sf */

        default:
          return -1;
        }

    case 872:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4778; /* mve_vaddq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4783; /* mve_vaddq_m_n_fv4sf */

        default:
          return -1;
        }

    case 993:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4779; /* mve_vfmaq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4784; /* mve_vfmaq_m_n_fv4sf */

        default:
          return -1;
        }

    case 994:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4780; /* mve_vfmasq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4785; /* mve_vfmasq_m_n_fv4sf */

        default:
          return -1;
        }

    case 853:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4781; /* mve_vmulq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4786; /* mve_vmulq_m_n_fv4sf */

        default:
          return -1;
        }

    case 836:
      switch (pattern230 (x1))
        {
        case 0:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4782; /* mve_vsubq_m_n_fv8hf */

        case 1:
          if (!
#line 3030 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4787; /* mve_vsubq_m_n_fv4sf */

        default:
          return -1;
        }

    case 886:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4788; /* mve_vandq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4793; /* mve_vandq_m_fv4sf */

        default:
          return -1;
        }

    case 837:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4789; /* mve_vbicq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4794; /* mve_vbicq_m_fv4sf */

        default:
          return -1;
        }

    case 903:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4790; /* mve_veorq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4795; /* mve_veorq_m_fv4sf */

        default:
          return -1;
        }

    case 843:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4791; /* mve_vornq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4796; /* mve_vornq_m_fv4sf */

        default:
          return -1;
        }

    case 880:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4792; /* mve_vorrq_m_fv8hf */

        case 1:
          if (!
#line 3052 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4797; /* mve_vorrq_m_fv4sf */

        default:
          return -1;
        }

    case 900:
      return recog_258 (x1, insn, pnum_clobbers);

    case 895:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4800; /* mve_vcaddq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4806; /* mve_vcaddq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 858:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4801; /* mve_vcaddq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4807; /* mve_vcaddq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 988:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4802; /* mve_vcmulq_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4808; /* mve_vcmulq_m_fv4sf */

        default:
          return -1;
        }

    case 991:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4803; /* mve_vcmulq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4809; /* mve_vcmulq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 989:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4804; /* mve_vcmulq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4810; /* mve_vcmulq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 990:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4805; /* mve_vcmulq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3093 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4811; /* mve_vcmulq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 984:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4812; /* mve_vcmlaq_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4816; /* mve_vcmlaq_m_fv4sf */

        default:
          return -1;
        }

    case 987:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4813; /* mve_vcmlaq_rot90_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4817; /* mve_vcmlaq_rot90_m_fv4sf */

        default:
          return -1;
        }

    case 985:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4814; /* mve_vcmlaq_rot180_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4818; /* mve_vcmlaq_rot180_m_fv4sf */

        default:
          return -1;
        }

    case 986:
      switch (pattern229 (x1))
        {
        case 0:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4815; /* mve_vcmlaq_rot270_m_fv8hf */

        case 1:
          if (!
#line 3114 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE && TARGET_HAVE_MVE_FLOAT))
            return -1;
          return 4819; /* mve_vcmlaq_rot270_m_fv4sf */

        default:
          return -1;
        }

    case 1002:
      return recog_247 (x1, insn, pnum_clobbers);

    case 1004:
      return recog_252 (x1, insn, pnum_clobbers);

    case 1010:
      return recog_248 (x1, insn, pnum_clobbers);

    case 1000:
      return recog_251 (x1, insn, pnum_clobbers);

    case 1016:
      return recog_250 (x1, insn, pnum_clobbers);

    case 1026:
      return recog_249 (x1, insn, pnum_clobbers);

    case 1028:
      if (pattern93 (x1) != 0)
        return -1;
      x3 = XVECEXP (x2, 0, 3);
      operands[3] = x3;
      if (!vpr_register_operand (operands[3], E_V8BImode)
          || !
#line 3717 "../../gcc/config/arm/mve.md"
(TARGET_HAVE_MVE))
        return -1;
      return 4937; /* mve_vstrq_truncate_scatter_shifted_offset_p_v4si */

    default:
      return -1;
    }
}

 int
recog_343 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      if (GET_MODE (x5) != E_SImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != AND
          || GET_MODE (x6) != E_SImode
          || GET_MODE (x4) != E_SImode)
        return -1;
      x7 = XEXP (x5, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          if (!s_register_operand (x7, E_SImode)
              || !s_register_operand (operands[0], E_SImode))
            return -1;
          x8 = XEXP (x5, 1);
          if (!const_int_operand (x8, E_VOIDmode))
            return -1;
          x9 = XEXP (x6, 1);
          if (!const_int_operand (x9, E_VOIDmode))
            return -1;
          x10 = XEXP (x6, 0);
          switch (GET_CODE (x10))
            {
            case ASHIFT:
              if (GET_MODE (x10) != E_SImode)
                return -1;
              x11 = XEXP (x1, 0);
              operands[6] = x11;
              x12 = XEXP (x11, 0);
              operands[7] = x12;
              operands[1] = x7;
              operands[2] = x8;
              x13 = XEXP (x10, 0);
              operands[3] = x13;
              if (!s_register_operand (operands[3], E_SImode))
                return -1;
              x14 = XEXP (x10, 1);
              operands[4] = x14;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              operands[5] = x9;
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3539 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[4]) < 32
   && UINTVAL (operands[2]) == ~UINTVAL (operands[5])
   && (exact_log2 (UINTVAL (operands[5])
		   + (HOST_WIDE_INT_1U << UINTVAL (operands[4])))
       >= 0))))
                return -1;
              return 6446; /* *p *bfi */

            case REG:
            case SUBREG:
              if (!s_register_operand (x10, E_SImode))
                return -1;
              x11 = XEXP (x1, 0);
              operands[5] = x11;
              x12 = XEXP (x11, 0);
              operands[6] = x12;
              operands[1] = x7;
              operands[2] = x8;
              operands[3] = x10;
              operands[4] = x9;
              if ((
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3577 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0)))
                return 6448; /* *p *bfi_alt2 */
              operands[3] = x7;
              operands[4] = x8;
              operands[1] = x10;
              operands[2] = x9;
              if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3592 "../../gcc/config/arm/arm.md"
(arm_arch_thumb2
   && UINTVAL (operands[2]) == ~UINTVAL (operands[4])
   && exact_log2 (UINTVAL (operands[4]) + 1) >= 0)))
                return -1;
              return 6449; /* *p *bfi_alt3 */

            default:
              return -1;
            }

        case ASHIFT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x15 = XEXP (x7, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          operands[4] = x15;
          if (const_int_operand (operands[4], E_VOIDmode))
            {
              res = recog_337 (x1, insn, pnum_clobbers);
              if (res >= 0)
                return res;
            }
          if (XWINT (x15, 0) != 8LL
              || pattern558 (x1, 
LSHIFTRT) != 0)
            return -1;
          x8 = XEXP (x5, 1);
          operands[3] = x8;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x9 = XEXP (x6, 1);
          operands[2] = x9;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x10 = XEXP (x6, 0);
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12592 "../../gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode))))
            return -1;
          return 6606; /* *p arm_rev16si2_alt1 */

        case LSHIFTRT:
          if (GET_MODE (x7) != E_SImode)
            return -1;
          x15 = XEXP (x7, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || pattern558 (x1, 
ASHIFT) != 0)
            return -1;
          x8 = XEXP (x5, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x9 = XEXP (x6, 1);
          operands[3] = x9;
          if (!const_int_operand (operands[3], E_SImode))
            return -1;
          x10 = XEXP (x6, 0);
          x13 = XEXP (x10, 0);
          if (!rtx_equal_p (x13, operands[1])
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 12613 "../../gcc/config/arm/arm.md"
(arm_arch6
   && aarch_rev16_shleft_mask_imm_p (operands[3], SImode)
   && aarch_rev16_shright_mask_imm_p (operands[2], SImode))))
            return -1;
          return 6607; /* *p *arm_rev16si2_alt2 */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      switch (pattern378 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 3737 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
            return -1;
          return 6454; /* *p *iorsi3_insn */

        case 1:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 61 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6674; /* *p iwmmxt_iordi3 */

        case 2:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 318 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6684; /* *p *iorv2si3_iwmmxt */

        case 3:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 318 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6685; /* *p *iorv4hi3_iwmmxt */

        case 4:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 318 "../../gcc/config/arm/iwmmxt.md"
(TARGET_REALLY_IWMMXT)))
            return -1;
          return 6686; /* *p *iorv8qi3_iwmmxt */

        default:
          return -1;
        }

    case MULT:
      if (pattern375 (x1) != 0
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9686 "../../gcc/config/arm/arm.md"
(TARGET_32BIT)))
        return -1;
      return 6585; /* *p *orr_multsi */

    case ASHIFT:
    case ROTATE:
    case ASHIFTRT:
    case LSHIFTRT:
    case ROTATERT:
      operands[2] = x5;
      if (pattern407 (x1) == 0
          && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 9700 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && GET_CODE (operands[2]) != MULT)))
        return 6590; /* *p *orr_shiftsi */
      if (GET_CODE (x5) != ASHIFT
          || GET_MODE (x5) != E_DImode)
        return -1;
      x8 = XEXP (x5, 1);
      if (GET_CODE (x8) != MINUS
          || GET_MODE (x8) != E_SImode)
        return -1;
      x16 = XEXP (x8, 0);
      if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
        return -1;
      x17 = XEXP (x8, 1);
      if (GET_CODE (x17) != MULT
          || GET_MODE (x17) != E_SImode)
        return -1;
      x18 = XEXP (x17, 1);
      if (x18 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != LSHIFTRT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != ASHIFT
          || GET_MODE (x10) != E_DImode)
        return -1;
      x14 = XEXP (x10, 1);
      if (GET_CODE (x14) != MULT
          || GET_MODE (x14) != E_SImode)
        return -1;
      x19 = XEXP (x14, 1);
      if (x19 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x9 = XEXP (x6, 1);
      if (GET_CODE (x9) != MULT
          || GET_MODE (x9) != E_SImode)
        return -1;
      x20 = XEXP (x9, 1);
      if (x20 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return -1;
      x11 = XEXP (x1, 0);
      operands[4] = x11;
      x12 = XEXP (x11, 0);
      operands[5] = x12;
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x4) != E_DImode)
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_DImode))
        return -1;
      x21 = XEXP (x17, 0);
      operands[3] = x21;
      if (!immediate_operand (operands[3], E_SImode))
        return -1;
      x13 = XEXP (x10, 0);
      operands[1] = x13;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x22 = XEXP (x14, 0);
      if (!rtx_equal_p (x22, operands[3]))
        return -1;
      x23 = XEXP (x9, 0);
      if (!rtx_equal_p (x23, operands[3])
          || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 858 "../../gcc/config/arm/iwmmxt2.md"
(TARGET_REALLY_IWMMXT)))
        return -1;
      return 6878; /* *p iwmmxt_wmerge */

    case NOT:
      switch (pattern374 (x1))
        {
        case 0:
          if (!(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1534 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
            return -1;
          return 6996; /* *p *orsi_notsi_si */

        case 1:
          x7 = XEXP (x5, 0);
          x24 = XEXP (x7, 0);
          operands[2] = x24;
          if (!s_register_operand (operands[2], E_SImode))
            return -1;
          x15 = XEXP (x7, 1);
          operands[3] = x15;
          if (!const_int_operand (operands[3], E_SImode)
              || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1546 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2)))
            return -1;
          return 6997; /* *p *orsi_not_shiftsi_si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_351 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[4] = x2;
  x3 = XEXP (x2, 0);
  operands[5] = x3;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 1);
  operands[2] = x7;
  x8 = XEXP (x6, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      operands[1] = x8;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern559 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1365 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6935; /* *p fmasf4 */

            case E_DFmode:
              if (pattern559 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1365 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6936; /* *p fmadf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern560 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1423 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6939; /* *p *fnmsubsf4 */

            case E_DFmode:
              if (pattern560 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1423 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6940; /* *p *fnmsubdf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NEG:
      x11 = XEXP (x8, 0);
      operands[1] = x11;
      x9 = XEXP (x6, 2);
      switch (GET_CODE (x9))
        {
        case REG:
        case SUBREG:
          operands[3] = x9;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern561 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1401 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6937; /* *p *fmsubsf4 */

            case E_DFmode:
              if (pattern561 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1401 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6938; /* *p *fmsubdf4 */

            default:
              return -1;
            }

        case NEG:
          x10 = XEXP (x9, 0);
          operands[3] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_SFmode:
              if (pattern562 (x6, 
E_SFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1446 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA )))
                return -1;
              return 6941; /* *p *fnmaddsf4 */

            case E_DFmode:
              if (pattern562 (x6, 
E_DFmode) != 0
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && (
#line 1446 "../../gcc/config/arm/vfp.md"
(TARGET_32BIT && TARGET_HARD_FLOAT && TARGET_FMA && TARGET_VFP_DOUBLE) && 
#line 60 "../../gcc/config/arm/iterators.md"
(TARGET_VFP_DOUBLE))))
                return -1;
              return 6942; /* *p *fnmadddf4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_362 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) == PLUS
      && GET_MODE (x4) == E_SImode)
    {
      res = recog_361 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  x5 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x5) != CLOBBER)
    return -1;
  x6 = XEXP (x1, 0);
  operands[5] = x6;
  x7 = XEXP (x6, 0);
  operands[6] = x7;
  operands[1] = x4;
  if (shiftable_operator (operands[1], E_SImode))
    {
      x8 = XEXP (x4, 0);
      operands[2] = x8;
      if (memory_operand (operands[2], E_SImode))
        {
          x9 = XEXP (x4, 1);
          operands[3] = x9;
          if (memory_operand (operands[3], E_SImode))
            {
              x10 = XEXP (x5, 0);
              operands[4] = x10;
              if (scratch_operand (operands[4], E_SImode)
                  && (
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 11472 "../../gcc/config/arm/arm.md"
(TARGET_ARM && adjacent_mem_locations (operands[2], operands[3]))))
                return 6594; /* *p *arith_adjacentmem */
            }
        }
    }
  x10 = XEXP (x5, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 100
      || GET_MODE (x10) != E_CCmode)
    return -1;
  operands[4] = x6;
  operands[5] = x7;
  operands[3] = x4;
  if (!thumb_16bit_operator (operands[3], E_SImode))
    return -1;
  x8 = XEXP (x4, 0);
  operands[1] = x8;
  if (!s_register_operand (operands[1], E_SImode))
    return -1;
  x9 = XEXP (x4, 1);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode)
      || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 1256 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2 && reload_completed
   && GET_CODE(operands[3]) != PLUS
   && GET_CODE(operands[3]) != MINUS)))
    return -1;
  return 6986; /* *p *thumb2_alusi3_short */
}

 int
recog_372 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != SET)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PLUS
      || GET_MODE (x4) != E_SImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != CONST_INT)
    return -1;
  x6 = XVECEXP (x2, 0, 1);
  if (GET_CODE (x6) != SET)
    return -1;
  x7 = XVECEXP (x2, 0, 2);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XVECEXP (x2, 0, 3);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XVECEXP (x2, 0, 4);
  if (GET_CODE (x9) != SET)
    return -1;
  x10 = XEXP (x1, 0);
  operands[6] = x10;
  x11 = XEXP (x10, 0);
  operands[7] = x11;
  x12 = XEXP (x3, 0);
  operands[5] = x12;
  if (!s_register_operand (operands[5], E_SImode))
    return -1;
  x13 = XEXP (x4, 0);
  if (!rtx_equal_p (x13, operands[5]))
    return -1;
  switch (XWINT (x5, 0))
    {
    case 16LL:
      switch (pattern597 (x6))
        {
        case 0:
          if (pattern619 (x2) != 0)
            return -1;
          x14 = XEXP (x9, 1);
          x15 = XEXP (x14, 0);
          if (GET_CODE (x15) != PLUS
              || GET_MODE (x15) != E_SImode)
            return -1;
          x16 = XEXP (x15, 1);
          if (GET_CODE (x16) != CONST_INT
              || pattern642 (operands[0]) != 0)
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[5]))
            return -1;
          x20 = XEXP (x8, 1);
          x21 = XEXP (x20, 0);
          x22 = XEXP (x21, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x23 = XEXP (x15, 0);
          if (!rtx_equal_p (x23, operands[5]))
            return -1;
          switch (pattern647 (x2))
            {
            case 0:
              x24 = XEXP (x6, 1);
              x25 = XEXP (x24, 0);
              if (!rtx_equal_p (x25, operands[5]))
                return -1;
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != 4LL)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != 8LL
                  || XWINT (x16, 0) != 12LL
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 74 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6623; /* *p *ldm4_ia_update */

            case 1:
              if (XWINT (x16, 0) != 16LL)
                return -1;
              x24 = XEXP (x6, 1);
              x25 = XEXP (x24, 0);
              x28 = XEXP (x25, 0);
              if (!rtx_equal_p (x28, operands[5])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 181 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6627; /* *p *ldm4_ib_update */

            default:
              return -1;
            }

        case 1:
          if (pattern621 (x2) != 0)
            return -1;
          x29 = XEXP (x9, 0);
          x30 = XEXP (x29, 0);
          if (GET_CODE (x30) != PLUS
              || GET_MODE (x30) != E_SImode)
            return -1;
          x31 = XEXP (x30, 1);
          if (GET_CODE (x31) != CONST_INT
              || pattern648 (operands[0]) != 0)
            return -1;
          x32 = XEXP (x7, 0);
          x33 = XEXP (x32, 0);
          x34 = XEXP (x33, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x8, 0);
          x36 = XEXP (x35, 0);
          x37 = XEXP (x36, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x38 = XEXP (x30, 0);
          if (!rtx_equal_p (x38, operands[5]))
            return -1;
          switch (pattern649 (x2))
            {
            case 0:
              x39 = XEXP (x6, 0);
              x40 = XEXP (x39, 0);
              if (!rtx_equal_p (x40, operands[5]))
                return -1;
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != 4LL)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != 8LL
                  || XWINT (x31, 0) != 12LL
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 125 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6625; /* *p *stm4_ia_update */

            case 1:
              if (XWINT (x31, 0) != 16LL)
                return -1;
              x39 = XEXP (x6, 0);
              x40 = XEXP (x39, 0);
              x43 = XEXP (x40, 0);
              if (!rtx_equal_p (x43, operands[5])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 213 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6629; /* *p *stm4_ib_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case -16LL:
      x24 = XEXP (x6, 1);
      switch (GET_CODE (x24))
        {
        case MEM:
          if (pattern546 (x24) != 0
              || pattern619 (x2) != 0
              || pattern642 (operands[0]) != 0)
            return -1;
          x25 = XEXP (x24, 0);
          x28 = XEXP (x25, 0);
          if (!rtx_equal_p (x28, operands[5]))
            return -1;
          x17 = XEXP (x7, 1);
          x18 = XEXP (x17, 0);
          x19 = XEXP (x18, 0);
          if (!rtx_equal_p (x19, operands[5]))
            return -1;
          x20 = XEXP (x8, 1);
          x21 = XEXP (x20, 0);
          x22 = XEXP (x21, 0);
          if (!rtx_equal_p (x22, operands[5]))
            return -1;
          x44 = XEXP (x25, 1);
          switch (XWINT (x44, 0))
            {
            case -12LL:
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != -8LL)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != -4LL)
                return -1;
              x14 = XEXP (x9, 1);
              x15 = XEXP (x14, 0);
              if (!rtx_equal_p (x15, operands[5])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 251 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6631; /* *p *ldm4_da_update */

            case -16LL:
              x26 = XEXP (x18, 1);
              if (XWINT (x26, 0) != -12LL)
                return -1;
              x27 = XEXP (x21, 1);
              if (XWINT (x27, 0) != -8LL)
                return -1;
              x14 = XEXP (x9, 1);
              x15 = XEXP (x14, 0);
              if (GET_CODE (x15) != PLUS
                  || GET_MODE (x15) != E_SImode)
                return -1;
              x16 = XEXP (x15, 1);
              if (x16 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x23 = XEXP (x15, 0);
              if (!rtx_equal_p (x23, operands[5])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 323 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6635; /* *p *ldm4_db_update */

            default:
              return -1;
            }

        case REG:
          operands[1] = x24;
          if (!arm_hard_general_register_operand (operands[1], E_SImode))
            return -1;
          x39 = XEXP (x6, 0);
          if (pattern573 (x39) != 0
              || pattern621 (x2) != 0
              || pattern648 (operands[0]) != 0)
            return -1;
          x40 = XEXP (x39, 0);
          x43 = XEXP (x40, 0);
          if (!rtx_equal_p (x43, operands[5]))
            return -1;
          x32 = XEXP (x7, 0);
          x33 = XEXP (x32, 0);
          x34 = XEXP (x33, 0);
          if (!rtx_equal_p (x34, operands[5]))
            return -1;
          x35 = XEXP (x8, 0);
          x36 = XEXP (x35, 0);
          x37 = XEXP (x36, 0);
          if (!rtx_equal_p (x37, operands[5]))
            return -1;
          x45 = XEXP (x40, 1);
          switch (XWINT (x45, 0))
            {
            case -12LL:
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != -8LL)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != -4LL)
                return -1;
              x29 = XEXP (x9, 0);
              x30 = XEXP (x29, 0);
              if (!rtx_equal_p (x30, operands[5])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 283 "../../gcc/config/arm/ldmstm.md"
(TARGET_ARM && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6633; /* *p *stm4_da_update */

            case -16LL:
              x41 = XEXP (x33, 1);
              if (XWINT (x41, 0) != -12LL)
                return -1;
              x42 = XEXP (x36, 1);
              if (XWINT (x42, 0) != -8LL)
                return -1;
              x29 = XEXP (x9, 0);
              x30 = XEXP (x29, 0);
              if (GET_CODE (x30) != PLUS
                  || GET_MODE (x30) != E_SImode)
                return -1;
              x31 = XEXP (x30, 1);
              if (x31 != const_int_rtx[MAX_SAVED_CONST_INT + -4])
                return -1;
              x38 = XEXP (x30, 0);
              if (!rtx_equal_p (x38, operands[5])
                  || !(
#line 12240 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (!TARGET_NO_VOLATILE_CE || !volatile_refs_p (PATTERN (insn)))) && 
#line 355 "../../gcc/config/arm/ldmstm.md"
(TARGET_32BIT && XVECLEN (operands[0], 0) == 5)))
                return -1;
              return 6637; /* *p *stm4_db_update */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 1);
  if (!minmax_operator (x4, E_SImode))
    return NULL;
  operands[4] = x4;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 100
      || GET_MODE (x6) != E_CCmode)
    return NULL;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x4, 0);
  operands[2] = x8;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x9 = XEXP (x4, 1);
  operands[3] = x9;
  if (!arm_rhs_operand (operands[3], E_SImode)
      || !
#line 4304 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && !arm_eliminable_register (operands[1]) && reload_completed))
    return NULL;
  return gen_split_26 (insn, operands);
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_SImode)
    return NULL;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFT
      || GET_MODE (x4) != E_SImode)
    return NULL;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
    return NULL;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  if (!const_int_operand (operands[1], E_SImode))
    return NULL;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!s_register_operand (operands[3], E_SImode)
      || !
#line 1895 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
    return NULL;
  return gen_split_2 (insn, operands);
}

 rtx_insn *
split_5 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case IOR:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case AND:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x4, 0);
          if (GET_CODE (x5) != NOT
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != NOT
              || GET_MODE (x6) != E_SImode)
            return NULL;
          x7 = XEXP (x5, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x6, 0);
          operands[2] = x8;
          if (!arm_rhs_operand (operands[2], E_SImode))
            return NULL;
          x9 = XEXP (x3, 1);
          operands[3] = x9;
          if (!arm_rhs_operand (operands[3], E_SImode))
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[4] = x11;
          if (!s_register_operand (operands[4], E_SImode)
              || !
#line 3898 "../../gcc/config/arm/arm.md"
(TARGET_32BIT))
            return NULL;
          return gen_split_16 (insn, operands);

        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x4;
          if (pattern526 (x1) != 0
              || !
#line 10498 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return NULL;
          return gen_split_87 (insn, operands);

        default:
          return NULL;
        }

    case AND:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
        case GEU:
        case GTU:
        case LEU:
        case LTU:
        case UNORDERED:
        case ORDERED:
        case UNGE:
        case UNGT:
        case UNLE:
        case UNLT:
          operands[3] = x4;
          if (pattern526 (x1) == 0)
            {
              if (
#line 10560 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed
   && (arm_select_dominance_cc_mode (operands[3], operands[6], DOM_CC_X_AND_Y)
       != CCmode)))
                return gen_split_89 (insn, operands);
              if (
#line 10628 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
                return gen_split_91 (insn, operands);
            }
          if (GET_CODE (x4) != GE
              || GET_MODE (x4) != E_SImode)
            return NULL;
          x6 = XEXP (x4, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x9 = XEXP (x3, 1);
          if (GET_CODE (x9) != NEG
              || GET_MODE (x9) != E_SImode)
            return NULL;
          x12 = XEXP (x9, 0);
          if (!arm_comparison_operator (x12, E_SImode))
            return NULL;
          operands[2] = x12;
          x5 = XEXP (x4, 0);
          operands[1] = x5;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x13 = XEXP (x12, 0);
          operands[3] = x13;
          if (!s_register_operand (operands[3], E_SImode))
            return NULL;
          x14 = XEXP (x12, 1);
          operands[4] = x14;
          if (!arm_rhs_operand (operands[4], E_SImode))
            return NULL;
          x10 = XVECEXP (x1, 0, 1);
          x11 = XEXP (x10, 0);
          operands[5] = x11;
          if (!s_register_operand (operands[5], E_SImode)
              || !
#line 11591 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return NULL;
          return gen_split_98 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case NE:
      x4 = XEXP (x3, 0);
      switch (GET_CODE (x4))
        {
        case ZERO_EXTRACT:
          if (GET_MODE (x4) != E_SImode)
            return NULL;
          x5 = XEXP (x4, 2);
          if (GET_CODE (x5) != CONST_INT)
            return NULL;
          operands[3] = x5;
          if (const_int_operand (operands[3], E_SImode))
            {
              x6 = XEXP (x3, 1);
              if (x6 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
                {
                  x7 = XEXP (x4, 0);
                  operands[1] = x7;
                  if (s_register_operand (operands[1], E_SImode))
                    {
                      x8 = XEXP (x4, 1);
                      operands[2] = x8;
                      if (const_int_operand (operands[2], E_SImode)
                          && 
#line 3122 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && (INTVAL (operands[3]) >= 0 && INTVAL (operands[3]) < 32
       && INTVAL (operands[2]) > 0 
       && INTVAL (operands[2]) + (INTVAL (operands[3]) & 1) <= 8
       && INTVAL (operands[2]) + INTVAL (operands[3]) <= 32)))
                        return gen_split_7 (insn, operands);
                    }
                }
            }
          if (XWINT (x5, 0) != 0LL)
            return NULL;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 3156 "../../gcc/config/arm/arm.md"
(TARGET_ARM))
            return NULL;
          return gen_split_8 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x4;
          if (!s_register_operand (operands[1], E_SImode))
            return NULL;
          x6 = XEXP (x3, 1);
          operands[2] = x6;
          if (const_int_operand (operands[2], E_SImode)
              && 
#line 9921 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return gen_split_84 (insn, operands);
          if (!arm_add_operand (operands[2], E_SImode)
              || !
#line 9937 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
            return NULL;
          return gen_split_85 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 9880 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_80 (insn, operands);

    case GE:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode)
          || !
#line 9888 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_81 (insn, operands);

    case EQ:
      x6 = XEXP (x3, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      if (!s_register_operand (operands[1], E_SImode))
        return NULL;
      if (
#line 9897 "../../gcc/config/arm/arm.md"
(arm_arch5t && TARGET_32BIT))
        return gen_split_82 (insn, operands);
      if (!
#line 9907 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && reload_completed))
        return NULL;
      return gen_split_83 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_5 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XVECEXP (x3, 0, 0);
  if (GET_CODE (x4) != SET)
    return NULL;
  x5 = XVECEXP (x3, 0, 1);
  if (GET_CODE (x5) != SET)
    return NULL;
  x6 = XVECEXP (x3, 0, 2);
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x4, 0);
  operands[1] = x7;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x8 = XEXP (x4, 1);
  operands[5] = x8;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x9 = XEXP (x5, 0);
  operands[2] = x9;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x10 = XEXP (x5, 1);
  operands[6] = x10;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x11 = XEXP (x6, 0);
  operands[3] = x11;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  x12 = XEXP (x6, 1);
  operands[7] = x12;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_20 (insn, operands);
}

 rtx_insn *
peephole2_8 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (!memory_operand (x2, E_SImode))
    return NULL;
  operands[2] = x2;
  if (arm_general_register_operand (operands[0], E_SImode))
    {
      res = peephole2_7 (x1, insn, pmatch_len_);
      if (res != NULL_RTX)
        return res;
    }
  if (peep2_current_count < 4)
    return NULL;
  operands[4] = x2;
  if (!s_register_operand (operands[0], E_SImode))
    return NULL;
  x3 = PATTERN (peep2_next_insn (1));
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!s_register_operand (operands[1], E_SImode))
    return NULL;
  x5 = XEXP (x3, 1);
  operands[5] = x5;
  if (!memory_operand (operands[5], E_SImode))
    return NULL;
  x6 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x6) != SET)
    return NULL;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!s_register_operand (operands[2], E_SImode))
    return NULL;
  x8 = XEXP (x6, 1);
  operands[6] = x8;
  if (!memory_operand (operands[6], E_SImode))
    return NULL;
  x9 = PATTERN (peep2_next_insn (3));
  if (GET_CODE (x9) != SET)
    return NULL;
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!s_register_operand (operands[3], E_SImode))
    return NULL;
  x11 = XEXP (x9, 1);
  operands[7] = x11;
  if (!memory_operand (operands[7], E_SImode))
    return NULL;
  *pmatch_len_ = 3;
  return gen_peephole2_19 (insn, operands);
}

 rtx_insn *
peephole2_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  operands[4] = x2;
  x3 = PATTERN (peep2_next_insn (1));
  switch (pattern494 (x3))
    {
    case 0:
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (2));
      x5 = XEXP (x4, 1);
      operands[5] = x5;
      if (!const_int_operand (operands[5], E_SImode))
        return NULL;
      x6 = PATTERN (peep2_next_insn (3));
      x7 = XEXP (x6, 1);
      if (!rtx_equal_p (x7, operands[1])
          || !
#line 67 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_15 (insn, operands);

    case 1:
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x4 = PATTERN (peep2_next_insn (2));
      x9 = XEXP (x4, 0);
      operands[2] = x9;
      if (!memory_operand (operands[2], E_SImode))
        return NULL;
      x5 = XEXP (x4, 1);
      if (!rtx_equal_p (x5, operands[0]))
        return NULL;
      x6 = PATTERN (peep2_next_insn (3));
      x7 = XEXP (x6, 1);
      if (!rtx_equal_p (x7, operands[1])
          || !
#line 86 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
        return NULL;
      *pmatch_len_ = 3;
      return gen_peephole2_16 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_insns (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  if (GET_CODE (x1) != SET)
    return NULL;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case PLUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != CONST_INT)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (arm_general_register_operand (operands[0], E_SImode))
        {
          x5 = XEXP (x2, 0);
          operands[1] = x5;
          if (arm_general_register_operand (operands[1], E_SImode))
            {
              operands[2] = x3;
              if (const_int_operand (operands[2], E_SImode)
                  && 
#line 928 "../../gcc/config/arm/arm.md"
(TARGET_32BIT &&
   !(const_ok_for_arm (INTVAL (operands[2]))
     || const_ok_for_arm (-INTVAL (operands[2])))
    && const_ok_for_arm (~INTVAL (operands[2]))))
                {
                  *pmatch_len_ = 0;
                  res = gen_peephole2_1 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
        }
      if (peep2_current_count < 2
          || peep2_current_count < 3)
        return NULL;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (register_operand (operands[2], E_SImode)
          && register_operand (operands[0], E_SImode))
        {
          res = peephole2_1 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (!cc_register (operands[2], E_VOIDmode)
          || XWINT (x3, 0) != -1LL
          || !arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != COMPARE)
        return NULL;
      x9 = XEXP (x8, 1);
      if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + -1])
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x11 = PATTERN (peep2_next_insn (2));
      if (GET_CODE (x11) != SET)
        return NULL;
      x12 = XEXP (x11, 1);
      if (GET_CODE (x12) != IF_THEN_ELSE)
        return NULL;
      x13 = XEXP (x12, 0);
      if (!equality_operator (x13, E_VOIDmode))
        return NULL;
      operands[3] = x13;
      x14 = XEXP (x13, 1);
      if (x14 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return NULL;
      x15 = XEXP (x11, 0);
      if (GET_CODE (x15) != PC)
        return NULL;
      x16 = XEXP (x12, 1);
      operands[4] = x16;
      x17 = XEXP (x12, 2);
      operands[5] = x17;
      x18 = XEXP (x13, 0);
      if (!rtx_equal_p (x18, operands[2])
          || !
#line 1216 "../../gcc/config/arm/arm.md"
(TARGET_32BIT && peep2_reg_dead_p (3, operands[2])))
        return NULL;
      *pmatch_len_ = 2;
      return gen_peephole2_4 (insn, operands);

    case COMPARE:
      x5 = XEXP (x2, 0);
      switch (GET_CODE (x5))
        {
        case PLUS:
          if (GET_MODE (x5) != E_DImode)
            return NULL;
          x19 = XEXP (x5, 0);
          if (GET_CODE (x19) != SIGN_EXTEND
              || GET_MODE (x19) != E_DImode)
            return NULL;
          x3 = XEXP (x2, 1);
          if (pattern321 (x3, 
E_SImode, 
PLUS, 
E_DImode, 
SIGN_EXTEND) != 0
              || pattern26 (x1, 
E_CC_Vmode) != 0)
            return NULL;
          x20 = XEXP (x19, 0);
          operands[0] = x20;
          if (!low_register_operand (operands[0], E_SImode))
            return NULL;
          x21 = XEXP (x5, 1);
          operands[1] = x21;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return NULL;
          x22 = XEXP (x3, 0);
          x23 = XEXP (x22, 0);
          if (!rtx_equal_p (x23, operands[0]))
            return NULL;
          x24 = XEXP (x22, 1);
          if (!rtx_equal_p (x24, operands[1]))
            return NULL;
          if (
#line 1088 "../../gcc/config/arm/arm.md"
(TARGET_THUMB2
   && satisfies_constraint_Pd (operands[1])))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_2 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 1107 "../../gcc/config/arm/arm.md"
(TARGET_THUMB2
   && dead_or_set_p (peep2_next_insn (0), operands[0])
   && satisfies_constraint_Py (operands[1])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_3 (insn, operands);

        case REG:
        case SUBREG:
          if (peep2_current_count >= 2)
            {
              res = peephole2_2 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[1] = x5;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          if (peep2_current_count >= 2)
            {
              res = peephole2_3 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[0] = x4;
          if (!cc_register (operands[0], E_CCmode)
              || GET_MODE (x2) != E_CCmode
              || !low_register_operand (operands[1], E_SImode))
            return NULL;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!const_int_operand (operands[2], E_SImode))
            return NULL;
          if (
#line 1341 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && peep2_reg_dead_p (1, operands[1])
   && satisfies_constraint_Pw (operands[2])))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_41 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!
#line 1355 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && satisfies_constraint_Px (operands[2])))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_42 (insn, operands);

        case ZERO_EXTRACT:
          if (peep2_current_count < 2
              || GET_MODE (x5) != E_SImode)
            return NULL;
          x21 = XEXP (x5, 1);
          if (GET_CODE (x21) != CONST_INT)
            return NULL;
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          if (!cc_register (operands[0], E_CC_NZmode)
              || GET_MODE (x2) != E_CC_NZmode)
            return NULL;
          x19 = XEXP (x5, 0);
          operands[1] = x19;
          if (!low_register_operand (operands[1], E_SImode))
            return NULL;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          x8 = XEXP (x6, 1);
          if (GET_CODE (x8) != IF_THEN_ELSE)
            return NULL;
          x10 = XEXP (x8, 0);
          if (!equality_operator (x10, E_CC_NZmode))
            return NULL;
          operands[4] = x10;
          x25 = XEXP (x10, 1);
          if (x25 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != PC)
            return NULL;
          x9 = XEXP (x8, 1);
          operands[5] = x9;
          x26 = XEXP (x8, 2);
          operands[6] = x26;
          x27 = XEXP (x10, 0);
          if (!rtx_equal_p (x27, operands[0]))
            return NULL;
          if (XWINT (x21, 0) == 1LL)
            {
              x28 = XEXP (x5, 2);
              operands[2] = x28;
              if (const_int_operand (operands[2], E_SImode)
                  && 
#line 1566 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && (INTVAL (operands[2]) >= 0 && INTVAL (operands[2]) < 32)
   && peep2_reg_dead_p (2, operands[0])))
                {
                  *pmatch_len_ = 1;
                  res = gen_peephole2_43 (insn, operands);
                  if (res != NULL_RTX)
                    return res;
                }
            }
          x28 = XEXP (x5, 2);
          if (x28 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          operands[2] = x21;
          if (!const_int_operand (operands[2], E_SImode)
              || !
#line 1595 "../../gcc/config/arm/thumb2.md"
(TARGET_THUMB2
   && (INTVAL (operands[2]) > 0 && INTVAL (operands[2]) < 32)
   && peep2_reg_dead_p (2, operands[0])))
            return NULL;
          *pmatch_len_ = 1;
          return gen_peephole2_44 (insn, operands);

        default:
          return NULL;
        }

    case MINUS:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!const_int_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!arm_general_register_operand (operands[2], E_SImode)
          || !
#line 2051 "../../gcc/config/arm/arm.md"
(TARGET_32BIT
   && !const_ok_for_arm (INTVAL (operands[1]))
   && const_ok_for_arm (~INTVAL (operands[1]))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_5 (insn, operands);

    case IOR:
      if (GET_MODE (x2) != E_SImode)
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!arm_general_register_operand (operands[0], E_SImode))
        return NULL;
      x5 = XEXP (x2, 0);
      operands[1] = x5;
      if (!arm_general_register_operand (operands[1], E_SImode))
        return NULL;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!const_int_operand (operands[2], E_SImode)
          || !
#line 3766 "../../gcc/config/arm/arm.md"
(TARGET_ARM
   && !const_ok_for_arm (INTVAL (operands[2]))
   && const_ok_for_arm (~INTVAL (operands[2]))))
        return NULL;
      *pmatch_len_ = 0;
      return gen_peephole2_6 (insn, operands);

    case UNSPEC:
      if (peep2_current_count < 2
          || XVECLEN (x2, 0) != 3
          || XINT (x2, 1) != 2
          || GET_MODE (x2) != E_SImode)
        return NULL;
      x29 = XVECEXP (x2, 0, 1);
      if (x29 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode))
        return NULL;
      x30 = XVECEXP (x2, 0, 0);
      operands[3] = x30;
      if (!register_operand (operands[3], E_SImode))
        return NULL;
      x31 = XVECEXP (x2, 0, 2);
      operands[1] = x31;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != MEM
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x7 = XEXP (x6, 0);
      operands[2] = x7;
      if (!arm_general_register_operand (operands[2], E_SImode))
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0])
          || !
#line 6793 "../../gcc/config/arm/arm.md"
(TARGET_ARM && peep2_reg_dead_p (2, operands[0])))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_7 (insn, operands);

    case REG:
    case SUBREG:
    case MEM:
      x4 = XEXP (x1, 0);
      switch (GET_MODE (x4))
        {
        case E_SImode:
          if (peep2_current_count < 2)
            return NULL;
          operands[0] = x4;
          res = peephole2_6 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
          x6 = PATTERN (peep2_next_insn (1));
          if (GET_CODE (x6) != SET)
            return NULL;
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              operands[0] = x2;
              if (arm_general_register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  if (memory_operand (operands[3], E_SImode))
                    {
                      x8 = XEXP (x6, 1);
                      operands[1] = x8;
                      if (arm_general_register_operand (operands[1], E_SImode)
                          && 
#line 49 "../../gcc/config/arm/ldrdstrd.md"
(TARGET_LDRD))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_14 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (peep2_current_count >= 3)
            {
              res = peephole2_10 (x1, insn, pmatch_len_);
              if (res != NULL_RTX)
                return res;
            }
          operands[0] = x4;
          if (pattern322 (x2) == 0)
            {
              *pmatch_len_ = 1;
              res = gen_peephole2_29 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          operands[2] = x4;
          if (memory_operand (operands[2], E_SImode))
            {
              operands[0] = x2;
              if (s_register_operand (operands[0], E_SImode))
                {
                  x7 = XEXP (x6, 0);
                  operands[3] = x7;
                  if (memory_operand (operands[3], E_SImode))
                    {
                      x8 = XEXP (x6, 1);
                      operands[1] = x8;
                      if (s_register_operand (operands[1], E_SImode))
                        {
                          *pmatch_len_ = 1;
                          res = gen_peephole2_32 (insn, operands);
                          if (res != NULL_RTX)
                            return res;
                        }
                    }
                }
            }
          if (peep2_current_count < 3)
            return NULL;
          operands[0] = x4;
          if (pattern322 (x2) != 0)
            return NULL;
          x11 = PATTERN (peep2_next_insn (2));
          switch (GET_CODE (x11))
            {
            case PARALLEL:
              if (pattern566 (x11) != 0
                  || !s_register_operand (operands[4], E_SImode))
                return NULL;
              x32 = XVECEXP (x11, 0, 0);
              x33 = XEXP (x32, 1);
              x34 = XEXP (x33, 0);
              operands[6] = x34;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x35 = XEXP (x33, 1);
              operands[7] = x35;
              if (!s_register_operand (operands[7], E_SImode)
                  || !
#line 1163 "../../gcc/config/arm/ldmstm.md"
(((((REGNO (operands[6]) == REGNO (operands[0]))
         && (REGNO (operands[7]) == REGNO (operands[1])))
      || ((REGNO (operands[7]) == REGNO (operands[0]))
         && (REGNO (operands[6]) == REGNO (operands[1]))))
    && (peep2_regno_dead_p (3, REGNO (operands[0]))
      || (REGNO (operands[0]) == REGNO (operands[4])))
    && (peep2_regno_dead_p (3, REGNO (operands[1]))
      || (REGNO (operands[1]) == REGNO (operands[4]))))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_33 (insn, operands);

            case SET:
              x12 = XEXP (x11, 1);
              if (!commutative_binary_operator (x12, E_SImode))
                return NULL;
              operands[5] = x12;
              x15 = XEXP (x11, 0);
              operands[4] = x15;
              if (!s_register_operand (operands[4], E_SImode))
                return NULL;
              x13 = XEXP (x12, 0);
              operands[6] = x13;
              if (!s_register_operand (operands[6], E_SImode))
                return NULL;
              x16 = XEXP (x12, 1);
              operands[7] = x16;
              if (!s_register_operand (operands[7], E_SImode)
                  || !
#line 1188 "../../gcc/config/arm/ldmstm.md"
(((((REGNO (operands[6]) == REGNO (operands[0]))
         && (REGNO (operands[7]) == REGNO (operands[1])))
      || ((REGNO (operands[7]) == REGNO (operands[0]))
         && (REGNO (operands[6]) == REGNO (operands[1]))))
    && (peep2_regno_dead_p (3, REGNO (operands[0]))
      || (REGNO (operands[0]) == REGNO (operands[4])))
    && (peep2_regno_dead_p (3, REGNO (operands[1]))
      || (REGNO (operands[1]) == REGNO (operands[4]))))))
                return NULL;
              *pmatch_len_ = 2;
              return gen_peephole2_34 (insn, operands);

            default:
              return NULL;
            }

        case E_DImode:
          operands[0] = x4;
          operands[1] = x2;
          if (memory_operand (operands[1], E_DImode)
              && low_register_operand (operands[0], E_DImode)
              && 
#line 663 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[1], 0), SImode)
   && !reg_overlap_mentioned_p (XEXP (operands[1], 0), operands[0])
   && peep2_reg_dead_p (1, XEXP (operands[1], 0))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_37 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!low_register_operand (operands[1], E_DImode)
              || !memory_operand (operands[0], E_DImode)
              || !
#line 679 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[0], 0), SImode)
   && peep2_reg_dead_p (1, XEXP (operands[0], 0))
   /* The low register in the transfer list may overlap the address,
      but the second cannot.  */
   && REGNO (XEXP (operands[0], 0)) != (REGNO (operands[1]) + 1)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_39 (insn, operands);

        case E_DFmode:
          operands[0] = x4;
          operands[1] = x2;
          if (memory_operand (operands[1], E_DFmode)
              && low_register_operand (operands[0], E_DFmode)
              && 
#line 663 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[1], 0), SImode)
   && !reg_overlap_mentioned_p (XEXP (operands[1], 0), operands[0])
   && peep2_reg_dead_p (1, XEXP (operands[1], 0))))
            {
              *pmatch_len_ = 0;
              res = gen_peephole2_38 (insn, operands);
              if (res != NULL_RTX)
                return res;
            }
          if (!low_register_operand (operands[1], E_DFmode)
              || !memory_operand (operands[0], E_DFmode)
              || !
#line 679 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && low_register_operand (XEXP (operands[0], 0), SImode)
   && peep2_reg_dead_p (1, XEXP (operands[0], 0))
   /* The low register in the transfer list may overlap the address,
      but the second cannot.  */
   && REGNO (XEXP (operands[0], 0)) != (REGNO (operands[1]) + 1)))
            return NULL;
          *pmatch_len_ = 0;
          return gen_peephole2_40 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
      if (peep2_current_count < 2
          || !const_int_operand (x2, E_SImode))
        return NULL;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (peep2_current_count >= 3)
        {
          res = peephole2_14 (x1, insn, pmatch_len_);
          if (res != NULL_RTX)
            return res;
        }
      if (!low_register_operand (operands[0], E_SImode))
        return NULL;
      operands[1] = x2;
      x6 = PATTERN (peep2_next_insn (1));
      if (GET_CODE (x6) != SET)
        return NULL;
      x8 = XEXP (x6, 1);
      if (GET_CODE (x8) != PLUS
          || GET_MODE (x8) != E_SImode)
        return NULL;
      x9 = XEXP (x8, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 13
          || GET_MODE (x9) != E_SImode)
        return NULL;
      x10 = XEXP (x8, 0);
      if (!rtx_equal_p (x10, operands[0]))
        return NULL;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[0])
          || !
#line 120 "../../gcc/config/arm/thumb1.md"
(TARGET_THUMB1
   && UINTVAL (operands[1]) < 1024
   && (UINTVAL (operands[1]) & 3) == 0))
        return NULL;
      *pmatch_len_ = 1;
      return gen_peephole2_35 (insn, operands);

    default:
      return NULL;
    }
}
